// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ArrayDataResultSet.java

package oracle.jdbc.driver;

import java.io.*;
import java.math.BigDecimal;
import java.sql.*;
import java.util.Calendar;
import java.util.Map;
import oracle.jdbc.dbaccess.DBConversion;
import oracle.jdbc.dbaccess.DBError;
import oracle.sql.*;

// Referenced classes of package oracle.jdbc.driver:
//            BaseResultSet, OracleConnection

public class ArrayDataResultSet extends BaseResultSet
{

    public ArrayDataResultSet(OracleConnection oracleconnection, Datum adatum[], Map map)
        throws SQLException
    {
        m_conn = oracleconnection;
        m_data = adatum;
        m_map = map;
        m_idx = 0;
        m_lastIdx = m_data != null ? m_data.length : 0;
        m_fetchSz = OracleConnection.DEFAULT_ROW_PREFETCH;
    }

    public ArrayDataResultSet(OracleConnection oracleconnection, Datum adatum[], long l, int i, Map map)
        throws SQLException
    {
        m_conn = oracleconnection;
        m_data = adatum;
        m_map = map;
        m_idx = (int)l - 1;
        int j = m_data != null ? m_data.length : 0;
        m_lastIdx = m_idx + Math.min(j - m_idx, i);
        m_fetchSz = OracleConnection.DEFAULT_ROW_PREFETCH;
    }

    public ArrayDataResultSet(OracleConnection oracleconnection, ARRAY array, long l, int i, Map map)
        throws SQLException
    {
        m_conn = oracleconnection;
        m_array = array;
        m_map = map;
        m_idx = (int)l - 1;
        int j = m_array != null ? array.length() : 0;
        m_lastIdx = m_idx + (i != -1 ? Math.min(j - m_idx, i) : j - m_idx);
        m_fetchSz = OracleConnection.DEFAULT_ROW_PREFETCH;
    }

    public boolean next()
        throws SQLException
    {
        if(m_closed)
            DBError.check_error(10, "next");
        m_idx++;
        return m_idx <= m_lastIdx;
    }

    public synchronized void close()
        throws SQLException
    {
        m_closed = true;
    }

    public synchronized boolean wasNull()
        throws SQLException
    {
        if(m_wasNull == null)
            DBError.check_error(24, null);
        return m_wasNull.booleanValue();
    }

    public synchronized String getString(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.stringValue();
        else
            return null;
    }

    public synchronized ResultSet getCursor(int i)
        throws SQLException
    {
        DBError.check_error(4, "getCursor");
        return null;
    }

    public synchronized Datum getOracleObject(int i)
        throws SQLException
    {
        if(m_idx <= 0)
            DBError.check_error(14, null);
        if(i == 1)
        {
            m_wasNull = BOOLEAN_FALSE;
            return new NUMBER(m_idx);
        }
        if(i == 2)
        {
            if(m_data != null)
            {
                m_wasNull = m_data[m_idx - 1] != null ? BOOLEAN_FALSE : BOOLEAN_TRUE;
                return m_data[m_idx - 1];
            }
            if(m_array != null)
            {
                Datum adatum[] = m_array.getOracleArray(m_idx, 1);
                if(adatum != null && adatum.length >= 1)
                {
                    m_wasNull = adatum[0] != null ? BOOLEAN_FALSE : BOOLEAN_TRUE;
                    return adatum[0];
                }
            }
            DBError.check_error(1, "Out of sync");
        }
        DBError.check_error(3, null);
        return null;
    }

    public synchronized ROWID getROWID(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof ROWID)
                return (ROWID)datum;
            DBError.check_error(4, "getROWID");
        }
        return null;
    }

    public synchronized NUMBER getNUMBER(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof NUMBER)
                return (NUMBER)datum;
            DBError.check_error(4, "getNUMBER");
        }
        return null;
    }

    public synchronized DATE getDATE(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof DATE)
                return (DATE)datum;
            DBError.check_error(4, "getDATE");
        }
        return null;
    }

    public synchronized ARRAY getARRAY(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof ARRAY)
                return (ARRAY)datum;
            DBError.check_error(4, "getARRAY");
        }
        return null;
    }

    public synchronized STRUCT getSTRUCT(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof STRUCT)
                return (STRUCT)datum;
            DBError.check_error(4, "getSTRUCT");
        }
        return null;
    }

    public synchronized OPAQUE getOPAQUE(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof OPAQUE)
                return (OPAQUE)datum;
            DBError.check_error(4, "getOPAQUE");
        }
        return null;
    }

    public synchronized REF getREF(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof REF)
                return (REF)datum;
            DBError.check_error(4, "getREF");
        }
        return null;
    }

    public synchronized CHAR getCHAR(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof CHAR)
                return (CHAR)datum;
            DBError.check_error(4, "getCHAR");
        }
        return null;
    }

    public synchronized RAW getRAW(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof RAW)
                return (RAW)datum;
            DBError.check_error(4, "getRAW");
        }
        return null;
    }

    public synchronized BLOB getBLOB(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof BLOB)
                return (BLOB)datum;
            DBError.check_error(4, "getBLOB");
        }
        return null;
    }

    public synchronized CLOB getCLOB(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof CLOB)
                return (CLOB)datum;
            DBError.check_error(4, "getCLOB");
        }
        return null;
    }

    public synchronized BFILE getBFILE(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof BFILE)
                return (BFILE)datum;
            DBError.check_error(4, "getBFILE");
        }
        return null;
    }

    public synchronized BFILE getBfile(int i)
        throws SQLException
    {
        return getBFILE(i);
    }

    public synchronized boolean getBoolean(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.booleanValue();
        else
            return false;
    }

    public synchronized byte getByte(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.byteValue();
        else
            return 0;
    }

    public synchronized short getShort(int i)
        throws SQLException
    {
        long l = getLong(i);
        if(l > 0x10001L || l < 0xfffffffffffefffeL)
            DBError.check_error(26, "getShort");
        return (short)(int)l;
    }

    public synchronized int getInt(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.intValue();
        else
            return 0;
    }

    public synchronized long getLong(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.longValue();
        else
            return 0L;
    }

    public synchronized float getFloat(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.floatValue();
        else
            return 0.0F;
    }

    public synchronized double getDouble(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.doubleValue();
        else
            return 0.0D;
    }

    public synchronized BigDecimal getBigDecimal(int i, int j)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.bigDecimalValue();
        else
            return null;
    }

    public synchronized byte[] getBytes(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof RAW)
                return ((RAW)datum).shareBytes();
            DBError.check_error(4, "getBytes");
        }
        return null;
    }

    public synchronized Date getDate(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.dateValue();
        else
            return null;
    }

    public synchronized Time getTime(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.timeValue();
        else
            return null;
    }

    public synchronized Timestamp getTimestamp(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.timestampValue();
        else
            return null;
    }

    public synchronized InputStream getAsciiStream(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            datum.asciiStreamValue();
        return null;
    }

    public synchronized InputStream getUnicodeStream(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            DBConversion dbconversion = m_conn.conversion;
            byte abyte0[] = datum.shareBytes();
            if(datum instanceof RAW)
                return dbconversion.ConvertStream(new ByteArrayInputStream(abyte0), 3);
            if(datum instanceof CHAR)
                return dbconversion.ConvertStream(new ByteArrayInputStream(abyte0), 1);
            DBError.check_error(4, "getUnicodeStream");
        }
        return null;
    }

    public synchronized InputStream getBinaryStream(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.binaryStreamValue();
        else
            return null;
    }

    public synchronized Object getObject(int i)
        throws SQLException
    {
        return getObject(i, m_map);
    }

    /**
     * @deprecated Method getCustomDatum is deprecated
     */

    public synchronized CustomDatum getCustomDatum(int i, CustomDatumFactory customdatumfactory)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        return customdatumfactory.create(datum, 0);
    }

    public synchronized ORAData getORAData(int i, ORADataFactory oradatafactory)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        return oradatafactory.create(datum, 0);
    }

    public synchronized ResultSetMetaData getMetaData()
        throws SQLException
    {
        if(m_closed)
            DBError.check_error(10, "getMetaData");
        DBError.check_error(23, "getMetaData");
        return null;
    }

    public synchronized int findColumn(String s)
        throws SQLException
    {
        if(s.equalsIgnoreCase("index"))
            return 1;
        if(s.equalsIgnoreCase("value"))
        {
            return 2;
        } else
        {
            DBError.check_error(6, "get_column_index");
            return 0;
        }
    }

    public synchronized Statement getStatement()
        throws SQLException
    {
        return null;
    }

    public synchronized Object getObject(int i, Map map)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof STRUCT)
                return ((STRUCT)datum).toJdbc(map);
            else
                return datum.toJdbc();
        } else
        {
            return null;
        }
    }

    public synchronized Ref getRef(int i)
        throws SQLException
    {
        return getREF(i);
    }

    public synchronized Blob getBlob(int i)
        throws SQLException
    {
        return getBLOB(i);
    }

    public synchronized Clob getClob(int i)
        throws SQLException
    {
        return getCLOB(i);
    }

    public synchronized Array getArray(int i)
        throws SQLException
    {
        return getARRAY(i);
    }

    public synchronized Reader getCharacterStream(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.characterStreamValue();
        else
            return null;
    }

    public synchronized BigDecimal getBigDecimal(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.bigDecimalValue();
        else
            return null;
    }

    public synchronized Date getDate(int i, Calendar calendar)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            DATE date = null;
            if(datum instanceof DATE)
                date = (DATE)datum;
            else
                date = new DATE(datum.stringValue());
            if(date != null)
                return date.dateValue(calendar);
        }
        return null;
    }

    public synchronized Time getTime(int i, Calendar calendar)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            DATE date = null;
            if(datum instanceof DATE)
                date = (DATE)datum;
            else
                date = new DATE(datum.stringValue());
            if(date != null)
                return date.timeValue(calendar);
        }
        return null;
    }

    public synchronized Timestamp getTimestamp(int i, Calendar calendar)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            DATE date = null;
            if(datum instanceof DATE)
                date = (DATE)datum;
            else
                date = new DATE(datum.stringValue());
            if(date != null)
                return date.timestampValue(calendar);
        }
        return null;
    }

    public boolean isBeforeFirst()
        throws SQLException
    {
        return m_idx < 1;
    }

    public boolean isAfterLast()
        throws SQLException
    {
        return m_idx > m_lastIdx;
    }

    public boolean isFirst()
        throws SQLException
    {
        return m_idx == 1;
    }

    public boolean isLast()
        throws SQLException
    {
        return m_idx == m_lastIdx;
    }

    public int getRow()
        throws SQLException
    {
        return m_idx;
    }

    public void setFetchSize(int i)
        throws SQLException
    {
        if(i < 0)
            DBError.throwSqlException(68);
        else
        if(i == 0)
            m_fetchSz = OracleConnection.DEFAULT_ROW_PREFETCH;
        else
            m_fetchSz = i;
    }

    public int getFetchSize()
        throws SQLException
    {
        return m_fetchSz;
    }

    Datum m_data[];
    Map m_map;
    private int m_idx;
    private int m_lastIdx;
    boolean m_closed;
    OracleConnection m_conn;
    private Boolean m_wasNull;
    private static Boolean BOOLEAN_TRUE = new Boolean(true);
    private static Boolean BOOLEAN_FALSE = new Boolean(false);
    private int m_fetchSz;
    ARRAY m_array;

}
