// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleBlobOutputStream.java

package oracle.jdbc.driver;

import java.io.IOException;
import java.io.OutputStream;
import java.sql.SQLException;
import oracle.jdbc.dbaccess.DBAccess;
import oracle.jdbc.dbaccess.DBError;
import oracle.sql.BLOB;

// Referenced classes of package oracle.jdbc.driver:
//            OracleConnection

public class OracleBlobOutputStream extends OutputStream
{

    public OracleBlobOutputStream(BLOB blob1)
        throws SQLException
    {
        this(blob1, blob1.getConnection().db_access.getDefaultStreamChunkSize());
    }

    public OracleBlobOutputStream(BLOB blob1, int i)
        throws SQLException
    {
        this(blob1, i, 1L);
    }

    public OracleBlobOutputStream(BLOB blob1, int i, long l)
        throws SQLException
    {
        if(blob1 == null || i <= 0 || l < 1L)
        {
            throw new IllegalArgumentException("Illegal Arguments");
        } else
        {
            blob = blob1;
            lob_offset = l;
            buf = new byte[i];
            count = 0;
            bufSize = i;
            isClosed = false;
            return;
        }
    }

    public void write(int i)
        throws IOException
    {
        ensureOpen();
        if(count >= buf.length)
            flushBuffer();
        buf[count++] = (byte)i;
    }

    public void write(byte abyte0[], int i, int j)
        throws IOException
    {
        ensureOpen();
        int k = i;
        for(int l = k + Math.min(j, abyte0.length - i); k < l;)
        {
            int i1 = Math.min(bufSize - count, l - k);
            System.arraycopy(abyte0, k, buf, count, i1);
            k += i1;
            count += i1;
            if(count >= bufSize)
                flushBuffer();
        }

    }

    public void flush()
        throws IOException
    {
        ensureOpen();
        flushBuffer();
    }

    public void close()
        throws IOException
    {
        flushBuffer();
        isClosed = true;
    }

    private void flushBuffer()
        throws IOException
    {
        try
        {
            if(count > 0)
            {
                if(count < buf.length)
                {
                    byte abyte0[] = new byte[count];
                    System.arraycopy(buf, 0, abyte0, 0, count);
                    lob_offset += blob.putBytes(lob_offset, abyte0);
                } else
                {
                    lob_offset += blob.putBytes(lob_offset, buf);
                }
                count = 0;
            }
        }
        catch(SQLException sqlexception)
        {
            DBError.SQLToIOException(sqlexception);
        }
    }

    void ensureOpen()
        throws IOException
    {
        try
        {
            if(isClosed)
                DBError.check_error(57, null);
        }
        catch(SQLException sqlexception)
        {
            DBError.SQLToIOException(sqlexception);
        }
    }

    long lob_offset;
    BLOB blob;
    byte buf[];
    int count;
    int bufSize;
    boolean isClosed;
}
