// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleBufferedStream.java

package oracle.jdbc.driver;

import java.io.IOException;
import java.io.InputStream;

public class OracleBufferedStream extends InputStream
{

    public OracleBufferedStream(int i)
    {
        pos = 0;
        count = 0;
        closed = false;
        chunkSize = i;
        buf = new byte[i];
    }

    public void close()
        throws IOException
    {
        closed = true;
    }

    public boolean needBytes()
        throws IOException
    {
        throw new IOException("You should not call this method");
    }

    public int flushBytes(int i)
    {
        int j = i <= count - pos ? i : count - pos;
        pos += j;
        return j;
    }

    public int writeBytes(byte abyte0[], int i, int j)
    {
        int k = j <= count - pos ? j : count - pos;
        System.arraycopy(buf, pos, abyte0, i, k);
        pos += k;
        return k;
    }

    public synchronized int read()
        throws IOException
    {
        if(closed || isNull())
            return -1;
        if(needBytes())
            return buf[pos++] & 0xff;
        else
            return -1;
    }

    public int read(byte abyte0[])
        throws IOException
    {
        return read(abyte0, 0, abyte0.length);
    }

    public synchronized int read(byte abyte0[], int i, int j)
        throws IOException
    {
        int l = i;
        if(closed || isNull())
            return -1;
        int k;
        if(j > abyte0.length)
            k = l + abyte0.length;
        else
            k = l + j;
        if(!needBytes())
            return -1;
        for(l += writeBytes(abyte0, l, k - l); l < k && needBytes(); l += writeBytes(abyte0, l, k - l));
        return l - i;
    }

    public int available()
        throws IOException
    {
        if(closed || isNull())
            return 0;
        else
            return count - pos;
    }

    public boolean isNull()
        throws IOException
    {
        return false;
    }

    public synchronized void mark(int i)
    {
    }

    public synchronized void reset()
        throws IOException
    {
        throw new IOException("mark/reset not supported");
    }

    public boolean markSupported()
    {
        return false;
    }

    public long skip(int i)
        throws IOException
    {
        int j = 0;
        int k = i;
        if(closed || isNull())
            return -1L;
        if(!needBytes())
            return -1L;
        for(; j < k && needBytes(); j += flushBytes(k - j));
        return (long)j;
    }

    byte buf[];
    int pos;
    int count;
    boolean closed;
    int chunkSize;
}
