// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleConnectionCacheImpl.java

package oracle.jdbc.pool;

import java.io.Serializable;
import java.sql.*;
import java.util.*;
import javax.naming.*;
import javax.sql.ConnectionPoolDataSource;
import javax.sql.PooledConnection;
import oracle.jdbc.dbaccess.DBError;
import oracle.jdbc.driver.OracleConnection;

// Referenced classes of package oracle.jdbc.pool:
//            OracleDataSource, OracleConnectionEventListener, OracleConnectionPoolDataSource, OraclePooledConnection, 
//            OracleConnectionCacheTimeOutThread, OracleConnectionCache

public class OracleConnectionCacheImpl extends OracleDataSource
    implements OracleConnectionCache, Serializable, Referenceable
{

    public OracleConnectionCacheImpl()
        throws SQLException
    {
        this(null);
    }

    public OracleConnectionCacheImpl(ConnectionPoolDataSource connectionpooldatasource)
        throws SQLException
    {
        m_cpds = null;
        _MIN_LIMIT = _DEFAULT_MIN_LIMIT;
        _MAX_LIMIT = _DEFAULT_MAX_LIMIT;
        m_cacheTTLTimeOut = -1L;
        m_cacheInactivityTimeOut = -1L;
        m_cacheFixedWaitTimeOut = -1L;
        m_threadInterval = 900L;
        m_cache = null;
        m_activeCache = null;
        m_cacheSize = 0;
        m_activeSize = 0;
        m_fixedWaitIdleTime = -1L;
        m_ocel = null;
        m_stmtCacheSize = 0;
        m_stmtClearMetaData = false;
        m_timeOutThread = null;
        m_warning = null;
        m_cacheScheme = 1;
        m_cache = new Stack();
        m_activeCache = new Hashtable();
        m_cacheSize = 0;
        m_activeSize = 0;
        m_cpds = connectionpooldatasource;
        m_ocel = new OracleConnectionEventListener(this);
        m_dataSourceName = "OracleConnectionCacheImpl";
    }

    public synchronized void setConnectionPoolDataSource(ConnectionPoolDataSource connectionpooldatasource)
        throws SQLException
    {
        if(m_cacheSize > 0)
            DBError.throwSqlException(78);
        m_cpds = connectionpooldatasource;
    }

    public synchronized Connection getConnection()
        throws SQLException
    {
        return getConnection(m_user, m_password);
    }

    public synchronized Connection getConnection(String s, String s1)
        throws SQLException
    {
        PooledConnection pooledconnection = getPooledConnection(s, s1);
        if(pooledconnection != null)
        {
            Connection connection = pooledconnection.getConnection();
            if(connection != null)
                ((OracleConnection)connection).setStartTime(System.currentTimeMillis());
            return connection;
        } else
        {
            return null;
        }
    }

    protected PooledConnection getPooledConnection(String s, String s1)
        throws SQLException
    {
        PooledConnection pooledconnection = null;
        if(!m_cache.empty())
        {
            checkCredentials(s, s1);
            pooledconnection = removeConnectionFromCache();
        } else
        if(m_cacheSize < _MAX_LIMIT || m_cacheScheme == 1)
        {
            String s2 = null;
            String s3 = null;
            if(m_cpds != null)
            {
                s2 = ((OracleConnectionPoolDataSource)m_cpds).getUser();
                s3 = ((OracleConnectionPoolDataSource)m_cpds).getPassword();
            }
            if(m_cacheSize > 0 && s != null && !s.equalsIgnoreCase(s2))
                DBError.throwSqlException(79);
            else
            if(s != null)
            {
                m_user = s;
                if(m_cpds != null)
                    ((OracleConnectionPoolDataSource)m_cpds).setUser(s);
            }
            if(m_cacheSize > 0 && s1 != null && !s1.equalsIgnoreCase(s3))
                DBError.throwSqlException(79);
            else
            if(s1 != null)
            {
                m_password = s1;
                if(m_cpds != null)
                    ((OracleConnectionPoolDataSource)m_cpds).setPassword(s1);
            }
            pooledconnection = getNewPoolOrXAConnection();
            m_cacheSize++;
        } else
        {
            if(m_cacheScheme == 3)
                return null;
            checkCredentials(s, s1);
            long l = System.currentTimeMillis();
            while(m_cache.empty()) 
            {
                if(m_cacheFixedWaitTimeOut > 0L && System.currentTimeMillis() - l > m_cacheFixedWaitTimeOut * 1000L)
                    DBError.throwSqlException(126);
                synchronized(m_cache)
                {
                    try
                    {
                        m_cache.wait((m_fixedWaitIdleTime != -1L ? m_fixedWaitIdleTime : 30L) * 1000L);
                    }
                    catch(InterruptedException interruptedexception) { }
                }
            }
            pooledconnection = removeConnectionFromCache();
        }
        if(pooledconnection != null)
        {
            pooledconnection.addConnectionEventListener(m_ocel);
            m_activeCache.put(pooledconnection, pooledconnection);
            m_activeSize++;
            ((OraclePooledConnection)pooledconnection).setStmtCacheSize(m_stmtCacheSize, m_stmtClearMetaData);
        }
        return pooledconnection;
    }

    PooledConnection getNewPoolOrXAConnection()
        throws SQLException
    {
        if(m_cpds == null)
        {
            if(m_user == null || m_password == null)
                DBError.throwSqlException(79);
            m_cpds = new OracleConnectionPoolDataSource();
            copy((OracleDataSource)m_cpds);
        }
        PooledConnection pooledconnection = m_cpds.getPooledConnection();
        ((OraclePooledConnection)pooledconnection).setStmtCacheSize(m_stmtCacheSize, m_stmtClearMetaData);
        return pooledconnection;
    }

    public void reusePooledConnection(PooledConnection pooledconnection)
        throws SQLException
    {
        detachSingleConnection(pooledconnection);
        if(m_cacheSize > _MAX_LIMIT && m_cacheScheme == 1)
            closeSingleConnection(pooledconnection);
        else
            putConnectionToCache(pooledconnection);
    }

    public void closePooledConnection(PooledConnection pooledconnection)
        throws SQLException
    {
        detachSingleConnection(pooledconnection);
        closeSingleConnection(pooledconnection);
    }

    private void detachSingleConnection(PooledConnection pooledconnection)
    {
        m_activeSize--;
        pooledconnection.removeConnectionEventListener(m_ocel);
        m_activeCache.remove(pooledconnection);
    }

    public synchronized void closeSingleConnection(PooledConnection pooledconnection)
        throws SQLException
    {
        m_cacheSize--;
        pooledconnection.close();
        removeConnectionFromCache(pooledconnection);
    }

    public void close()
        throws SQLException
    {
        PooledConnection pooledconnection;
        for(Enumeration enumeration = m_activeCache.keys(); enumeration.hasMoreElements(); reusePooledConnection(pooledconnection))
        {
            PooledConnection pooledconnection1 = (PooledConnection)enumeration.nextElement();
            pooledconnection = (PooledConnection)m_activeCache.get(pooledconnection1);
        }

        for(; !m_cache.empty(); closeSingleConnection((PooledConnection)m_cache.peek()));
        m_cache = null;
        m_activeCache = null;
        m_ocel = null;
        m_cpds = null;
        m_timeOutThread = null;
        clearWarnings();
    }

    public synchronized void setMinLimit(int i)
        throws SQLException
    {
        if(i < 0 || i > _MAX_LIMIT)
            DBError.throwSqlException(68);
        _MIN_LIMIT = i;
        if(m_cacheSize < _MIN_LIMIT)
        {
            for(int j = m_cacheSize; j < _MIN_LIMIT; j++)
            {
                PooledConnection pooledconnection = getNewPoolOrXAConnection();
                putConnectionToCache(pooledconnection);
            }

            m_cacheSize = _MIN_LIMIT;
        }
    }

    public synchronized int getMinLimit()
    {
        return _MIN_LIMIT;
    }

    public synchronized void setMaxLimit(int i)
        throws SQLException
    {
        if(i < 0 || i < _MIN_LIMIT)
            DBError.throwSqlException(68);
        _MAX_LIMIT = i;
        if(m_cacheSize > _MAX_LIMIT && m_cacheScheme != 1)
        {
            for(int j = _MAX_LIMIT; j < m_cacheSize; j++)
                if(m_cache.empty())
                    DBError.throwSqlException(78);
                else
                    removeConnectionFromCache().close();

            m_cacheSize = _MAX_LIMIT;
        }
    }

    public synchronized int getMaxLimit()
    {
        return _MAX_LIMIT;
    }

    public synchronized int getCacheScheme()
    {
        return m_cacheScheme;
    }

    public synchronized void setCacheScheme(int i)
        throws SQLException
    {
        if(i == 1 || i == 3 || i == 2)
        {
            m_cacheScheme = i;
            return;
        } else
        {
            DBError.throwSqlException(68);
            return;
        }
    }

    public synchronized void setCacheScheme(String s)
        throws SQLException
    {
        if(s.equalsIgnoreCase("DYNAMIC_SCHEME"))
            m_cacheScheme = 1;
        else
        if(s.equalsIgnoreCase("FIXED_RETURN_NULL_SCHEME"))
            m_cacheScheme = 3;
        else
        if(s.equalsIgnoreCase("FIXED_WAIT_SCHEME"))
            m_cacheScheme = 2;
        else
            DBError.throwSqlException(68);
    }

    public synchronized int getActiveSize()
    {
        return m_activeSize;
    }

    public synchronized int getCacheSize()
    {
        return m_cacheSize;
    }

    public synchronized void setCacheTimeToLiveTimeout(long l)
        throws SQLException
    {
        if(m_timeOutThread == null)
            m_timeOutThread = new OracleConnectionCacheTimeOutThread(this);
        if(l <= 0L)
        {
            m_cacheTTLTimeOut = -1L;
            m_warning = DBError.addSqlWarning(m_warning, 111);
        } else
        {
            m_cacheTTLTimeOut = l;
            checkAndStartTimeOutThread();
        }
    }

    public synchronized void setCacheInactivityTimeout(long l)
        throws SQLException
    {
        if(m_timeOutThread == null)
            m_timeOutThread = new OracleConnectionCacheTimeOutThread(this);
        if(l <= 0L)
        {
            m_cacheInactivityTimeOut = -1L;
            m_warning = DBError.addSqlWarning(m_warning, 124);
        } else
        {
            m_cacheInactivityTimeOut = l;
            checkAndStartTimeOutThread();
        }
    }

    public synchronized void setCacheFixedWaitTimeout(long l)
        throws SQLException
    {
        if(l <= 0L)
        {
            m_cacheFixedWaitTimeOut = -1L;
            m_warning = DBError.addSqlWarning(m_warning, 127);
        } else
        {
            m_cacheFixedWaitTimeOut = l;
        }
    }

    public long getCacheTimeToLiveTimeout()
        throws SQLException
    {
        return m_cacheTTLTimeOut;
    }

    public long getCacheInactivityTimeout()
        throws SQLException
    {
        return m_cacheInactivityTimeOut;
    }

    public long getCacheFixedWaitTimeout()
        throws SQLException
    {
        return m_cacheFixedWaitTimeOut;
    }

    public synchronized void setThreadWakeUpInterval(long l)
        throws SQLException
    {
        if(l <= 0L)
        {
            m_threadInterval = 900L;
            m_warning = DBError.addSqlWarning(m_warning, 112);
        } else
        {
            m_threadInterval = l;
        }
        if(m_cacheTTLTimeOut > 0L && m_threadInterval > m_cacheTTLTimeOut || m_cacheInactivityTimeOut > 0L && m_threadInterval > m_cacheInactivityTimeOut)
            m_warning = DBError.addSqlWarning(m_warning, 113);
    }

    public long getThreadWakeUpInterval()
        throws SQLException
    {
        return m_threadInterval;
    }

    private void checkAndStartTimeOutThread()
        throws SQLException
    {
        try
        {
            if(!m_timeOutThread.isAlive())
                m_timeOutThread.start();
        }
        catch(IllegalThreadStateException illegalthreadstateexception) { }
    }

    public SQLWarning getWarnings()
        throws SQLException
    {
        return m_warning;
    }

    public void clearWarnings()
        throws SQLException
    {
        m_warning = null;
    }

    private void checkCredentials(String s, String s1)
        throws SQLException
    {
        String s2 = null;
        String s3 = null;
        if(m_cpds != null)
        {
            s2 = ((OracleConnectionPoolDataSource)m_cpds).getUser();
            s3 = ((OracleConnectionPoolDataSource)m_cpds).getPassword();
        }
        if(s != null && !s.equals(s2) || s1 != null && !s1.equals(s3))
            DBError.throwSqlException(79);
    }

    public synchronized Reference getReference()
        throws NamingException
    {
        Reference reference = new Reference(getClass().getName(), "oracle.jdbc.pool.OracleDataSourceFactory", null);
        super.addRefProperties(reference);
        if(_MIN_LIMIT != _DEFAULT_MIN_LIMIT)
            reference.add(new StringRefAddr("minLimit", Integer.toString(_MIN_LIMIT)));
        if(_MAX_LIMIT != _DEFAULT_MAX_LIMIT)
            reference.add(new StringRefAddr("maxLimit", Integer.toString(_MAX_LIMIT)));
        if(m_cacheScheme != 1)
            reference.add(new StringRefAddr("cacheScheme", Integer.toString(m_cacheScheme)));
        return reference;
    }

    public synchronized void setStmtCacheSize(int i)
        throws SQLException
    {
        setStmtCacheSize(i, false);
    }

    public synchronized void setStmtCacheSize(int i, boolean flag)
        throws SQLException
    {
        if(i < 0)
            DBError.throwSqlException(68);
        m_stmtCacheSize = i;
        m_stmtClearMetaData = flag;
    }

    public synchronized int getStmtCacheSize()
    {
        return m_stmtCacheSize;
    }

    synchronized boolean isStmtCacheEnabled()
    {
        return m_stmtCacheSize > 0;
    }

    private void putConnectionToCache(PooledConnection pooledconnection)
        throws SQLException
    {
        ((OraclePooledConnection)pooledconnection).setLastAccessedTime(System.currentTimeMillis());
        m_cache.push(pooledconnection);
        synchronized(m_cache)
        {
            m_cache.notify();
        }
    }

    private PooledConnection removeConnectionFromCache()
        throws SQLException
    {
        return (PooledConnection)m_cache.pop();
    }

    private void removeConnectionFromCache(PooledConnection pooledconnection)
        throws SQLException
    {
        m_cache.removeElement(pooledconnection);
    }

    public synchronized void setCacheFixedWaitIdleTime(long l)
        throws SQLException
    {
        if(m_cacheScheme == 2)
        {
            if(l <= 0L)
            {
                DBError.addSqlWarning(m_warning, 68);
                m_fixedWaitIdleTime = 30L;
            } else
            {
                m_fixedWaitIdleTime = l;
            }
        } else
        {
            DBError.addSqlWarning(m_warning, new SQLWarning("Caching scheme is not FIXED_WAIT_SCHEME"));
        }
    }

    public long getCacheFixedWaitIdleTime()
        throws SQLException
    {
        return m_fixedWaitIdleTime != -1L ? m_fixedWaitIdleTime : 30L;
    }

    protected ConnectionPoolDataSource m_cpds;
    protected static int _DEFAULT_MIN_LIMIT = 0;
    protected static int _DEFAULT_MAX_LIMIT = 10;
    protected int _MIN_LIMIT;
    protected int _MAX_LIMIT;
    protected static final int DEFAULT_CACHE_TIMEOUT = -1;
    protected static final int DEFAULT_THREAD_INTERVAL = 900;
    protected long m_cacheTTLTimeOut;
    protected long m_cacheInactivityTimeOut;
    protected long m_cacheFixedWaitTimeOut;
    protected long m_threadInterval;
    Stack m_cache;
    Hashtable m_activeCache;
    protected int m_cacheSize;
    protected int m_activeSize;
    protected int m_cacheScheme;
    public static final long DEFAULT_FIXED_WAIT_IDLE_TIME = 30L;
    protected long m_fixedWaitIdleTime;
    public static final int DYNAMIC_SCHEME = 1;
    public static final int FIXED_WAIT_SCHEME = 2;
    public static final int FIXED_RETURN_NULL_SCHEME = 3;
    protected OracleConnectionEventListener m_ocel;
    protected int m_stmtCacheSize;
    protected boolean m_stmtClearMetaData;
    protected OracleConnectionCacheTimeOutThread m_timeOutThread;
    SQLWarning m_warning;

}
