// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleDataSource.java

package oracle.jdbc.pool;

import java.io.PrintWriter;
import java.io.Serializable;
import java.sql.*;
import java.util.Properties;
import javax.naming.*;
import javax.sql.DataSource;
import oracle.jdbc.OracleConnection;
import oracle.jdbc.dbaccess.DBError;
import oracle.jdbc.driver.OracleDriver;
import oracle.jdbc.driver.OracleLog;

public class OracleDataSource
    implements DataSource, Serializable, Referenceable
{

    public OracleDataSource()
        throws SQLException
    {
        m_pw = null;
        m_timeout = 0;
        m_databaseName = null;
        m_serviceName = null;
        m_dataSourceName = null;
        m_description = null;
        m_networkProtocol = "tcp";
        m_portNumber = 0;
        m_user = null;
        m_password = null;
        m_serverName = null;
        m_url = null;
        m_driverType = null;
        m_tnsentry = null;
        m_maxStatements = 0;
        m_implicitCachingEnabled = false;
        m_explicitCachingEnabled = false;
        m_url_explicit = false;
        m_use_defConn = false;
        m_od = null;
        m_od = new OracleDriver();
        DriverManager.registerDriver(m_od);
        m_dataSourceName = "OracleDataSource";
    }

    public synchronized Connection getConnection()
        throws SQLException
    {
        return getConnection(m_user, m_password);
    }

    public synchronized Connection getConnection(String s, String s1)
        throws SQLException
    {
        makeURL();
        Connection connection = null;
        Properties properties = new Properties();
        if(s != null)
            properties.put("user", s);
        if(s1 != null)
            properties.put("password", s1);
        if(m_use_defConn)
        {
            if(m_od == null)
                m_od = new OracleDriver();
            connection = m_od.defaultConnection();
        } else
        {
            connection = DriverManager.getConnection(m_url, properties);
        }
        ((OracleConnection)connection).setStatementCacheSize(m_maxStatements);
        ((OracleConnection)connection).setImplicitCachingEnabled(m_implicitCachingEnabled);
        ((OracleConnection)connection).setExplicitCachingEnabled(m_explicitCachingEnabled);
        return connection;
    }

    public synchronized int getLoginTimeout()
    {
        return m_timeout;
    }

    public synchronized void setLoginTimeout(int i)
    {
        m_timeout = i;
    }

    public synchronized void setLogWriter(PrintWriter printwriter)
    {
        m_pw = printwriter;
        OracleLog.setLogWriter(printwriter);
    }

    public synchronized PrintWriter getLogWriter()
    {
        return m_pw;
    }

    public synchronized void setTNSEntryName(String s)
    {
        m_tnsentry = s;
    }

    public synchronized String getTNSEntryName()
    {
        return m_tnsentry;
    }

    public synchronized void setDataSourceName(String s)
    {
        m_dataSourceName = s;
    }

    public synchronized String getDataSourceName()
    {
        return m_dataSourceName;
    }

    public synchronized String getDatabaseName()
    {
        return m_databaseName;
    }

    public synchronized void setDatabaseName(String s)
    {
        m_databaseName = s;
    }

    public synchronized void setServiceName(String s)
    {
        m_serviceName = s;
    }

    public synchronized String getServiceName()
    {
        return m_serviceName;
    }

    public synchronized void setServerName(String s)
    {
        m_serverName = s;
    }

    public synchronized String getServerName()
    {
        return m_serverName;
    }

    public synchronized void setURL(String s)
    {
        m_url = s;
        if(m_url != null)
            m_url_explicit = true;
    }

    public synchronized String getURL()
        throws SQLException
    {
        if(!m_url_explicit)
            makeURL();
        return m_url;
    }

    public synchronized void setUser(String s)
    {
        m_user = s;
    }

    public synchronized String getUser()
    {
        return m_user;
    }

    public synchronized void setPassword(String s)
    {
        m_password = s;
    }

    protected synchronized String getPassword()
    {
        return m_password;
    }

    public synchronized String getDescription()
    {
        return m_description;
    }

    public synchronized void setDescription(String s)
    {
        m_description = s;
    }

    public synchronized String getDriverType()
    {
        return m_driverType;
    }

    public synchronized void setDriverType(String s)
    {
        m_driverType = s;
    }

    public synchronized String getNetworkProtocol()
    {
        return m_networkProtocol;
    }

    public synchronized void setNetworkProtocol(String s)
    {
        m_networkProtocol = s;
    }

    public synchronized void setPortNumber(int i)
    {
        m_portNumber = i;
    }

    public synchronized int getPortNumber()
    {
        return m_portNumber;
    }

    public synchronized Reference getReference()
        throws NamingException
    {
        Reference reference = new Reference(getClass().getName(), "oracle.jdbc.pool.OracleDataSourceFactory", null);
        addRefProperties(reference);
        return reference;
    }

    protected void addRefProperties(Reference reference)
    {
        if(m_url != null)
            reference.add(new StringRefAddr("url", m_url));
        if(m_user != null)
            reference.add(new StringRefAddr("userName", m_user));
        if(m_password != null)
            reference.add(new StringRefAddr("passWord", m_password));
        if(m_description != null)
            reference.add(new StringRefAddr("description", m_description));
        if(m_driverType != null)
            reference.add(new StringRefAddr("driverType", m_driverType));
        if(m_serverName != null)
            reference.add(new StringRefAddr("serverName", m_serverName));
        if(m_databaseName != null)
            reference.add(new StringRefAddr("databaseName", m_databaseName));
        if(m_serviceName != null)
            reference.add(new StringRefAddr("serviceName", m_serviceName));
        if(m_networkProtocol != null)
            reference.add(new StringRefAddr("networkProtocol", m_networkProtocol));
        if(m_portNumber != 0)
            reference.add(new StringRefAddr("portNumber", Integer.toString(m_portNumber)));
        if(m_tnsentry != null)
            reference.add(new StringRefAddr("tnsentryname", m_tnsentry));
        if(m_maxStatements != 0)
            reference.add(new StringRefAddr("maxStatements", Integer.toString(m_maxStatements)));
        if(m_implicitCachingEnabled)
            reference.add(new StringRefAddr("implicitCachingEnabled", "true"));
        if(m_explicitCachingEnabled)
            reference.add(new StringRefAddr("explicitCachingEnabled", "true"));
    }

    void makeURL()
        throws SQLException
    {
        if(m_url_explicit)
            return;
        if(m_driverType == null || !m_driverType.equals("oci8") && !m_driverType.equals("oci") && !m_driverType.equals("thin") && !m_driverType.equals("kprb"))
            DBError.check_error(67, "OracleDataSource.makeURL");
        if(m_driverType.equals("kprb"))
        {
            m_use_defConn = true;
            m_url = "jdbc:oracle:kprb:@";
            return;
        }
        if((m_driverType.equals("oci8") || m_driverType.equals("oci")) && m_networkProtocol != null && m_networkProtocol.equals("ipc"))
        {
            m_url = "jdbc:oracle:oci:@";
            return;
        }
        if(m_tnsentry != null)
        {
            m_url = "jdbc:oracle:" + m_driverType + ":@" + m_tnsentry;
            return;
        }
        if(m_serviceName != null)
        {
            m_url = "jdbc:oracle:" + m_driverType + ":@(DESCRIPTION=(ADDRESS=(PROTOCOL=" + m_networkProtocol + ")(PORT=" + m_portNumber + ")(HOST=" + m_serverName + "))(CONNECT_DATA=(SERVICE_NAME=" + m_serviceName + ")))";
        } else
        {
            m_url = "jdbc:oracle:" + m_driverType + ":@(DESCRIPTION=(ADDRESS=(PROTOCOL=" + m_networkProtocol + ")(PORT=" + m_portNumber + ")(HOST=" + m_serverName + "))(CONNECT_DATA=(SID=" + m_databaseName + ")))";
            DBError.addSqlWarning(null, new SQLWarning("URL with SID jdbc:subprotocol:@host:port:sid will be deprecated in 10i\nPlease use URL with SERVICE_NAME as jdbc:subprotocol:@//host:port/service_name"));
        }
    }

    protected void trace(String s)
    {
        if(m_pw != null)
            OracleLog.print(this, 1, 512, 32, "OracleDataSource.trace(s): m_pw is not null");
    }

    void copy(OracleDataSource oracledatasource)
        throws SQLException
    {
        oracledatasource.setUser(m_user);
        oracledatasource.setPassword(m_password);
        oracledatasource.setTNSEntryName(m_tnsentry);
        makeURL();
        oracledatasource.setURL(m_url);
    }

    public void setMaxStatements(int i)
        throws SQLException
    {
        m_maxStatements = i;
    }

    public int getMaxStatements()
        throws SQLException
    {
        return m_maxStatements;
    }

    public void setImplicitCachingEnabled(boolean flag)
        throws SQLException
    {
        m_implicitCachingEnabled = flag;
    }

    public boolean getImplicitCachingEnabled()
        throws SQLException
    {
        return m_implicitCachingEnabled;
    }

    public void setExplicitCachingEnabled(boolean flag)
        throws SQLException
    {
        m_explicitCachingEnabled = flag;
    }

    public boolean getExplicitCachingEnabled()
        throws SQLException
    {
        return m_explicitCachingEnabled;
    }

    protected PrintWriter m_pw;
    protected int m_timeout;
    protected String m_databaseName;
    protected String m_serviceName;
    protected String m_dataSourceName;
    protected String m_description;
    protected String m_networkProtocol;
    protected int m_portNumber;
    protected String m_user;
    protected String m_password;
    protected String m_serverName;
    protected String m_url;
    protected String m_driverType;
    protected String m_tnsentry;
    protected int m_maxStatements;
    protected boolean m_implicitCachingEnabled;
    protected boolean m_explicitCachingEnabled;
    private boolean m_url_explicit;
    private boolean m_use_defConn;
    private transient OracleDriver m_od;
}
