// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OraclePooledConnection.java

package oracle.jdbc.pool;

import java.sql.*;
import java.util.Enumeration;
import java.util.Hashtable;
import javax.sql.*;
import oracle.jdbc.dbaccess.DBError;
import oracle.jdbc.driver.*;

public class OraclePooledConnection
    implements PooledConnection
{

    public OraclePooledConnection()
    {
        this((Connection)null);
    }

    public OraclePooledConnection(String s)
        throws SQLException
    {
        m_eventListeners = null;
        m_sqlException = null;
        m_autoCommit = true;
        m_logicalHandle = null;
        m_physicalConn = null;
        m_occ = null;
        m_privData = null;
        m_lastAccessedTime = 0L;
        DriverManager.registerDriver(new OracleDriver());
        Connection connection = DriverManager.getConnection(s);
        initialize(connection);
    }

    public OraclePooledConnection(String s, String s1, String s2)
        throws SQLException
    {
        m_eventListeners = null;
        m_sqlException = null;
        m_autoCommit = true;
        m_logicalHandle = null;
        m_physicalConn = null;
        m_occ = null;
        m_privData = null;
        m_lastAccessedTime = 0L;
        DriverManager.registerDriver(new OracleDriver());
        Connection connection = DriverManager.getConnection(s, s1, s2);
        initialize(connection);
    }

    public OraclePooledConnection(Connection connection)
    {
        m_eventListeners = null;
        m_sqlException = null;
        m_autoCommit = true;
        m_logicalHandle = null;
        m_physicalConn = null;
        m_occ = null;
        m_privData = null;
        m_lastAccessedTime = 0L;
        initialize(connection);
    }

    public OraclePooledConnection(Connection connection, boolean flag)
    {
        this(connection);
        m_autoCommit = flag;
    }

    private void initialize(Connection connection)
    {
        m_physicalConn = connection;
        m_eventListeners = new Hashtable(10);
        m_occ = null;
        m_privData = null;
        m_lastAccessedTime = 0L;
    }

    public synchronized void addConnectionEventListener(ConnectionEventListener connectioneventlistener)
    {
        if(m_eventListeners == null)
            m_sqlException = new SQLException("Listener Hashtable Null");
        else
            m_eventListeners.put(connectioneventlistener, connectioneventlistener);
    }

    public synchronized void close()
        throws SQLException
    {
        if(m_occ != null)
            m_occ.beforeClose((OracleConnection)m_physicalConn, m_privData);
        if(m_physicalConn != null)
        {
            m_physicalConn.close();
            m_physicalConn = null;
        }
        if(m_occ != null)
            m_occ.afterClose(m_privData);
        m_lastAccessedTime = 0L;
        callListener(2);
    }

    public synchronized Connection getConnection()
        throws SQLException
    {
        if(m_physicalConn == null)
        {
            m_sqlException = new SQLException("Physical Connection doesn't exis");
            callListener(2);
            DBError.throwSqlException(8);
            return null;
        }
        try
        {
            if(m_logicalHandle != null)
            {
                ((OracleConnection)m_logicalHandle).setPhysicalStatus(false);
                m_logicalHandle.close();
            }
            m_logicalHandle = new OracleConnection(this, (OracleConnection)m_physicalConn, m_autoCommit);
        }
        catch(SQLException sqlexception)
        {
            m_sqlException = sqlexception;
            callListener(2);
            DBError.throwSqlException(8);
            return null;
        }
        return m_logicalHandle;
    }

    public synchronized Connection getLogicalHandle()
        throws SQLException
    {
        return m_logicalHandle;
    }

    public synchronized void setLastAccessedTime(long l)
        throws SQLException
    {
        m_lastAccessedTime = l;
    }

    public long getLastAccessedTime()
        throws SQLException
    {
        return m_lastAccessedTime;
    }

    public synchronized void registerCloseCallback(OracleCloseCallback oracleclosecallback, Object obj)
    {
        m_occ = oracleclosecallback;
        m_privData = obj;
    }

    public synchronized void removeConnectionEventListener(ConnectionEventListener connectioneventlistener)
    {
        if(m_eventListeners == null)
            m_sqlException = new SQLException("Listener Hashtable Null");
        else
            m_eventListeners.remove(connectioneventlistener);
    }

    public synchronized void logicalClose()
    {
        callListener(1);
    }

    private void callListener(int i)
    {
        if(m_eventListeners == null)
            return;
        Enumeration enumeration = m_eventListeners.keys();
        ConnectionEvent connectionevent = new ConnectionEvent(this, m_sqlException);
        while(enumeration.hasMoreElements()) 
        {
            ConnectionEventListener connectioneventlistener = (ConnectionEventListener)enumeration.nextElement();
            ConnectionEventListener connectioneventlistener1 = (ConnectionEventListener)m_eventListeners.get(connectioneventlistener);
            if(i == 1)
                connectioneventlistener1.connectionClosed(connectionevent);
            else
            if(i == 2)
                connectioneventlistener1.connectionErrorOccurred(connectionevent);
        }
    }

    /**
     * @deprecated Method setStmtCacheSize is deprecated
     */

    public synchronized void setStmtCacheSize(int i)
        throws SQLException
    {
        setStmtCacheSize(i, false);
    }

    /**
     * @deprecated Method setStmtCacheSize is deprecated
     */

    public synchronized void setStmtCacheSize(int i, boolean flag)
        throws SQLException
    {
        if(i < 0)
            DBError.throwSqlException(68);
        if(m_physicalConn != null)
            ((OracleConnection)m_physicalConn).setStmtCacheSize(i, flag);
    }

    /**
     * @deprecated Method getStmtCacheSize is deprecated
     */

    public synchronized int getStmtCacheSize()
    {
        if(m_physicalConn != null)
            return ((OracleConnection)m_physicalConn).getStmtCacheSize();
        else
            return 0;
    }

    public void setStatementCacheSize(int i)
        throws SQLException
    {
        if(m_physicalConn != null)
            ((OracleConnection)m_physicalConn).setStatementCacheSize(i);
    }

    public int getStatementCacheSize()
        throws SQLException
    {
        if(m_physicalConn != null)
            return ((OracleConnection)m_physicalConn).getStatementCacheSize();
        else
            return 0;
    }

    public void setImplicitCachingEnabled(boolean flag)
        throws SQLException
    {
        if(m_physicalConn != null)
            ((OracleConnection)m_physicalConn).setImplicitCachingEnabled(flag);
    }

    public boolean getImplicitCachingEnabled()
        throws SQLException
    {
        if(m_physicalConn != null)
            return ((OracleConnection)m_physicalConn).getImplicitCachingEnabled();
        else
            return false;
    }

    public void setExplicitCachingEnabled(boolean flag)
        throws SQLException
    {
        if(m_physicalConn != null)
            ((OracleConnection)m_physicalConn).setExplicitCachingEnabled(flag);
    }

    public boolean getExplicitCachingEnabled()
        throws SQLException
    {
        if(m_physicalConn != null)
            return ((OracleConnection)m_physicalConn).getExplicitCachingEnabled();
        else
            return false;
    }

    public void purgeImplicitCache()
        throws SQLException
    {
        if(m_physicalConn != null)
            ((OracleConnection)m_physicalConn).purgeImplicitCache();
    }

    public void purgeExplicitCache()
        throws SQLException
    {
        if(m_physicalConn != null)
            ((OracleConnection)m_physicalConn).purgeExplicitCache();
    }

    public PreparedStatement getStatementWithKey(String s)
        throws SQLException
    {
        if(m_physicalConn != null)
            return ((OracleConnection)m_physicalConn).getStatementWithKey(s);
        else
            return null;
    }

    public CallableStatement getCallWithKey(String s)
        throws SQLException
    {
        if(m_physicalConn != null)
            return ((OracleConnection)m_physicalConn).getCallWithKey(s);
        else
            return null;
    }

    public boolean isStatementCacheInitialized()
    {
        if(m_physicalConn != null)
            return ((OracleConnection)m_physicalConn).isStatementCacheInitialized();
        else
            return false;
    }

    private Hashtable m_eventListeners;
    private SQLException m_sqlException;
    private boolean m_autoCommit;
    protected Connection m_logicalHandle;
    protected Connection m_physicalConn;
    private OracleCloseCallback m_occ;
    private Object m_privData;
    private long m_lastAccessedTime;
}
