// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   MAREngine.java

package oracle.jdbc.ttc7;

import java.io.*;
import java.sql.SQLException;
import java.util.Vector;
import oracle.jdbc.dbaccess.DBError;
import oracle.net.ns.*;

// Referenced classes of package oracle.jdbc.ttc7:
//            TTCTypeRep, TTCItem, TTCConversion

public class MAREngine
{

    protected static String toHex(long l, int i)
    {
        String s;
        switch(i)
        {
        case 1: // '\001'
            s = "00" + Long.toString(l & 255L, 16);
            break;

        case 2: // '\002'
            s = "0000" + Long.toString(l & 65535L, 16);
            break;

        case 3: // '\003'
            s = "000000" + Long.toString(l & 0xffffffL, 16);
            break;

        case 4: // '\004'
            s = "00000000" + Long.toString(l & 0xffffffffL, 16);
            break;

        case 5: // '\005'
            s = "0000000000" + Long.toString(l & 0xffffffffffL, 16);
            break;

        case 6: // '\006'
            s = "000000000000" + Long.toString(l & 0xffffffffffffL, 16);
            break;

        case 7: // '\007'
            s = "00000000000000" + Long.toString(l & 0xffffffffffffffL, 16);
            break;

        case 8: // '\b'
            return toHex(l >> 32, 4) + toHex(l, 4).substring(2);

        default:
            return "more than 8 bytes";
        }
        return "0x" + s.substring(s.length() - 2 * i);
    }

    protected static String toHex(byte byte0)
    {
        String s = "00" + Integer.toHexString(byte0 & 0xff);
        return "0x" + s.substring(s.length() - 2);
    }

    protected static String toHex(short word0)
    {
        return toHex(word0, 2);
    }

    protected static String toHex(int i)
    {
        return toHex(i, 4);
    }

    protected static String toHex(byte abyte0[], int i)
    {
        if(abyte0 == null)
            return "null";
        if(i > abyte0.length)
            return "byte array not long enough";
        String s = "[";
        int j = Math.min(64, i);
        for(int k = 0; k < j; k++)
            s = s + toHex(abyte0[k]) + " ";

        if(j < i)
            s = s + "...";
        return s + "]";
    }

    protected static String toHex(byte abyte0[])
    {
        if(abyte0 == null)
            return "null";
        else
            return toHex(abyte0, abyte0.length);
    }

    public MAREngine(Communication communication)
        throws SQLException, IOException
    {
        if(communication == null)
            DBError.check_error(433);
        net = communication;
        try
        {
            inStream = communication.getInputStream();
            outStream = communication.getOutputStream();
        }
        catch(NetException netexception)
        {
            throw new IOException(netexception.getMessage());
        }
        types = new TTCTypeRep();
        types.setRep((byte)1, (byte)2);
    }

    public void initBuffers()
    {
    }

    protected void marshalSB1(byte byte0)
        throws IOException
    {
        outStream.write(byte0);
    }

    protected void marshalUB1(short word0)
        throws IOException
    {
        outStream.write((byte)(word0 & 0xff));
    }

    protected void marshalSB2(short word0)
        throws IOException
    {
        byte byte0 = value2Buffer(word0, tmpBuffer2, (byte)1);
        if(byte0 != 0)
            outStream.write(tmpBuffer2, 0, byte0);
    }

    protected void marshalUB2(int i)
        throws IOException
    {
        marshalSB2((short)(i & 0xffff));
    }

    protected void marshalSB4(int i)
        throws IOException
    {
        byte byte0 = value2Buffer(i, tmpBuffer4, (byte)2);
        if(byte0 != 0)
            outStream.write(tmpBuffer4, 0, byte0);
    }

    protected void marshalUB4(long l)
        throws IOException
    {
        marshalSB4((int)(l & -1L));
    }

    protected void marshalSWORD(int i)
        throws IOException
    {
        marshalSB4(i);
    }

    protected void marshalUWORD(long l)
        throws IOException
    {
        marshalSB4((int)(l & -1L));
    }

    protected void marshalB1Array(byte abyte0[])
        throws IOException
    {
        if(abyte0.length > 0)
            outStream.write(abyte0);
    }

    protected void marshalB1Array(byte abyte0[], int i, int j)
        throws IOException
    {
        if(abyte0.length > 0)
            outStream.write(abyte0, i, j);
    }

    protected void marshalUB4Array(long al[])
        throws IOException
    {
        for(int i = 0; i < al.length; i++)
            marshalSB4((int)(al[i] & -1L));

    }

    public void marshalO2U(boolean flag)
        throws IOException
    {
        if(flag)
            addPtr((byte)1);
        else
            addPtr((byte)0);
    }

    public void marshalNULLPTR()
        throws IOException
    {
        addPtr((byte)0);
    }

    public void marshalPTR()
        throws IOException
    {
        addPtr((byte)1);
    }

    protected void marshalCHR(byte abyte0[])
        throws IOException
    {
        if(abyte0.length > 0)
            if(types.isConvNeeded())
                marshalCLR(abyte0, abyte0.length);
            else
                outStream.write(abyte0);
    }

    protected void marshalCLR(byte abyte0[], int i)
        throws IOException
    {
        if(i > 64)
        {
            int l = 0;
            outStream.write(-2);
            do
            {
                int j = i - l;
                int k = j <= 64 ? j : 64;
                outStream.write((byte)(k & 0xff));
                outStream.write(abyte0, l, k);
                l += k;
            } while(l < i);
            outStream.write(0);
        } else
        {
            outStream.write((byte)(i & 0xff));
            if(abyte0.length != 0)
                outStream.write(abyte0);
        }
    }

    public void marshalDALC(byte abyte0[])
        throws SQLException, IOException
    {
        if(abyte0 == null || abyte0.length < 1)
        {
            outStream.write(0);
        } else
        {
            marshalSB4(-1 & abyte0.length);
            marshalCLR(abyte0, abyte0.length);
        }
    }

    protected void addPtr(byte byte0)
        throws IOException
    {
        if((types.rep[3] & 1) > 0)
        {
            outStream.write(byte0);
        } else
        {
            byte byte1 = value2Buffer(byte0, tmpBuffer4, (byte)3);
            if(byte1 != 0)
                outStream.write(tmpBuffer4, 0, byte1);
        }
    }

    protected byte value2Buffer(int i, byte abyte0[], byte byte0)
        throws IOException
    {
        boolean flag = true;
        byte byte1 = 0;
        for(int j = abyte0.length - 1; j >= 0; j--)
        {
            abyte0[byte1] = (byte)(i >>> 8 * j & 0xff);
            if((types.rep[byte0] & 1) > 0)
            {
                if(!flag || abyte0[byte1] != 0)
                {
                    flag = false;
                    byte1++;
                }
            } else
            {
                byte1++;
            }
        }

        if((types.rep[byte0] & 1) > 0)
            outStream.write(byte1);
        if((types.rep[byte0] & 2) > 0)
            reverseArray(abyte0, byte1);
        return byte1;
    }

    protected void reverseArray(byte abyte0[], byte byte0)
    {
        for(int i = 0; i < byte0 / 2; i++)
        {
            byte byte1 = abyte0[i];
            abyte0[i] = abyte0[byte0 - 1 - i];
            abyte0[byte0 - 1 - i] = byte1;
        }

    }

    public byte unmarshalSB1()
        throws SQLException, IOException
    {
        byte byte0 = (byte)unmarshalUB1();
        return byte0;
    }

    public short unmarshalUB1()
        throws SQLException, IOException
    {
        short word0 = 0;
        do
            try
            {
                try
                {
                    word0 = (short)inStream.read();
                    break;
                }
                catch(BreakNetException breaknetexception)
                {
                    net.sendReset();
                }
            }
            catch(NetException netexception)
            {
                throw new IOException(netexception.getMessage());
            }
        while(true);
        if(word0 < 0)
            DBError.check_error(410);
        return word0;
    }

    public short unmarshalSB2()
        throws SQLException, IOException
    {
        short word0 = (short)unmarshalUB2();
        return word0;
    }

    public int unmarshalUB2()
        throws SQLException, IOException
    {
        int i = (int)buffer2Value((byte)1);
        return i & 0xffff;
    }

    public int unmarshalUCS2(byte abyte0[], long l)
        throws SQLException, IOException
    {
        byte byte0 = 0;
        int i = 2;
        if((types.rep[1] & 1) > 0)
        {
            do
                try
                {
                    try
                    {
                        i = inStream.read();
                        break;
                    }
                    catch(BreakNetException breaknetexception)
                    {
                        net.sendReset();
                    }
                }
                catch(NetException netexception)
                {
                    throw new IOException(netexception.getMessage());
                }
            while(true);
            if((i & 0x80) > 0)
                i &= 0x7f;
            if(i < 0)
                DBError.check_error(410);
        }
        if(i > 2 || i < 1)
        {
            DBError.check_error(412);
        } else
        {
            byte abyte1[];
            if(i == 1)
                abyte1 = tmpBuffer1;
            else
                abyte1 = tmpBuffer2;
            boolean flag = true;
            do
                try
                {
                    try
                    {
                        if(inStream.read(abyte1) < 0)
                            DBError.check_error(410);
                        break;
                    }
                    catch(BreakNetException breaknetexception1)
                    {
                        net.sendReset();
                    }
                }
                catch(NetException netexception1)
                {
                    throw new IOException(netexception1.getMessage());
                }
            while(true);
            if(i == 1)
            {
                abyte0[(int)l] = 0;
                abyte0[(int)l + 1] = abyte1[0];
                byte0 = 2;
            } else
            {
                if((types.rep[1] & 2) > 0)
                {
                    abyte0[(int)l] = abyte1[1];
                    abyte0[(int)l + 1] = abyte1[0];
                } else
                {
                    abyte0[(int)l] = abyte1[0];
                    abyte0[(int)l + 1] = abyte1[1];
                }
                byte0 = 3;
            }
        }
        return byte0;
    }

    public int unmarshalSB4()
        throws SQLException, IOException
    {
        int i = (int)unmarshalUB4();
        return i;
    }

    public long unmarshalUB4()
        throws SQLException, IOException
    {
        long l = buffer2Value((byte)2);
        return l;
    }

    public int unmarshalSB4(byte abyte0[])
        throws SQLException, IOException
    {
        long l = buffer2Value((byte)2, new ByteArrayInputStream(abyte0));
        return (int)l;
    }

    public int unmarshalRefCursor(byte abyte0[])
        throws SQLException, IOException
    {
        int i = unmarshalSB4(abyte0);
        return i;
    }

    public int unmarshalSWORD()
        throws SQLException, IOException
    {
        int i = (int)unmarshalUB4();
        return i;
    }

    public long unmarshalUWORD()
        throws SQLException, IOException
    {
        long l = unmarshalUB4();
        return l;
    }

    public byte[] unmarshalNBytes(int i)
        throws SQLException, IOException
    {
        byte abyte0[] = new byte[i];
        do
            try
            {
                try
                {
                    if(inStream.read(abyte0) < 0)
                        DBError.check_error(410);
                    break;
                }
                catch(BreakNetException breaknetexception)
                {
                    net.sendReset();
                }
            }
            catch(NetException netexception)
            {
                throw new IOException(netexception.getMessage());
            }
        while(true);
        return abyte0;
    }

    public int unmarshalNBytes(byte abyte0[], int i, int j)
        throws SQLException, IOException
    {
        int k;
        for(k = 0; k < j; k += getNBytes(abyte0, i + k, j - k));
        return k;
    }

    public int getNBytes(byte abyte0[], int i, int j)
        throws SQLException, IOException
    {
        int k = 0;
        do
            try
            {
                try
                {
                    if((k = inStream.read(abyte0, i, j)) < 0)
                        DBError.check_error(410);
                    break;
                }
                catch(BreakNetException breaknetexception)
                {
                    net.sendReset();
                }
            }
            catch(NetException netexception)
            {
                throw new IOException(netexception.getMessage());
            }
        while(true);
        return k;
    }

    public byte[] getNBytes(int i)
        throws SQLException, IOException
    {
        byte abyte0[] = new byte[i];
        do
            try
            {
                try
                {
                    if(inStream.read(abyte0) < 0)
                        DBError.check_error(410);
                    break;
                }
                catch(BreakNetException breaknetexception)
                {
                    net.sendReset();
                }
            }
            catch(NetException netexception)
            {
                throw new IOException(netexception.getMessage());
            }
        while(true);
        return abyte0;
    }

    public byte[] unmarshalTEXT(int i)
        throws SQLException, IOException
    {
        int j = 0;
        byte abyte0[] = new byte[i];
        while(j < i) 
        {
            do
                try
                {
                    try
                    {
                        if(inStream.read(abyte0, j, 1) < 0)
                            DBError.check_error(410);
                        break;
                    }
                    catch(BreakNetException breaknetexception)
                    {
                        net.sendReset();
                    }
                }
                catch(NetException netexception)
                {
                    throw new IOException(netexception.getMessage());
                }
            while(true);
            if(abyte0[j++] == 0)
                break;
        }
        byte abyte1[];
        if(abyte0.length == --j)
        {
            abyte1 = abyte0;
        } else
        {
            abyte1 = new byte[j];
            System.arraycopy(abyte0, 0, abyte1, 0, j);
        }
        return abyte1;
    }

    public byte[] unmarshalCHR(int i)
        throws SQLException, IOException
    {
        byte abyte0[] = null;
        if(types.isConvNeeded())
        {
            abyte0 = unmarshalCLR(i, retLen);
            if(abyte0.length != retLen[0])
            {
                byte abyte1[] = new byte[retLen[0]];
                System.arraycopy(abyte0, 0, abyte1, 0, retLen[0]);
                abyte0 = abyte1;
            }
        } else
        {
            abyte0 = getNBytes(i);
        }
        return abyte0;
    }

    public void unmarshalCLR(TTCItem ttcitem, int ai[])
        throws SQLException, IOException
    {
        short word0 = 0;
        int i = 0;
        boolean flag = false;
        byte byte0 = -1;
        word0 = unmarshalUB1();
        if(word0 < 0)
            DBError.check_error(401);
        if(word0 == 0)
            return;
        if(escapeSequenceNull(word0))
        {
            ai[0] = 0;
            return;
        }
        if(word0 != 254)
        {
            i = unmarshalBuffer(ttcitem.byte_value, i, word0);
        } else
        {
            byte byte1 = -1;
            do
            {
                if(byte1 != -1)
                {
                    word0 = unmarshalUB1();
                    if(word0 <= 0)
                        break;
                }
                if(word0 == 254)
                    switch(byte1)
                    {
                    default:
                        break;

                    case -1: 
                        byte1 = 1;
                        continue;

                    case 1: // '\001'
                        byte1 = 0;
                        break;

                    case 0: // '\0'
                        if(flag)
                        {
                            byte1 = 0;
                            break;
                        }
                        byte1 = 0;
                        continue;
                    }
                if(i == -1)
                    unmarshalBuffer(ignored, 0, word0);
                else
                    i = unmarshalBuffer(ttcitem.byte_value, i, word0);
                byte1 = 0;
                if(word0 > 252)
                    flag = true;
            } while(true);
        }
        if(ai != null)
            if(i != -1)
                ai[0] = i;
            else
                ai[0] = ttcitem.byte_value.length;
    }

    public byte[] unmarshalCLR(int i, int ai[])
        throws SQLException, IOException
    {
        boolean flag = false;
        int j = 0;
        short word1 = unmarshalUB1();
        if(word1 < 0)
            DBError.check_error(401);
        if(word1 == 0)
        {
            ai[0] = 0;
            return new byte[0];
        }
        byte abyte0[] = new byte[i * conv.getNLSRATIO()];
        if(escapeSequenceNull(word1))
        {
            ai[0] = 0;
        } else
        {
            short word0;
            if(word1 != 254)
                j = unmarshalBuffer(abyte0, j, word1);
            else
                while((word0 = unmarshalUB1()) > 0) 
                    if(word0 != 254 || !types.isServerConversion())
                        if(j == -1)
                            unmarshalBuffer(ignored, 0, word0);
                        else
                            j = unmarshalBuffer(abyte0, j, word0);
            if(ai != null)
                if(j != -1)
                    ai[0] = j;
                else
                    ai[0] = abyte0.length;
        }
        return abyte0;
    }

    private int unmarshalBuffer(byte abyte0[], int i, int j)
        throws SQLException, IOException
    {
        if(abyte0.length < i + j)
        {
            unmarshalNBytes(abyte0, i, abyte0.length - i);
            unmarshalNBytes(ignored, 0, (i + j) - abyte0.length);
            i = -1;
        } else
        {
            unmarshalNBytes(abyte0, i, j);
            i += j;
        }
        return i;
    }

    public byte[] unmarshalCLRforREFS()
        throws SQLException, IOException
    {
        boolean flag = false;
        short word1 = 0;
        byte abyte0[] = null;
        Vector vector = new Vector(10, 10);
        short word2 = unmarshalUB1();
        if(word2 < 0)
            DBError.check_error(401);
        if(word2 == 0)
            return null;
        if(!escapeSequenceNull(word2))
        {
            short word0;
            if(word2 == 254)
            {
                while((word0 = unmarshalUB1()) > 0) 
                    if(word0 != 254 || !types.isServerConversion())
                    {
                        word1 += word0;
                        byte abyte1[] = new byte[word0];
                        unmarshalBuffer(abyte1, 0, word0);
                        vector.addElement(abyte1);
                    }
            } else
            {
                word1 = word2;
                byte abyte2[] = new byte[word2];
                unmarshalBuffer(abyte2, 0, word2);
                vector.addElement(abyte2);
            }
            abyte0 = new byte[word1];
            int i = 0;
            for(; vector.size() > 0; vector.removeElementAt(0))
            {
                int j = ((byte[])vector.elementAt(0)).length;
                System.arraycopy(vector.elementAt(0), 0, abyte0, i, j);
                i += j;
            }

        } else
        {
            abyte0 = null;
        }
        return abyte0;
    }

    public boolean escapeSequenceNull(int i)
        throws SQLException
    {
        boolean flag = false;
        switch(i)
        {
        case 0: // '\0'
            flag = true;
            break;

        case 253: 
            DBError.check_error(401);
            // fall through

        case 255: 
            flag = true;
            break;
        }
        return flag;
    }

    public int processIndicator(boolean flag, int i)
        throws SQLException, IOException
    {
        short word0 = unmarshalSB2();
        int j = 0;
        if(!flag)
            if(word0 == 0)
                j = i;
            else
            if(word0 == -2 || word0 > 0)
                j = word0;
            else
                j = 0x10000 + word0;
        return j;
    }

    public byte[] unmarshalDALC()
        throws SQLException, IOException
    {
        long l = unmarshalUB4();
        byte abyte0[] = new byte[(int)(-1L & l)];
        if(abyte0.length > 0)
        {
            abyte0 = unmarshalCLR(abyte0.length, retLen);
            if(abyte0 == null)
                DBError.check_error(401);
        } else
        {
            abyte0 = new byte[0];
        }
        return abyte0;
    }

    public byte[] unmarshalDALC(int ai[])
        throws SQLException, IOException
    {
        long l = unmarshalUB4();
        byte abyte0[] = new byte[(int)(-1L & l)];
        if(abyte0.length > 0)
        {
            abyte0 = unmarshalCLR(abyte0.length, ai);
            if(abyte0 == null)
                DBError.check_error(401);
        } else
        {
            abyte0 = new byte[0];
        }
        return abyte0;
    }

    private long buffer2Value(byte byte0)
        throws SQLException, IOException
    {
        int i = 0;
        long l = 0L;
        boolean flag = false;
        if((types.rep[byte0] & 1) > 0)
        {
            do
                try
                {
                    try
                    {
                        i = inStream.read();
                        break;
                    }
                    catch(BreakNetException breaknetexception)
                    {
                        net.sendReset();
                    }
                }
                catch(NetException netexception)
                {
                    throw new IOException(netexception.getMessage());
                }
            while(true);
            if((i & 0x80) > 0)
            {
                i &= 0x7f;
                flag = true;
            }
            if(i < 0)
                DBError.check_error(410);
            if(i == 0)
                return 0L;
            if(byte0 == 1 && i > 2 || byte0 == 2 && i > 4)
                DBError.check_error(412);
        } else
        if(byte0 == 1)
            i = 2;
        else
        if(byte0 == 2)
            i = 4;
        byte abyte0[];
        switch(i)
        {
        case 1: // '\001'
            abyte0 = tmpBuffer1;
            break;

        case 2: // '\002'
            abyte0 = tmpBuffer2;
            break;

        case 3: // '\003'
            abyte0 = tmpBuffer3;
            break;

        case 4: // '\004'
            abyte0 = tmpBuffer4;
            break;

        default:
            abyte0 = new byte[i];
            break;
        }
        do
            try
            {
                try
                {
                    if(inStream.read(abyte0) < 0)
                        DBError.check_error(410);
                    break;
                }
                catch(BreakNetException breaknetexception1)
                {
                    net.sendReset();
                }
            }
            catch(NetException netexception1)
            {
                throw new IOException(netexception1.getMessage());
            }
        while(true);
        for(int j = 0; j < abyte0.length; j++)
        {
            short word0;
            if((types.rep[byte0] & 2) > 0)
                word0 = (short)(abyte0[abyte0.length - 1 - j] & 0xff);
            else
                word0 = (short)(abyte0[j] & 0xff);
            l |= word0 << 8 * (abyte0.length - 1 - j);
        }

        l &= -1L;
        if(flag)
            l *= -1L;
        return l;
    }

    private long buffer2Value(byte byte0, ByteArrayInputStream bytearrayinputstream)
        throws SQLException, IOException
    {
        int i = 0;
        long l = 0L;
        boolean flag = false;
        if((types.rep[byte0] & 1) > 0)
        {
            i = bytearrayinputstream.read();
            if((i & 0x80) > 0)
            {
                i &= 0x7f;
                flag = true;
            }
            if(i < 0)
                DBError.check_error(410);
            if(i == 0)
                return 0L;
            if(byte0 == 1 && i > 2 || byte0 == 2 && i > 4)
                DBError.check_error(412);
        } else
        if(byte0 == 1)
            i = 2;
        else
        if(byte0 == 2)
            i = 4;
        byte abyte0[] = new byte[i];
        if(bytearrayinputstream.read(abyte0) < 0)
            DBError.check_error(410);
        for(int j = 0; j < abyte0.length; j++)
        {
            short word0;
            if((types.rep[byte0] & 2) > 0)
                word0 = (short)(abyte0[abyte0.length - 1 - j] & 0xff);
            else
                word0 = (short)(abyte0[j] & 0xff);
            l |= word0 << 8 * (abyte0.length - 1 - j);
        }

        l &= -1L;
        if(flag)
            l *= -1L;
        return l;
    }

    public static final int TTCC_MXL = 252;
    public static final int TTCC_ESC = 253;
    public static final int TTCC_LNG = 254;
    public static final int TTCC_ERR = 255;
    public static final int TTCC_MXIN = 64;
    public static final byte TTCLXMULTI = 1;
    public static final byte TTCLXMCONV = 2;
    public TTCTypeRep types;
    public Communication net;
    public TTCConversion conv;
    public byte proSvrVer;
    protected InputStream inStream;
    protected OutputStream outStream;
    final byte ignored[] = new byte[255];
    final byte tmpBuffer1[] = new byte[1];
    final byte tmpBuffer2[] = new byte[2];
    final byte tmpBuffer3[] = new byte[3];
    final byte tmpBuffer4[] = new byte[4];
    final int retLen[] = new int[1];
}
