// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   CharacterSet.java

package oracle.sql;

import java.sql.SQLException;
import oracle.gss.util.NLSError;

// Referenced classes of package oracle.sql:
//            CharacterBuffer, CharacterSetFactory, CharacterSetFactoryDefault, CharacterWalker

public abstract class CharacterSet
{

    CharacterSet(int i)
    {
        oracleId = i;
    }

    public static char[] AL16UTF16BytesToJavaChars(byte abyte0[], int i, int j)
    {
        int i1 = Math.min(abyte0.length - i >>> 1, j >>> 1);
        char ac[] = new char[i1];
        int k = 0;
        int l = i;
        for(; k < i1; k++)
        {
            ac[k] = (char)((abyte0[l] << 8) + (abyte0[l + 1] & 0xff));
            l += 2;
        }

        return ac;
    }

    public static int AL16UTF16BytesToJavaChars(byte abyte0[], int i, char ac[])
    {
        int l = Math.min(i >>> 1, ac.length);
        int j = 0;
        int k = 0;
        for(; j < l; j++)
        {
            ac[j] = (char)((abyte0[k] << 8) + (abyte0[k + 1] & 0xff));
            k += 2;
        }

        return j;
    }

    public static String AL16UTF16BytesToString(byte abyte0[], int i)
    {
        char ac[] = new char[i >>> 1];
        AL16UTF16BytesToJavaChars(abyte0, i, ac);
        return new String(ac);
    }

    public static char[] AL16UTF16LEBytesToJavaChars(byte abyte0[], int i, int j)
    {
        int i1 = Math.min(abyte0.length - i >>> 1, j >>> 1);
        char ac[] = new char[i1];
        int k = 0;
        int l = i;
        for(; k < i1; k++)
        {
            ac[k] = (char)((abyte0[l + 1] << 8) + (abyte0[l] & 0xff));
            l += 2;
        }

        return ac;
    }

    public static char[] AL32UTF8ToJavaChar(byte abyte0[], int i, int j)
        throws SQLException
    {
        int k = i;
        int l = i + j;
        if(l > abyte0.length)
            l = abyte0.length;
        char ac[] = new char[UTFStringLength(abyte0, i, j)];
        int i1 = 0;
        while(k < l) 
        {
            byte byte0 = abyte0[k++];
            int j1 = byte0 & 0xf0;
            switch(j1 / 16)
            {
            case 0: // '\0'
            case 1: // '\001'
            case 2: // '\002'
            case 3: // '\003'
            case 4: // '\004'
            case 5: // '\005'
            case 6: // '\006'
            case 7: // '\007'
                ac[i1++] = (char)(byte0 & 0xff);
                break;

            case 12: // '\f'
            case 13: // '\r'
                if(k >= l)
                    failUTFConversion();
                byte byte1 = abyte0[k++];
                if((byte1 & 0xc0) != 128)
                    failUTFConversion();
                ac[i1++] = (char)((byte0 & 0x1f) << 6 | byte1 & 0x3f);
                break;

            case 14: // '\016'
                if(k + 1 >= l)
                    failUTFConversion();
                byte byte2 = abyte0[k++];
                byte byte4 = abyte0[k++];
                if((byte2 & 0xc0) != 128 || (byte4 & 0xc0) != 128)
                    failUTFConversion();
                ac[i1++] = (char)((byte0 & 0xf) << 12 | (byte2 & 0x3f) << 6 | byte4 & 0x3f);
                break;

            case 15: // '\017'
                if(k + 2 >= l)
                    failUTFConversion();
                byte byte3 = abyte0[k++];
                byte byte5 = abyte0[k++];
                byte byte6 = abyte0[k++];
                if((byte3 & 0xc0) != 128 || (byte5 & 0xc0) != 128 || (byte6 & 0xc0) != 128)
                    failUTFConversion();
                ac[i1++] = (char)((((byte0 & 7) << 2 | (byte3 >> 4 & 3) - 1) & 0xf) << 6 | (byte3 & 0xf) << 2 | byte5 >> 4 & 3 | 0xd800);
                ac[i1++] = (char)((byte5 & 0xf) << 6 | byte6 & 0x3f | 0xdc00);
                break;

            case 8: // '\b'
            case 9: // '\t'
            case 10: // '\n'
            case 11: // '\013'
            default:
                failUTFConversion();
                break;
            }
        }
        return ac;
    }

    public static int UTFStringLength(byte abyte0[], int i, int j)
    {
        int k = 0;
        for(int l = i; l < i + j;)
        {
            switch((abyte0[l] & 0xf0) >> 4)
            {
            case 1: // '\001'
            case 2: // '\002'
            case 3: // '\003'
            case 4: // '\004'
            case 5: // '\005'
            case 6: // '\006'
            case 7: // '\007'
                l++;
                break;

            case 12: // '\f'
            case 13: // '\r'
                l += 2;
                break;

            case 14: // '\016'
                l += 3;
                break;

            case 15: // '\017'
                l += 4;
                k++;
                break;

            case 8: // '\b'
            case 9: // '\t'
            case 10: // '\n'
            case 11: // '\013'
            default:
                l++;
                break;
            }
            k++;
        }

        return k;
    }

    public static char[] UTFToJavaChar(byte abyte0[], int i, int j)
        throws SQLException
    {
        int k = i;
        int l = i + j;
        if(l > abyte0.length)
            l = abyte0.length;
        char ac[] = new char[UTFStringLength(abyte0, i, j)];
        int i1 = 0;
        while(k < l) 
        {
            byte byte0 = abyte0[k++];
            int j1 = byte0 & 0xf0;
            switch(j1 / 16)
            {
            case 0: // '\0'
            case 1: // '\001'
            case 2: // '\002'
            case 3: // '\003'
            case 4: // '\004'
            case 5: // '\005'
            case 6: // '\006'
            case 7: // '\007'
                ac[i1++] = (char)(byte0 & 0xff);
                break;

            case 12: // '\f'
            case 13: // '\r'
                if(k >= l)
                    failUTFConversion();
                byte byte1 = abyte0[k++];
                if((byte1 & 0xc0) != 128)
                    failUTFConversion();
                ac[i1++] = (char)((byte0 & 0x1f) << 6 | byte1 & 0x3f);
                break;

            case 14: // '\016'
                if(k + 1 >= l)
                    failUTFConversion();
                byte byte2 = abyte0[k++];
                byte byte3 = abyte0[k++];
                if((byte2 & 0xc0) != 128 || (byte3 & 0xc0) != 128)
                    failUTFConversion();
                ac[i1++] = (char)((byte0 & 0xf) << 12 | (byte2 & 0x3f) << 6 | byte3 & 0x3f);
                break;

            case 8: // '\b'
            case 9: // '\t'
            case 10: // '\n'
            case 11: // '\013'
            default:
                failUTFConversion();
                break;
            }
        }
        return ac;
    }

    public abstract byte[] convert(String s)
        throws SQLException;

    public abstract byte[] convert(CharacterSet characterset, byte abyte0[], int i, int j)
        throws SQLException;

    public static final long convertUTF32toUTF16(long l)
    {
        if(l > 65535L)
        {
            long l1 = 216L | l - 0x10000L >> 18 & 255L;
            l1 = l - 0x10000L >> 10 & 255L | l1 << 8;
            l1 = 220L | (l & 1023L) >> 8 & 255L | l1 << 8;
            l1 = l & 255L | l1 << 8;
            return l1;
        } else
        {
            return l;
        }
    }

    public byte[] convertUnshared(CharacterSet characterset, byte abyte0[], int i, int j)
        throws SQLException
    {
        byte abyte1[] = convert(characterset, abyte0, i, j);
        if(abyte1 == abyte0)
        {
            abyte1 = new byte[abyte0.length];
            System.arraycopy(abyte0, 0, abyte1, 0, j);
        }
        return abyte1;
    }

    public abstract byte[] convertWithReplacement(String s);

    abstract int decode(CharacterWalker characterwalker)
        throws SQLException;

    abstract void encode(CharacterBuffer characterbuffer, int i)
        throws SQLException;

    public boolean equals(Object obj)
    {
        return (obj instanceof CharacterSet) && oracleId == ((CharacterSet)obj).oracleId;
    }

    static void failCharacterConversion(CharacterSet characterset)
        throws SQLException
    {
        NLSError.throwSQLException(17055, characterset);
    }

    static void failUTFConversion()
        throws SQLException
    {
        NLSError.throwSQLException(17037, "failUTFConversion");
    }

    public int getOracleId()
    {
        return oracleId;
    }

    public int getRatioTo(CharacterSet characterset)
    {
        throw new Error("oracle.sql.CharacterSet.getRationTo Not Implemented");
    }

    int getRep()
    {
        return rep;
    }

    public int hashCode()
    {
        return oracleId;
    }

    public abstract boolean isConvertibleFrom(CharacterSet characterset);

    public abstract boolean isLossyFrom(CharacterSet characterset);

    public boolean isUnicode()
    {
        return false;
    }

    boolean isWellFormed(byte abyte0[], int i, int j)
    {
        return true;
    }

    public static int javaCharsToAL16UTF16Bytes(char ac[], int i, byte abyte0[])
    {
        int l = Math.min(i, abyte0.length >>> 1);
        int j = 0;
        int k;
        for(k = 0; j < l; k += 2)
        {
            abyte0[k] = (byte)(ac[j] >>> 8);
            abyte0[k + 1] = (byte)(ac[j] & 0xff);
            j++;
        }

        return k + 1;
    }

    public static int javaCharsToAL16UTF16LEBytes(char ac[], int i, byte abyte0[])
    {
        int l = Math.min(i, abyte0.length >>> 1);
        int j = 0;
        int k;
        for(k = 0; j < l; k += 2)
        {
            abyte0[k] = (byte)(ac[j] & 0xff);
            abyte0[k + 1] = (byte)(ac[j] >>> 8);
            j++;
        }

        return k + 1;
    }

    public static int javaCharsToAL32UTF8(char ac[], int i, int j, byte abyte0[], int k)
        throws SQLException
    {
        int j1 = i;
        int k1 = i + j;
        if(j1 < 0)
            j1 = 0;
        if(k1 > ac.length)
            k1 = ac.length;
        if(k < 0)
            k = 0;
        int l1 = 0;
        for(int l = j1; l < k1; l++)
        {
            char c = ac[l];
            if(c >= 0 && c <= '\177')
                l1++;
            else
            if(c >= '\uD800' && c <= '\uDBFF')
            {
                l1 += 4;
                l++;
            } else
            if(c > '\u07FF')
                l1 += 3;
            else
                l1 += 2;
        }

        if(l1 + k > abyte0.length)
            NLSError.throwSQLException(17038, "JavaCharsToCHARBytes");
        int i2 = 0;
        for(int i1 = j1; i1 < k1; i1++)
        {
            char c1 = ac[i1];
            if(c1 >= 0 && c1 <= '\177')
                abyte0[i2++] = (byte)c1;
            else
            if(c1 >= '\uD800' && c1 <= '\uDBFF')
            {
                if(i1 + 1 < k1)
                {
                    char c2 = ac[i1 + 1];
                    if((c2 >= '\uDC00') & (c2 <= '\uDFFF'))
                    {
                        int j2 = (c1 >> 6 & 0xf) + 1;
                        abyte0[i2++] = (byte)(j2 >> 2 & 2 | 0xf0);
                        abyte0[i2++] = (byte)((j2 & 3) << 4 | c1 >> 2 & 0xf | 0x80);
                        abyte0[i2++] = (byte)((c1 & 3) << 4 | c2 >> 6 & 0xf | 0x80);
                        abyte0[i2++] = (byte)(c2 & 0x3f | 0x80);
                        i1++;
                    }
                }
            } else
            if(c1 > '\u07FF')
            {
                abyte0[i2++] = (byte)(0xe0 | c1 >> 12 & 0xf);
                abyte0[i2++] = (byte)(0x80 | c1 >> 6 & 0x3f);
                abyte0[i2++] = (byte)(0x80 | c1 & 0x3f);
            } else
            {
                abyte0[i2++] = (byte)(0xc0 | c1 >> 6 & 0x1f);
                abyte0[i2++] = (byte)(0x80 | c1 & 0x3f);
            }
        }

        return i2;
    }

    public static int javaCharsToUTF(char ac[], int i, int j, byte abyte0[], int k)
        throws SQLException
    {
        int j1 = i;
        int k1 = i + j;
        if(j1 < 0)
            j1 = 0;
        if(k1 > ac.length)
            k1 = ac.length;
        if(k < 0)
            k = 0;
        int l1 = 0;
        for(int l = j1; l < k1; l++)
        {
            char c = ac[l];
            if(c >= 0 && c <= '\177')
                l1++;
            else
            if(c > '\u07FF')
                l1 += 3;
            else
                l1 += 2;
        }

        if(l1 + k > abyte0.length)
            NLSError.throwSQLException(17038, "JavaCharsToCHARBytes");
        int i2 = 0;
        for(int i1 = j1; i1 < k1; i1++)
        {
            char c1 = ac[i1];
            if(c1 >= 0 && c1 <= '\177')
                abyte0[i2++] = (byte)c1;
            else
            if(c1 > '\u07FF')
            {
                abyte0[i2++] = (byte)(0xe0 | c1 >> 12 & 0xf);
                abyte0[i2++] = (byte)(0x80 | c1 >> 6 & 0x3f);
                abyte0[i2++] = (byte)(0x80 | c1 & 0x3f);
            } else
            {
                abyte0[i2++] = (byte)(0xc0 | c1 >> 6 & 0x1f);
                abyte0[i2++] = (byte)(0x80 | c1 & 0x3f);
            }
        }

        return i2;
    }

    public static CharacterSet make(int i)
    {
        return factory.make(i);
    }

    static void need(CharacterBuffer characterbuffer, int i)
    {
        int j = characterbuffer.bytes.length;
        int k = i + characterbuffer.next;
        if(k >= j)
            return;
        for(; k < j; j = 2 * j);
        byte abyte0[] = characterbuffer.bytes;
        characterbuffer.bytes = new byte[j];
        System.arraycopy(abyte0, 0, characterbuffer.bytes, 0, characterbuffer.next);
    }

    public static int string32UTF8Length(String s)
    {
        int i = 0;
        int j = s.length();
        for(int k = 0; k < j; k++)
        {
            char c = s.charAt(k);
            if(c >= 0 && c <= '\177')
                i++;
            else
            if(c > '\u07FF')
            {
                if(c >= '\uD800' && c <= '\uDBFF' && k + 1 < j)
                {
                    i += 4;
                    k++;
                } else
                {
                    i += 3;
                }
            } else
            {
                i += 2;
            }
        }

        return i;
    }

    public static byte[] stringToAL16UTF16Bytes(String s)
    {
        char ac[] = s.toCharArray();
        byte abyte0[] = new byte[ac.length * 2];
        javaCharsToAL16UTF16Bytes(ac, ac.length, abyte0);
        return abyte0;
    }

    public static byte[] stringToAL16UTF16LEBytes(String s)
    {
        char ac[] = s.toCharArray();
        byte abyte0[] = new byte[ac.length * 2];
        javaCharsToAL16UTF16LEBytes(ac, ac.length, abyte0);
        return abyte0;
    }

    public static byte[] stringToAL32UTF8(String s)
    {
        int i = s.length();
        byte abyte0[] = new byte[string32UTF8Length(s)];
        char ac[] = new char[i];
        s.getChars(0, i, ac, 0);
        try
        {
            javaCharsToAL32UTF8(ac, 0, i, abyte0, 0);
        }
        catch(SQLException _ex) { }
        return abyte0;
    }

    public static byte[] stringToUTF(String s)
    {
        int i = s.length();
        byte abyte0[] = new byte[stringUTFLength(s)];
        char ac[] = new char[i];
        s.getChars(0, i, ac, 0);
        try
        {
            javaCharsToUTF(ac, 0, i, abyte0, 0);
        }
        catch(SQLException _ex) { }
        return abyte0;
    }

    public static int stringUTFLength(String s)
    {
        int i = 0;
        int j = s.length();
        for(int k = 0; k < j; k++)
        {
            char c = s.charAt(k);
            if(c >= 0 && c <= '\177')
                i++;
            else
            if(c > '\u07FF')
                i += 3;
            else
                i += 2;
        }

        return i;
    }

    public String toString()
    {
        return "oracle-character-set-" + oracleId;
    }

    public String toString(byte abyte0[], int i, int j)
        throws SQLException
    {
        String s = toStringWithReplacement(abyte0, i, j);
        byte abyte1[] = convert(s);
        if(j != abyte1.length)
            failCharacterConversion(this);
        for(int k = 0; k < j; k++)
            if(abyte1[k] != abyte0[i + k])
                failCharacterConversion(this);

        return null;
    }

    public abstract String toStringWithReplacement(byte abyte0[], int i, int j);

    static byte[] useOrCopy(byte abyte0[], int i, int j)
    {
        byte abyte1[];
        if(abyte0.length == j && i == 0)
        {
            abyte1 = abyte0;
        } else
        {
            abyte1 = new byte[j];
            System.arraycopy(abyte0, i, abyte1, 0, j);
        }
        return abyte1;
    }

    public static final short DEFAULT_CHARSET = -1;
    public static final short ASCII_CHARSET = 1;
    public static final short ISO_LATIN_1_CHARSET = 31;
    public static final short UNICODE_1_CHARSET = 870;
    public static final short US7ASCII_CHARSET = 1;
    public static final short WE8DEC_CHARSET = 2;
    public static final short WE8HP_CHARSET = 3;
    public static final short US8PC437_CHARSET = 4;
    public static final short WE8EBCDIC37_CHARSET = 5;
    public static final short WE8EBCDIC500_CHARSET = 6;
    public static final short WE8EBCDIC285_CHARSET = 8;
    public static final short WE8PC850_CHARSET = 10;
    public static final short D7DEC_CHARSET = 11;
    public static final short F7DEC_CHARSET = 12;
    public static final short S7DEC_CHARSET = 13;
    public static final short E7DEC_CHARSET = 14;
    public static final short SF7ASCII_CHARSET = 15;
    public static final short NDK7DEC_CHARSET = 16;
    public static final short I7DEC_CHARSET = 17;
    public static final short NL7DEC_CHARSET = 18;
    public static final short CH7DEC_CHARSET = 19;
    public static final short YUG7ASCII_CHARSET = 20;
    public static final short SF7DEC_CHARSET = 21;
    public static final short TR7DEC_CHARSET = 22;
    public static final short IW7IS960_CHARSET = 23;
    public static final short IN8ISCII_CHARSET = 25;
    public static final short WE8ISO8859P1_CHARSET = 31;
    public static final short EE8ISO8859P2_CHARSET = 32;
    public static final short SE8ISO8859P3_CHARSET = 33;
    public static final short NEE8ISO8859P4_CHARSET = 34;
    public static final short CL8ISO8859P5_CHARSET = 35;
    public static final short AR8ISO8859P6_CHARSET = 36;
    public static final short EL8ISO8859P7_CHARSET = 37;
    public static final short IW8ISO8859P8_CHARSET = 38;
    public static final short WE8ISO8859P9_CHARSET = 39;
    public static final short NE8ISO8859P10_CHARSET = 40;
    public static final short TH8TISASCII_CHARSET = 41;
    public static final short TH8TISEBCDIC_CHARSET = 42;
    public static final short BN8BSCII_CHARSET = 43;
    public static final short VN8VN3_CHARSET = 44;
    public static final short VN8MSWIN1258_CHARSET = 45;
    public static final short WE8NEXTSTEP_CHARSET = 50;
    public static final short AR8ASMO708PLUS_CHARSET = 61;
    public static final short AR8EBCDICX_CHARSET = 70;
    public static final short AR8XBASIC_CHARSET = 72;
    public static final short EL8DEC_CHARSET = 81;
    public static final short TR8DEC_CHARSET = 82;
    public static final short WE8EBCDIC37C_CHARSET = 90;
    public static final short WE8EBCDIC500C_CHARSET = 91;
    public static final short IW8EBCDIC424_CHARSET = 92;
    public static final short TR8EBCDIC1026_CHARSET = 93;
    public static final short WE8EBCDIC871_CHARSET = 94;
    public static final short WE8EBCDIC284_CHARSET = 95;
    public static final short WE8EBCDIC1047_CHARSET = 96;
    public static final short EEC8EUROASCI_CHARSET = 110;
    public static final short EEC8EUROPA3_CHARSET = 113;
    public static final short LA8PASSPORT_CHARSET = 114;
    public static final short BG8PC437S_CHARSET = 140;
    public static final short EE8PC852_CHARSET = 150;
    public static final short RU8PC866_CHARSET = 152;
    public static final short RU8BESTA_CHARSET = 153;
    public static final short IW8PC1507_CHARSET = 154;
    public static final short RU8PC855_CHARSET = 155;
    public static final short TR8PC857_CHARSET = 156;
    public static final short CL8MACCYRILLIC_CHARSET = 158;
    public static final short CL8MACCYRILLICS_CHARSET = 159;
    public static final short WE8PC860_CHARSET = 160;
    public static final short IS8PC861_CHARSET = 161;
    public static final short EE8MACCES_CHARSET = 162;
    public static final short EE8MACCROATIANS_CHARSET = 163;
    public static final short TR8MACTURKISHS_CHARSET = 164;
    public static final short IS8MACICELANDICS_CHARSET = 165;
    public static final short EL8MACGREEKS_CHARSET = 166;
    public static final short IW8MACHEBREWS_CHARSET = 167;
    public static final short EE8MSWIN1250_CHARSET = 170;
    public static final short CL8MSWIN1251_CHARSET = 171;
    public static final short ET8MSWIN923_CHARSET = 172;
    public static final short BG8MSWIN_CHARSET = 173;
    public static final short EL8MSWIN1253_CHARSET = 174;
    public static final short IW8MSWIN1255_CHARSET = 175;
    public static final short LT8MSWIN921_CHARSET = 176;
    public static final short TR8MSWIN1254_CHARSET = 177;
    public static final short WE8MSWIN1252_CHARSET = 178;
    public static final short BLT8MSWIN1257_CHARSET = 179;
    public static final short D8EBCDIC273_CHARSET = 180;
    public static final short I8EBCDIC280_CHARSET = 181;
    public static final short DK8EBCDIC277_CHARSET = 182;
    public static final short S8EBCDIC278_CHARSET = 183;
    public static final short EE8EBCDIC870_CHARSET = 184;
    public static final short CL8EBCDIC1025_CHARSET = 185;
    public static final short F8EBCDIC297_CHARSET = 186;
    public static final short IW8EBCDIC1086_CHARSET = 187;
    public static final short CL8EBCDIC1025X_CHARSET = 188;
    public static final short N8PC865_CHARSET = 190;
    public static final short BLT8CP921_CHARSET = 191;
    public static final short LV8PC1117_CHARSET = 192;
    public static final short LV8PC8LR_CHARSET = 193;
    public static final short BLT8EBCDIC1112_CHARSET = 194;
    public static final short LV8RST104090_CHARSET = 195;
    public static final short CL8KOI8R_CHARSET = 196;
    public static final short BLT8PC775_CHARSET = 197;
    public static final short F7SIEMENS9780X_CHARSET = 201;
    public static final short E7SIEMENS9780X_CHARSET = 202;
    public static final short S7SIEMENS9780X_CHARSET = 203;
    public static final short DK7SIEMENS9780X_CHARSET = 204;
    public static final short N7SIEMENS9780X_CHARSET = 205;
    public static final short I7SIEMENS9780X_CHARSET = 206;
    public static final short D7SIEMENS9780X_CHARSET = 207;
    public static final short WE8GCOS7_CHARSET = 210;
    public static final short EL8GCOS7_CHARSET = 211;
    public static final short US8BS2000_CHARSET = 221;
    public static final short D8BS2000_CHARSET = 222;
    public static final short F8BS2000_CHARSET = 223;
    public static final short E8BS2000_CHARSET = 224;
    public static final short DK8BS2000_CHARSET = 225;
    public static final short S8BS2000_CHARSET = 226;
    public static final short WE8BS2000_CHARSET = 231;
    public static final short CL8BS2000_CHARSET = 235;
    public static final short WE8BS2000L5_CHARSET = 239;
    public static final short WE8DG_CHARSET = 241;
    public static final short WE8NCR4970_CHARSET = 251;
    public static final short WE8ROMAN8_CHARSET = 261;
    public static final short EE8MACCE_CHARSET = 262;
    public static final short EE8MACCROATIAN_CHARSET = 263;
    public static final short TR8MACTURKISH_CHARSET = 264;
    public static final short IS8MACICELANDIC_CHARSET = 265;
    public static final short EL8MACGREEK_CHARSET = 266;
    public static final short IW8MACHEBREW_CHARSET = 267;
    public static final short US8ICL_CHARSET = 277;
    public static final short WE8ICL_CHARSET = 278;
    public static final short WE8ISOICLUK_CHARSET = 279;
    public static final short WE8MACROMAN8_CHARSET = 351;
    public static final short WE8MACROMAN8S_CHARSET = 352;
    public static final short TH8MACTHAI_CHARSET = 353;
    public static final short TH8MACTHAIS_CHARSET = 354;
    public static final short HU8CWI2_CHARSET = 368;
    public static final short EL8PC437S_CHARSET = 380;
    public static final short EL8EBCDIC875_CHARSET = 381;
    public static final short EL8PC737_CHARSET = 382;
    public static final short LT8PC772_CHARSET = 383;
    public static final short LT8PC774_CHARSET = 384;
    public static final short EL8PC869_CHARSET = 385;
    public static final short EL8PC851_CHARSET = 386;
    public static final short CDN8PC863_CHARSET = 390;
    public static final short HU8ABMOD_CHARSET = 401;
    public static final short AR8ASMO8X_CHARSET = 500;
    public static final short AR8NAFITHA711T_CHARSET = 504;
    public static final short AR8SAKHR707T_CHARSET = 505;
    public static final short AR8MUSSAD768T_CHARSET = 506;
    public static final short AR8ADOS710T_CHARSET = 507;
    public static final short AR8ADOS720T_CHARSET = 508;
    public static final short AR8APTEC715T_CHARSET = 509;
    public static final short AR8NAFITHA721T_CHARSET = 511;
    public static final short AR8HPARABIC8T_CHARSET = 514;
    public static final short AR8NAFITHA711_CHARSET = 554;
    public static final short AR8SAKHR707_CHARSET = 555;
    public static final short AR8MUSSAD768_CHARSET = 556;
    public static final short AR8ADOS710_CHARSET = 557;
    public static final short AR8ADOS720_CHARSET = 558;
    public static final short AR8APTEC715_CHARSET = 559;
    public static final short AR8MSAWIN_CHARSET = 560;
    public static final short AR8NAFITHA721_CHARSET = 561;
    public static final short AR8SAKHR706_CHARSET = 563;
    public static final short AR8ARABICMAC_CHARSET = 565;
    public static final short AR8ARABICMACS_CHARSET = 566;
    public static final short AR8ARABICMACT_CHARSET = 567;
    public static final short LA8ISO6937_CHARSET = 590;
    public static final short US8NOOP_CHARSET = 797;
    public static final short WE8DECTST_CHARSET = 798;
    public static final short JA16VMS_CHARSET = 829;
    public static final short JA16EUC_CHARSET = 830;
    public static final short JA16EUCYEN_CHARSET = 831;
    public static final short JA16SJIS_CHARSET = 832;
    public static final short JA16DBCS_CHARSET = 833;
    public static final short JA16SJISYEN_CHARSET = 834;
    public static final short JA16EBCDIC930_CHARSET = 835;
    public static final short JA16MACSJIS_CHARSET = 836;
    public static final short JA16EUCTILDE_CHARSET = 837;
    public static final short JA16SJISTILDE_CHARSET = 838;
    public static final short KO16KSC5601_CHARSET = 840;
    public static final short KO16DBCS_CHARSET = 842;
    public static final short KO16KSCCS_CHARSET = 845;
    public static final short KO16MSWIN949_CHARSET = 846;
    public static final short ZHS16CGB231280_CHARSET = 850;
    public static final short ZHS16MACCGB231280_CHARSET = 851;
    public static final short ZHS16GBK_CHARSET = 852;
    public static final short ZHS16DBCS_CHARSET = 853;
    public static final short ZHS32GB18030 = 854;
    public static final short ZHS16MSWIN936_CHARSET = 854;
    public static final short ZHT32EUC_CHARSET = 860;
    public static final short ZHT32SOPS_CHARSET = 861;
    public static final short ZHT16DBT_CHARSET = 862;
    public static final short ZHT32TRIS_CHARSET = 863;
    public static final short ZHT16DBCS_CHARSET = 864;
    public static final short ZHT16BIG5_CHARSET = 865;
    public static final short ZHT16CCDC_CHARSET = 866;
    public static final short ZHT16MSWIN950_CHARSET = 867;
    public static final short AL24UTFFSS_CHARSET = 870;
    public static final short UTF8_CHARSET = 871;
    public static final short UTFE_CHARSET = 872;
    public static final short AL32UTF8_CHARSET = 873;
    public static final short KO16TSTSET_CHARSET = 996;
    public static final short JA16TSTSET2_CHARSET = 997;
    public static final short JA16TSTSET_CHARSET = 998;
    public static final short US16TSTFIXED_CHARSET = 1001;
    public static final short JA16EUCFIXED_CHARSET = 1830;
    public static final short JA16SJISFIXED_CHARSET = 1832;
    public static final short JA16DBCSFIXED_CHARSET = 1833;
    public static final short KO16KSC5601FIXED_CHARSET = 1840;
    public static final short KO16DBCSFIXED_CHARSET = 1842;
    public static final short ZHS16CGB231280FIXED_CHARSET = 1850;
    public static final short ZHS16GBKFIXED_CHARSET = 1852;
    public static final short ZHS16DBCSFIXED_CHARSET = 1853;
    public static final short ZHT32EUCFIXED_CHARSET = 1860;
    public static final short ZHT32TRISFIXED_CHARSET = 1863;
    public static final short ZHT16DBCSFIXED_CHARSET = 1864;
    public static final short ZHT16BIG5FIXED_CHARSET = 1865;
    public static final short AL16UTF16_CHARSET = 2000;
    public static final short AL16UTF16LE_CHARSET = 2002;
    public static final short UNICODE_2_CHARSET = 871;
    private int oracleId;
    int rep;
    static CharacterSetFactory factory = new CharacterSetFactoryDefault();

}
