// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OpaqueDescriptor.java

package oracle.sql;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.Map;
import oracle.jdbc.OracleConnection;
import oracle.jdbc.dbaccess.DBError;
import oracle.jdbc.oracore.OracleNamedType;
import oracle.jdbc.oracore.OracleTypeADT;
import oracle.jdbc.oracore.OracleTypeOPAQUE;

// Referenced classes of package oracle.sql:
//            TypeDescriptor, SQLName, OPAQUE

public class OpaqueDescriptor extends TypeDescriptor
    implements Serializable
{

    public static OpaqueDescriptor createDescriptor(String s, Connection connection)
        throws SQLException
    {
        if(s == null || s.length() == 0 || connection == null)
            DBError.check_error(60, "Invalid arguments");
        SQLName sqlname = new SQLName(s, (OracleConnection)connection);
        String s1 = sqlname.getName();
        OpaqueDescriptor opaquedescriptor = (OpaqueDescriptor)((OracleConnection)connection).getDescriptor(s1);
        if(opaquedescriptor == null)
        {
            opaquedescriptor = new OpaqueDescriptor(sqlname, connection);
            ((OracleConnection)connection).putDescriptor(s1, opaquedescriptor);
        }
        return opaquedescriptor;
    }

    public OpaqueDescriptor(String s, Connection connection)
        throws SQLException
    {
        super(s, connection);
        initPickler();
    }

    public OpaqueDescriptor(SQLName sqlname, Connection connection)
        throws SQLException
    {
        super(sqlname, connection);
        initPickler();
    }

    public OpaqueDescriptor(SQLName sqlname, OracleTypeOPAQUE oracletypeopaque, Connection connection)
        throws SQLException
    {
        super(sqlname, oracletypeopaque, connection);
    }

    private void initPickler()
        throws SQLException
    {
        try
        {
            m_pickler = new OracleTypeADT(getName(), m_conn);
            ((OracleTypeADT)m_pickler).init((oracle.jdbc.driver.OracleConnection)m_conn);
            m_pickler = (OracleTypeOPAQUE)((OracleTypeADT)m_pickler).cleanup();
            m_pickler.setDescriptor(this);
        }
        catch(Exception exception)
        {
            if(exception instanceof SQLException)
                throw (SQLException)exception;
            DBError.throwSqlException(60, "Unable to resolve type \"" + getName() + "\"");
        }
    }

    public OpaqueDescriptor(OracleTypeADT oracletypeadt, Connection connection)
        throws SQLException
    {
        super(oracletypeadt, connection);
    }

    byte[] toBytes(OPAQUE opaque, boolean flag)
        throws SQLException
    {
        byte abyte0[] = null;
        if(opaque.shareBytes() != null)
            abyte0 = opaque.shareBytes();
        else
            try
            {
                abyte0 = m_pickler.linearize(opaque);
            }
            finally
            {
                if(!flag)
                    opaque.setShareBytes(null);
            }
        return abyte0;
    }

    byte[] toValue(OPAQUE opaque, boolean flag)
        throws SQLException
    {
        byte abyte0[] = null;
        if(opaque.m_value != null)
            abyte0 = opaque.m_value;
        else
            try
            {
                m_pickler.unlinearize(opaque.shareBytes(), 0L, opaque, 1, null);
                abyte0 = opaque.m_value;
            }
            finally
            {
                if(!flag)
                    opaque.m_value = null;
            }
        return abyte0;
    }

    public int getTypeCode()
    {
        return 2007;
    }

    public long getMaxLength()
        throws SQLException
    {
        long l = hasUnboundedSize() ? 0L : ((OracleTypeOPAQUE)m_pickler).getMaxLength();
        return l;
    }

    public boolean isTrustedLibrary()
        throws SQLException
    {
        return ((OracleTypeOPAQUE)m_pickler).isTrustedLibrary();
    }

    public boolean isModeledInC()
        throws SQLException
    {
        return ((OracleTypeOPAQUE)m_pickler).isModeledInC();
    }

    public boolean hasUnboundedSize()
        throws SQLException
    {
        return ((OracleTypeOPAQUE)m_pickler).isUnboundedSized();
    }

    public boolean hasFixedSize()
        throws SQLException
    {
        return ((OracleTypeOPAQUE)m_pickler).isFixedSized();
    }

    public String descType()
        throws SQLException
    {
        StringBuffer stringbuffer = new StringBuffer();
        String s = descType(stringbuffer, 0);
        return s;
    }

    String descType(StringBuffer stringbuffer, int i)
        throws SQLException
    {
        String s = "";
        for(int j = 0; j < i; j++)
            s = s + "  ";

        String s1 = s + "  ";
        stringbuffer.append(s);
        stringbuffer.append(getTypeName());
        stringbuffer.append(" maxLen=" + getMaxLength() + " isTrusted=" + isTrustedLibrary() + " hasUnboundedSize=" + hasUnboundedSize() + " hasFixedSize=" + hasFixedSize());
        stringbuffer.append("\n");
        String s2 = stringbuffer.toString();
        return s2;
    }

    public Class getClass(Map map)
        throws SQLException
    {
        Class class1 = null;
        String s = getName();
        Class class2 = (Class)map.get(s);
        String s1 = getSchemaName();
        String s2 = getTypeName();
        if(class2 == null && m_conn.getUserName().equals(s1))
            class2 = (Class)map.get(s2);
        if(!SQLName.s_parseAllFormat)
        {
            class1 = class2;
        } else
        {
            if(class2 == null && m_conn.getUserName().equals(s1))
                class2 = (Class)map.get("\"" + s2 + "\"");
            if(class2 == null)
                class2 = (Class)map.get("\"" + s1 + "\"" + "." + "\"" + s2 + "\"");
            if(class2 == null)
                class2 = (Class)map.get("\"" + s1 + "\"" + "." + s2);
            if(class2 == null)
                class2 = (Class)map.get(s1 + "." + "\"" + s2 + "\"");
            class1 = class2;
        }
        return class1;
    }

    private void writeObject(ObjectOutputStream objectoutputstream)
        throws IOException
    {
    }

    private void readObject(ObjectInputStream objectinputstream)
        throws IOException, ClassNotFoundException
    {
    }

    static final boolean DEBUG = false;
    static final long serialVersionUID = 0xe122c1707c9af97L;
}
