// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleJdbc2SQLInput.java

package oracle.sql;

import java.io.InputStream;
import java.io.Reader;
import java.math.BigDecimal;
import java.net.URL;
import java.sql.*;
import java.util.Map;
import oracle.jdbc.OracleConnection;
import oracle.jdbc.dbaccess.DBError;

// Referenced classes of package oracle.sql:
//            RAW, Datum, STRUCT, NUMBER, 
//            CHAR, DATE, BFILE, BLOB, 
//            CLOB, REF, ROWID, ARRAY

public class OracleJdbc2SQLInput
    implements SQLInput
{

    public OracleJdbc2SQLInput(Datum adatum[], Map map1, OracleConnection oracleconnection)
    {
        attributes = adatum;
        map = map1;
        conn = oracleconnection;
        index = 0;
    }

    public String readString()
        throws SQLException
    {
        String s = null;
        try
        {
            if(attributes[index] != null)
                s = attributes[index].stringValue();
        }
        finally
        {
            index++;
        }
        return s;
    }

    public boolean readBoolean()
        throws SQLException
    {
        boolean flag = false;
        try
        {
            if(attributes[index] != null)
                flag = attributes[index].booleanValue();
        }
        finally
        {
            index++;
        }
        return flag;
    }

    public byte readByte()
        throws SQLException
    {
        byte byte0 = 0;
        try
        {
            if(attributes[index] != null)
                byte0 = attributes[index].byteValue();
        }
        finally
        {
            index++;
        }
        return byte0;
    }

    public short readShort()
        throws SQLException
    {
        long l = readLong();
        if(l > 0x10001L || l < 0xfffffffffffefffeL)
            DBError.check_error(26, "readShort");
        short word0 = (short)(int)l;
        return word0;
    }

    public int readInt()
        throws SQLException
    {
        int i = 0;
        try
        {
            if(attributes[index] != null)
                i = attributes[index].intValue();
        }
        finally
        {
            index++;
        }
        return i;
    }

    public long readLong()
        throws SQLException
    {
        long l = 0L;
        try
        {
            if(attributes[index] != null)
                l = attributes[index].longValue();
        }
        finally
        {
            index++;
        }
        return l;
    }

    public float readFloat()
        throws SQLException
    {
        float f = 0.0F;
        try
        {
            if(attributes[index] != null)
                f = attributes[index].floatValue();
        }
        finally
        {
            index++;
        }
        return f;
    }

    public double readDouble()
        throws SQLException
    {
        double d = 0.0D;
        try
        {
            if(attributes[index] != null)
                d = attributes[index].doubleValue();
        }
        finally
        {
            index++;
        }
        return d;
    }

    public BigDecimal readBigDecimal()
        throws SQLException
    {
        BigDecimal bigdecimal = null;
        try
        {
            if(attributes[index] != null)
                bigdecimal = attributes[index].bigDecimalValue();
        }
        finally
        {
            index++;
        }
        return bigdecimal;
    }

    public byte[] readBytes()
        throws SQLException
    {
        byte abyte0[] = null;
        try
        {
            if(attributes[index] != null)
                if(attributes[index] instanceof RAW)
                    abyte0 = ((RAW)attributes[index]).shareBytes();
                else
                    DBError.check_error(4, null);
        }
        finally
        {
            index++;
        }
        return abyte0;
    }

    public Date readDate()
        throws SQLException
    {
        Date date = null;
        try
        {
            if(attributes[index] != null)
                date = attributes[index].dateValue();
        }
        finally
        {
            index++;
        }
        return date;
    }

    public Time readTime()
        throws SQLException
    {
        Time time = null;
        try
        {
            if(attributes[index] != null)
                time = attributes[index].timeValue();
        }
        finally
        {
            index++;
        }
        return time;
    }

    public Timestamp readTimestamp()
        throws SQLException
    {
        Timestamp timestamp = null;
        try
        {
            if(attributes[index] != null)
                timestamp = attributes[index].timestampValue();
        }
        finally
        {
            index++;
        }
        return timestamp;
    }

    public Reader readCharacterStream()
        throws SQLException
    {
        Reader reader = null;
        try
        {
            Datum datum = attributes[index];
            if(datum != null)
                reader = datum.characterStreamValue();
        }
        finally
        {
            index++;
        }
        return reader;
    }

    public InputStream readAsciiStream()
        throws SQLException
    {
        InputStream inputstream = null;
        try
        {
            Datum datum = attributes[index];
            if(datum != null)
                inputstream = datum.asciiStreamValue();
        }
        finally
        {
            index++;
        }
        return inputstream;
    }

    public InputStream readBinaryStream()
        throws SQLException
    {
        InputStream inputstream = null;
        try
        {
            Datum datum = attributes[index];
            if(datum != null)
                inputstream = datum.binaryStreamValue();
        }
        finally
        {
            index++;
        }
        return inputstream;
    }

    public Object readObject()
        throws SQLException
    {
        Datum datum = (Datum)readOracleObject();
        if(datum != null)
        {
            if(datum instanceof STRUCT)
                return ((STRUCT)datum).toJdbc(map);
            datum.toJdbc();
        }
        return null;
    }

    public Ref readRef()
        throws SQLException
    {
        return readREF();
    }

    public Blob readBlob()
        throws SQLException
    {
        return readBLOB();
    }

    public Clob readClob()
        throws SQLException
    {
        return readCLOB();
    }

    public Array readArray()
        throws SQLException
    {
        return readARRAY();
    }

    public Struct readStruct()
        throws SQLException
    {
        return readSTRUCT();
    }

    public boolean wasNull()
        throws SQLException
    {
        if(index == 0)
            DBError.throwSqlException(24);
        boolean flag = attributes[index - 1] == null;
        return flag;
    }

    public Object readOracleObject()
        throws SQLException
    {
        Datum datum = attributes[index++];
        return datum;
    }

    public NUMBER readNUMBER()
        throws SQLException
    {
        NUMBER number = null;
        try
        {
            if(attributes[index] != null)
                if(attributes[index] instanceof NUMBER)
                    number = (NUMBER)attributes[index];
                else
                    DBError.check_error(4, null);
        }
        finally
        {
            index++;
        }
        return number;
    }

    public CHAR readCHAR()
        throws SQLException
    {
        CHAR char1 = null;
        try
        {
            if(attributes[index] != null)
                if(attributes[index] instanceof CHAR)
                    char1 = (CHAR)attributes[index];
                else
                    DBError.check_error(4, null);
        }
        finally
        {
            index++;
        }
        return char1;
    }

    public DATE readDATE()
        throws SQLException
    {
        DATE date = null;
        try
        {
            if(attributes[index] != null)
                if(attributes[index] instanceof DATE)
                    date = (DATE)attributes[index];
                else
                    DBError.check_error(4, null);
        }
        finally
        {
            index++;
        }
        return date;
    }

    public BFILE readBFILE()
        throws SQLException
    {
        BFILE bfile = null;
        try
        {
            if(attributes[index] != null)
                if(attributes[index] instanceof BFILE)
                    bfile = (BFILE)attributes[index];
                else
                    DBError.check_error(4, null);
        }
        finally
        {
            index++;
        }
        return bfile;
    }

    public BLOB readBLOB()
        throws SQLException
    {
        BLOB blob = null;
        try
        {
            if(attributes[index] != null)
                if(attributes[index] instanceof BLOB)
                    blob = (BLOB)attributes[index];
                else
                    DBError.check_error(4, null);
        }
        finally
        {
            index++;
        }
        return blob;
    }

    public CLOB readCLOB()
        throws SQLException
    {
        CLOB clob = null;
        try
        {
            if(attributes[index] != null)
                if(attributes[index] instanceof CLOB)
                    clob = (CLOB)attributes[index];
                else
                    DBError.check_error(4, null);
        }
        finally
        {
            index++;
        }
        return clob;
    }

    public RAW readRAW()
        throws SQLException
    {
        RAW raw = null;
        try
        {
            if(attributes[index] != null)
                if(attributes[index] instanceof RAW)
                    raw = (RAW)attributes[index];
                else
                    DBError.check_error(4, null);
        }
        finally
        {
            index++;
        }
        return raw;
    }

    public REF readREF()
        throws SQLException
    {
        REF ref = null;
        try
        {
            if(attributes[index] != null)
                if(attributes[index] instanceof REF)
                    ref = (REF)attributes[index];
                else
                    DBError.check_error(4, null);
        }
        finally
        {
            index++;
        }
        return ref;
    }

    public ROWID readROWID()
        throws SQLException
    {
        ROWID rowid = null;
        try
        {
            if(attributes[index] != null)
                if(attributes[index] instanceof ROWID)
                    rowid = (ROWID)attributes[index];
                else
                    DBError.check_error(4, null);
        }
        finally
        {
            index++;
        }
        return rowid;
    }

    public ARRAY readARRAY()
        throws SQLException
    {
        ARRAY array = null;
        try
        {
            if(attributes[index] != null)
                if(attributes[index] instanceof ARRAY)
                    array = (ARRAY)attributes[index];
                else
                    DBError.check_error(4, null);
        }
        finally
        {
            index++;
        }
        return array;
    }

    public STRUCT readSTRUCT()
        throws SQLException
    {
        STRUCT struct = null;
        try
        {
            if(attributes[index] != null)
                if(attributes[index] instanceof STRUCT)
                    struct = (STRUCT)attributes[index];
                else
                    DBError.check_error(4, null);
        }
        finally
        {
            index++;
        }
        return struct;
    }

    public URL readURL()
        throws SQLException
    {
        DBError.throwUnsupportedFeatureSqlException();
        return null;
    }

    private int index;
    private Datum attributes[];
    private Map map;
    private OracleConnection conn;
}
