// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleSQLOutput.java

package oracle.sql;

import java.io.*;
import java.math.BigDecimal;
import java.net.URL;
import java.sql.*;
import oracle.jdbc.OracleConnection;
import oracle.jdbc.dbaccess.DBError;

// Referenced classes of package oracle.sql:
//            STRUCT, StructDescriptor, Datum, REF, 
//            BLOB, BFILE, CLOB, ARRAY, 
//            NUMBER, CHAR, DATE, RAW, 
//            ROWID

public class OracleSQLOutput
    implements SQLOutput
{

    public OracleSQLOutput(StructDescriptor structdescriptor, OracleConnection oracleconnection)
        throws SQLException
    {
        descriptor = structdescriptor;
        attributes = new Object[structdescriptor.getLength()];
        conn = oracleconnection;
        index = 0;
    }

    public STRUCT getSTRUCT()
        throws SQLException
    {
        return new STRUCT(descriptor, conn, attributes);
    }

    public void writeString(String s)
        throws SQLException
    {
        attributes[index++] = s;
    }

    public void writeBoolean(boolean flag)
        throws SQLException
    {
        attributes[index++] = new Boolean(flag);
    }

    public void writeByte(byte byte0)
        throws SQLException
    {
        attributes[index++] = new Integer(byte0);
    }

    public void writeShort(short word0)
        throws SQLException
    {
        attributes[index++] = new Integer(word0);
    }

    public void writeInt(int i)
        throws SQLException
    {
        attributes[index++] = new Integer(i);
    }

    public void writeLong(long l)
        throws SQLException
    {
        attributes[index++] = new Long(l);
    }

    public void writeFloat(float f)
        throws SQLException
    {
        attributes[index++] = new Float(f);
    }

    public void writeDouble(double d)
        throws SQLException
    {
        attributes[index++] = new Double(d);
    }

    public void writeBigDecimal(BigDecimal bigdecimal)
        throws SQLException
    {
        attributes[index++] = bigdecimal;
    }

    public void writeBytes(byte abyte0[])
        throws SQLException
    {
        attributes[index++] = abyte0;
    }

    public void writeDate(Date date)
        throws SQLException
    {
        attributes[index++] = date;
    }

    public void writeTime(Time time)
        throws SQLException
    {
        attributes[index++] = time;
    }

    public void writeTimestamp(Timestamp timestamp)
        throws SQLException
    {
        attributes[index++] = timestamp;
    }

    public void writeCharacterStream(Reader reader)
        throws SQLException
    {
        StringBuffer stringbuffer = new StringBuffer();
        char ac[] = new char[100];
        int i = 0;
        try
        {
            while((i = reader.read(ac)) != -1) 
                stringbuffer.append(ac, 0, i);
        }
        catch(IOException ioexception)
        {
            DBError.check_error(ioexception);
        }
        String s = stringbuffer.toString();
        attributes[index++] = s;
    }

    public void writeAsciiStream(InputStream inputstream)
        throws SQLException
    {
        StringBuffer stringbuffer = new StringBuffer();
        byte abyte0[] = new byte[100];
        char ac[] = new char[100];
        int i = 0;
        try
        {
            while((i = inputstream.read(abyte0)) != -1) 
            {
                for(int j = 0; j < i; j++)
                    ac[j] = (char)abyte0[j];

                stringbuffer.append(ac, 0, i);
            }
        }
        catch(IOException ioexception)
        {
            DBError.check_error(ioexception);
        }
        String s = stringbuffer.toString();
        attributes[index++] = s;
    }

    public void writeBinaryStream(InputStream inputstream)
        throws SQLException
    {
        writeAsciiStream(inputstream);
    }

    public void writeObject(SQLData sqldata)
        throws SQLException
    {
        STRUCT struct = null;
        if(sqldata != null)
        {
            StructDescriptor structdescriptor = StructDescriptor.createDescriptor(sqldata.getSQLTypeName(), conn);
            SQLOutput sqloutput = structdescriptor.toJdbc2SQLOutput();
            sqldata.writeSQL(sqloutput);
            struct = ((OracleSQLOutput)sqloutput).getSTRUCT();
        }
        writeStruct(struct);
    }

    public void writeObject(Object obj)
        throws SQLException
    {
        if(obj != null && (obj instanceof SQLData))
            writeObject((SQLData)obj);
        else
            attributes[index++] = obj;
    }

    public void writeRef(Ref ref)
        throws SQLException
    {
        attributes[index++] = ref;
    }

    public void writeBlob(Blob blob)
        throws SQLException
    {
        attributes[index++] = blob;
    }

    public void writeClob(Clob clob)
        throws SQLException
    {
        attributes[index++] = clob;
    }

    public void writeStruct(Struct struct)
        throws SQLException
    {
        attributes[index++] = struct;
    }

    public void writeArray(Array array)
        throws SQLException
    {
        attributes[index++] = array;
    }

    public void writeOracleObject(Datum datum)
        throws SQLException
    {
        attributes[index++] = datum;
    }

    public void writeRef(REF ref)
        throws SQLException
    {
        attributes[index++] = ref;
    }

    public void writeBlob(BLOB blob)
        throws SQLException
    {
        attributes[index++] = blob;
    }

    public void writeBfile(BFILE bfile)
        throws SQLException
    {
        attributes[index++] = bfile;
    }

    public void writeClob(CLOB clob)
        throws SQLException
    {
        attributes[index++] = clob;
    }

    public void writeStruct(STRUCT struct)
        throws SQLException
    {
        attributes[index++] = struct;
    }

    public void writeArray(ARRAY array)
        throws SQLException
    {
        attributes[index++] = array;
    }

    public void writeNUMBER(NUMBER number)
        throws SQLException
    {
        attributes[index++] = number;
    }

    public void writeCHAR(CHAR char1)
        throws SQLException
    {
        attributes[index++] = char1;
    }

    public void writeDATE(DATE date)
        throws SQLException
    {
        attributes[index++] = date;
    }

    public void writeRAW(RAW raw)
        throws SQLException
    {
        attributes[index++] = raw;
    }

    public void writeROWID(ROWID rowid)
        throws SQLException
    {
        attributes[index++] = rowid;
    }

    public void writeURL(URL url)
        throws SQLException
    {
        DBError.throwUnsupportedFeatureSqlException();
    }

    private StructDescriptor descriptor;
    private Object attributes[];
    private int index;
    private OracleConnection conn;
}
