// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   DBDataSetImpl.java

package oracle.jdbc.dbaccess;

import java.io.IOException;
import java.io.InputStream;
import java.sql.SQLException;
import oracle.jdbc.driver.*;
import oracle.jdbc.oracore.OracleType;
import oracle.jdbc.oracore.OracleTypeADT;
import oracle.sql.StructDescriptor;

// Referenced classes of package oracle.jdbc.dbaccess:
//            DBDataSet, DBData, DBItem, DBType, 
//            DBError, DBAccess, DBConversion

public class DBDataSetImpl extends DBDataSet
{

    private void init()
    {
        m_dynamic = false;
        m_first_row = true;
        m_noOfArgs = 0;
        data = null;
        types = null;
        m_cleanedData = false;
    }

    private void _transformToDynamic()
    {
        m_dynamic = true;
        m_arrayDepth = 0;
        if(!m_first_row)
        {
            _cleanData();
            for(int i = 0; i < types.length; i++)
                _allocData(i);

        }
    }

    private final void _allocData(int i)
    {
        if(data[i] != null)
        {
            return;
        } else
        {
            data[i] = m_dynamic ? new DBData() : new DBData(m_arrayDepth);
            return;
        }
    }

    private final void _allocDataAndItems(int i)
        throws SQLException
    {
        if(m_dynamic)
            DBError.throwSqlException(89);
        _allocData(i);
        _allocItemsAndBuffers(i);
    }

    private void _allocItemsAndBuffers(int i)
        throws SQLException
    {
        boolean flag = false;
        int k = data[i].getNItems();
        DBType dbtype = types[i];
        for(int j = 0; j < k; j++)
        {
            data[i].setItem(j, m_connection.db_access.createDBItem(dbtype));
            if(!dbtype.is_stream && dbtype.type != 109 && dbtype.type != 111)
                data[i].getItem(j).allocBuffer();
        }

    }

    public final void _cleanData()
    {
        if(data != null)
        {
            int j = data.length;
            for(int i = 0; i < j; i++)
                if(data[i] != null)
                {
                    data[i].cleanup();
                    data[i] = null;
                }

            m_cleanedData = true;
        }
    }

    public final DBItem _getDBItem(int i, int j)
        throws SQLException
    {
        if(data == null || data[i] == null)
            return null;
        else
            return data[i].getItem(j);
    }

    private final DBItem _getLastDBItem(int i)
        throws SQLException
    {
        if(data == null || data[i] == null)
            return null;
        if(m_dynamic)
        {
            int j = data[i].getNItems();
            if(j == 0)
                return null;
            else
                return data[i].getItem(j - 1);
        } else
        {
            return data[i].getItem(m_arrayDepth - 1);
        }
    }

    private final void _setDBItem(DBItem dbitem, int i, int j)
        throws SQLException
    {
        if(data[i] == null)
            DBError.throwSqlException(44);
        if(m_dynamic)
            data[i].addItem(dbitem);
        else
            data[i].setItem(j, dbitem);
    }

    private final DBType _getDBType(int i)
    {
        if(types != null && i >= 0 && i < types.length)
            return types[i];
        else
            return null;
    }

    private final void _setDBType(int i, DBType dbtype)
    {
        if(types != null && i >= 0 && i < types.length)
            types[i] = dbtype;
    }

    private void _alloc_tmp_binds(int i, boolean flag)
    {
        if(m_tmp_first_row_types == null)
        {
            int j = Math.max(i + 1, _MIN_ARG_COUNT);
            if(flag)
                m_tmp_first_row_items = new DBItem[j];
            m_tmp_first_row_types = new DBType[j];
        } else
        if(i >= m_tmp_first_row_types.length)
        {
            int k = m_tmp_first_row_types.length;
            k = Math.max(i + 1, k);
            if(flag)
            {
                DBItem adbitem[] = new DBItem[2 * k];
                System.arraycopy(m_tmp_first_row_items, 0, adbitem, 0, m_tmp_first_row_items.length);
                m_tmp_first_row_items = adbitem;
                adbitem = null;
            }
            DBType adbtype[] = new DBType[2 * k];
            System.arraycopy(m_tmp_first_row_types, 0, adbtype, 0, m_tmp_first_row_types.length);
            m_tmp_first_row_types = adbtype;
            adbtype = null;
        }
    }

    protected DBType _getBindDBType(int i)
    {
        DBType dbtype = null;
        if(m_first_row)
        {
            if(i + 1 > m_noOfArgs)
                m_noOfArgs = i + 1;
            _alloc_tmp_binds(i, true);
            dbtype = m_tmp_first_row_types[i];
        } else
        {
            dbtype = _getDBType(i);
        }
        return dbtype;
    }

    protected DBType _createOrGetBindDBType(int i, int j)
        throws SQLException
    {
        DBType dbtype = _getBindDBType(i);
        if(dbtype == null || dbtype.type != j)
        {
            newDBType = true;
            if(!m_sql_kind_cached)
            {
                m_sql_kind = m_statement.getSqlKind();
                m_sql_kind_cached = true;
            }
            if(m_sql_kind == 1)
                dbtype = m_connection.db_access.createDBType(j, m_dataSetType == 1, true);
            else
                dbtype = m_connection.db_access.createDBType(j, true, getFormOfUse(i));
        } else
        {
            newDBType = false;
        }
        return dbtype;
    }

    protected DBItem _createOrGetDBItem(int i, DBType dbtype, int j)
        throws SQLException
    {
        DBItem dbitem = null;
        if(m_first_row)
        {
            dbitem = m_connection.db_access.createDBItem(dbtype);
        } else
        {
            dbitem = _getDBItem(i, j);
            DBItem dbitem1 = null;
            if(j == 0)
                dbitem1 = _getLastDBItem(i);
            else
                dbitem1 = _getDBItem(i, j - 1);
            if(dbitem == null || dbitem1 != null && dbitem1.equals(dbitem))
                dbitem = m_connection.db_access.createDBItem(dbtype);
            else
                dbitem.reinitialize(dbtype.max_length);
        }
        return dbitem;
    }

    protected void _setBindDBItem(int i, DBItem dbitem)
    {
        if(m_first_row)
            m_tmp_first_row_items[i] = dbitem;
        else
            m_last_bind_values[i] = dbitem;
    }

    protected void _setBindDBType(int i, DBType dbtype)
    {
        dbtype.FormOfUse = getFormOfUse(i);
        if(dbtype.isNType())
            dbtype.ncs = m_connection.conversion.getNCharSet();
        else
            dbtype.ncs = m_connection.conversion.getDbCharSet();
        if(m_first_row)
        {
            if(m_tmp_first_row_types[i] == null)
                m_tmp_first_row_types[i] = dbtype;
        } else
        {
            _setDBType(i, dbtype);
        }
    }

    private final void _setRowItems(int i, DBItem dbitem)
        throws SQLException
    {
        if(m_dynamic)
            DBError.throwSqlException(89);
        data[i].setItem(0, dbitem);
        for(int j = 1; j < m_arrayDepth; j++)
        {
            DBItem dbitem1 = dbitem.clone(types[i], m_connection.db_access);
            data[i].setItem(j, dbitem1);
        }

    }

    private void _bindsRowCompleted(int i)
        throws SQLException
    {
        if(i == -1 && !m_dynamic)
            _transformToDynamic();
        if(m_first_row)
        {
            m_first_row = false;
            data = new DBData[m_noOfArgs];
            types = new DBType[m_noOfArgs];
            m_last_bind_values = new DBItem[m_noOfArgs];
            for(int j = 0; j < m_noOfArgs; j++)
                if(m_tmp_first_row_types != null && m_tmp_first_row_types[j] != null)
                {
                    types[j] = m_tmp_first_row_types[j];
                    if(m_dataSetType == 1)
                    {
                        m_last_bind_values[j] = m_tmp_first_row_items[j];
                        _allocData(j);
                    } else
                    {
                        _allocDataAndItems(j);
                    }
                }

            if(m_tmp_first_row_types != null)
            {
                for(int k = 0; k < m_tmp_first_row_types.length; k++)
                {
                    m_tmp_first_row_types[k] = null;
                    m_tmp_first_row_items[k] = null;
                }

                m_tmp_first_row_items = null;
                m_tmp_first_row_types = null;
            }
        }
        if(m_cleanedData)
        {
            for(int l = 0; l < m_noOfArgs; l++)
                if(types != null && types[l] != null)
                    if(m_dataSetType == 1)
                        _allocData(l);
                    else
                        _allocDataAndItems(l);

            m_cleanedData = false;
        }
        if(m_dataSetType == 1)
        {
            for(int i1 = 0; i1 < types.length; i1++)
                if(m_last_bind_values[i1] != null)
                    _setDBItem(m_last_bind_values[i1], i1, i);

        }
    }

    private void _definesRowCompleted()
        throws SQLException
    {
        m_first_row = false;
        if(!m_dynamic)
        {
            if(types == null)
                DBError.throwSqlException(21);
            if(types.length == 0)
                DBError.throwSqlException(21);
            int k = types.length;
            data = new DBData[k];
            for(int j = 0; j < k; j++)
                data[j] = new DBData(m_arrayDepth);

        }
        for(int i = 0; i < m_noOfArgs; i++)
        {
            DBType dbtype = types[i];
            DBItem dbitem = m_connection.db_access.createDBItem(dbtype);
            if(dbtype.type != 109 && dbtype.type != 111 && !dbtype.is_stream)
                dbitem.allocBuffer();
            _setRowItems(i, dbitem);
        }

    }

    private final void _createArrayFromTypes(int i)
        throws SQLException
    {
    }

    public DBDataSetImpl(OracleConnection oracleconnection, OracleStatement oraclestatement, int i, int j)
    {
        m_dynamic = false;
        m_arrayDepth = 0;
        m_cleanedData = false;
        m_last_bind_values = null;
        newDBType = false;
        m_tmp_first_row_items = null;
        m_tmp_first_row_types = null;
        form_of_use = null;
        init();
        m_connection = oracleconnection;
        m_statement = oraclestatement;
        m_arrayDepth = i;
        m_dataSetType = j;
    }

    public final boolean isDynamic()
    {
        return m_dynamic;
    }

    public int getNoOfArgs()
    {
        return m_noOfArgs;
    }

    public void setNoOfDefineCol(int i)
    {
        if(m_dynamic || m_dataSetType != 0)
            return;
        m_noOfArgs = i;
        DBType adbtype[] = types;
        types = new DBType[m_noOfArgs];
        if(adbtype != null)
        {
            int k = m_noOfArgs >= adbtype.length ? adbtype.length : m_noOfArgs;
            for(int j = 0; j < k; j++)
                types[j] = adbtype[j];

            adbtype = null;
        }
    }

    public boolean isStreamType(int i)
    {
        if(types != null && i < types.length && types[i] != null)
            return types[i].is_stream;
        else
            return false;
    }

    public boolean hasStreamType()
    {
        if(types != null)
        {
            for(int i = 0; i < types.length; i++)
                if(types[i] != null && types[i].is_stream)
                    return true;

        }
        return false;
    }

    public int getMissingType()
    {
        for(int i = 0; i < types.length; i++)
            if(types[i] == null)
                return i;

        return -1;
    }

    public final byte[] getBytesItem(int i, int j)
        throws SQLException
    {
        byte abyte0[] = null;
        if(data != null && data[i] != null)
        {
            DBItem dbitem = data[i].getItem(j);
            if(dbitem != null && !dbitem.is_null)
            {
                abyte0 = new byte[dbitem.data_size];
                System.arraycopy(dbitem.byte_value, 0, abyte0, 0, dbitem.data_size);
            }
        }
        return abyte0;
    }

    public final char[] getCharsItem(int i, int j, int ai[], short word0)
        throws SQLException
    {
        char ac[] = null;
        if(data != null && data[i] != null)
        {
            DBItem dbitem = data[i].getItem(j);
            if(dbitem != null && !dbitem.is_null)
            {
                dbitem.getChars(word0);
                ac = dbitem.char_value;
                ai[0] = dbitem.char_size;
            }
        }
        return ac;
    }

    public final InputStream getStreamItem(int i, int j)
        throws SQLException
    {
        if(data == null || data[i] == null)
            return null;
        DBItem dbitem = data[i].getItem(j);
        if(dbitem == null || dbitem.is_null)
            return null;
        try
        {
            if(((OracleInputStream)dbitem.stream_value).isClosed())
                DBError.throwSqlException(27);
            if(!((OracleInputStream)dbitem.stream_value).needBytes())
            {
                dbitem.setNull();
                return null;
            } else
            {
                return dbitem.stream_value;
            }
        }
        catch(IOException ioexception)
        {
            DBError.throwSqlException(ioexception);
        }
        return null;
    }

    public final char[] getCharsStreamItem(int i, int j, int ai[])
        throws SQLException
    {
        if(data == null || data[i] == null)
            return null;
        DBItem dbitem = data[i].getItem(j);
        if(dbitem == null || dbitem.is_null)
        {
            return null;
        } else
        {
            char ac[] = dbitem.getChars((short)1);
            ai[0] = dbitem.char_size;
            return ac;
        }
    }

    public final void setStreamItem(int i, int j, InputStream inputstream)
        throws SQLException
    {
        if(data == null || data[i] == null)
        {
            return;
        } else
        {
            data[i].getItem(j).stream_value = inputstream;
            return;
        }
    }

    public boolean dataAllocated(int i)
    {
        return data != null && i < data.length && data[i] != null;
    }

    public final byte[] getBytes(int i, int j)
        throws SQLException
    {
        if(data.length < i)
            return null;
        else
            return data[i].getItem(j).getBytes();
    }

    public final boolean isNull(int i, int j)
        throws SQLException
    {
        return data[i].getItem(j).is_null;
    }

    public final void setNull(int i, int j)
        throws SQLException
    {
        data[i].getItem(j).setNull();
    }

    public final int getType(int i)
    {
        if(types == null || i < 0 || types.length <= i || types[i] == null)
            return -1;
        else
            return types[i].type;
    }

    public final int getExternalType(int i)
    {
        if(types == null || i < 0 || types.length <= i || types[i] == null)
            return -1;
        else
            return types[i].external_type;
    }

    public final OracleType getOtype(int i)
    {
        if(types == null || types.length <= i || types[i] == null)
            return null;
        else
            return types[i].otype;
    }

    public final void setType(int i, int j, int k, short word0)
        throws SQLException
    {
        setType(i, j, 0, k, word0);
    }

    public void setType(int i, int j, int k, int l, short word0)
        throws SQLException
    {
        DBType dbtype = null;
        if(m_dataSetType == 0)
        {
            if(i + 1 > m_noOfArgs)
                setNoOfDefineCol(i + 1);
            dbtype = m_connection.db_access.createDBType(j, false);
            if(j == 96 || j == 1 || j == 999)
            {
                if(l > 0)
                    dbtype.setMaxSize(l);
            } else
            if(l > 0 && l < dbtype.max_length)
                dbtype.max_length = l;
            dbtype.FormOfUse = word0;
            if(dbtype.isNType())
                dbtype.ncs = m_connection.conversion.getNCharSet();
            else
                dbtype.ncs = m_connection.conversion.getDbCharSet();
            _setDBType(i, dbtype);
        } else
        {
            dbtype = _createOrGetBindDBType(i, j);
            if(l > 0 && l < dbtype.max_length)
                dbtype.max_length = l;
            _setBindDBType(i, dbtype);
            if(m_dataSetType == 2 && !m_first_row)
                _allocDataAndItems(i);
        }
        dbtype.setExternalType(k);
    }

    public final void setType(int i, int j, OracleType oracletype)
        throws SQLException
    {
        if(m_dataSetType == 0)
        {
            if(i + 1 > m_noOfArgs)
                setNoOfDefineCol(i + 1);
            DBType dbtype = m_connection.db_access.createDBType(j, false);
            dbtype.otype = oracletype;
            _setDBType(i, dbtype);
        } else
        {
            DBType dbtype1 = _createOrGetBindDBType(i, j);
            dbtype1.otype = oracletype;
            _setBindDBType(i, dbtype1);
        }
    }

    public final void clearItems()
    {
        if(m_first_row && m_tmp_first_row_items != null)
        {
            for(int j = 0; j < m_noOfArgs; j++)
                m_tmp_first_row_items[j] = null;

        } else
        {
            for(int k = 0; k < m_noOfArgs; k++)
                m_last_bind_values[k] = null;

            if(data == null)
                return;
            for(int i = 0; i < data.length; i++)
                if(data[i] != null)
                    data[i].clearItems();

            m_cleanedData = true;
        }
    }

    public final void cleanup()
    {
        cleanTypes();
        cleanData();
        data = null;
        boolean flag = false;
        m_last_bind_values = null;
        if(m_tmp_first_row_items != null)
        {
            int k = m_tmp_first_row_items.length;
            for(int i = 0; i < k; i++)
                m_tmp_first_row_items[i] = null;

            m_tmp_first_row_items = null;
        }
        if(m_tmp_first_row_types != null)
        {
            int l = m_tmp_first_row_types.length;
            for(int j = 0; j < l; j++)
                m_tmp_first_row_types[j] = null;

            m_tmp_first_row_types = null;
        }
        init();
    }

    public final void cleanTypes()
    {
        if(types != null)
        {
            for(int i = 0; i < types.length; i++)
                types[i] = null;

        }
        types = null;
        m_noOfArgs = 0;
    }

    public final void cleanData()
    {
        if(m_last_bind_values != null)
        {
            int j = m_last_bind_values.length;
            for(int i = 0; i < j; i++)
                if(m_last_bind_values[i] != null)
                    m_last_bind_values[i] = null;

        }
        _cleanData();
    }

    public void setBatchSize(int i)
        throws SQLException
    {
        if(i == m_arrayDepth)
            return;
        m_arrayDepth = i;
        if(m_first_row || m_dynamic)
            return;
        if(data != null && types != null)
        {
            int j = data.length;
            for(int k = 0; k < j; k++)
            {
                DBType dbtype = types[k];
                if(data[k] == null)
                {
                    data[k] = new DBData(m_arrayDepth);
                } else
                {
                    DBData dbdata = data[k];
                    int j1 = dbdata.getNItems();
                    int k1 = j1 >= i ? i : j1;
                    data[k] = new DBData(i);
                    for(int l = 0; l < k1; l++)
                        data[k].setItem(l, dbdata.getItem(l));

                    int l1 = -1;
                    DBItem dbitem = dbdata.getItem(0);
                    if(dbitem != null && dbitem.byte_value != null)
                        l1 = dbitem.byte_value.length;
                    for(int i1 = k1; i1 < i; i1++)
                    {
                        DBItem dbitem1 = m_connection.db_access.createDBItem(dbtype);
                        if(l1 == -1)
                            dbitem1.allocBuffer();
                        else
                            dbitem1.allocBuffer(l1);
                        data[k].setItem(i1, dbitem1);
                    }

                }
            }

        }
    }

    public void rowCompleted(int i)
        throws SQLException
    {
        if(m_dataSetType == 0)
            _definesRowCompleted();
        else
            _bindsRowCompleted(i);
    }

    public boolean setBytesBindItem(int i, int j, int k, byte abyte0[])
        throws SQLException
    {
        DBType dbtype = _createOrGetBindDBType(i, k);
        DBItem dbitem = _createOrGetDBItem(i, dbtype, j);
        boolean flag = newDBType;
        if(abyte0 == null)
        {
            dbitem.setNull();
        } else
        {
            if(dbtype.max_length < abyte0.length)
            {
                dbtype.max_length = abyte0.length;
                flag = true;
            }
            dbitem.setArrayData(false, abyte0);
        }
        _setBindDBType(i, dbtype);
        _setBindDBItem(i, dbitem);
        return flag;
    }

    public boolean setBytesBindItem(int i, int j, int k, String s)
        throws SQLException
    {
        DBType dbtype = _createOrGetBindDBType(i, k);
        DBItem dbitem = _createOrGetDBItem(i, dbtype, j);
        boolean flag = newDBType;
        if(s == null)
        {
            dbitem.setNull();
        } else
        {
            dbitem.setArrayData(false, s, getFormOfUse(i));
            if(dbtype.max_length < dbitem.byte_value.length)
            {
                dbtype.max_length = dbitem.byte_value.length;
                flag = true;
            }
        }
        _setBindDBType(i, dbtype);
        _setBindDBItem(i, dbitem);
        return flag;
    }

    public void setStreamBindItem(int i, int j, int k, InputStream inputstream, int l)
        throws SQLException
    {
        DBType dbtype = _createOrGetBindDBType(i, k);
        DBItem dbitem = _createOrGetDBItem(i, dbtype, j);
        dbitem.setStreamData(false, l, inputstream);
        _setBindDBType(i, dbtype);
        _setBindDBItem(i, dbitem);
    }

    public boolean setNullADTBindItem(int i, int j, int k, OracleType oracletype)
        throws SQLException
    {
        boolean flag = false;
        DBType dbtype = _createOrGetBindDBType(i, k);
        DBItem dbitem = _createOrGetDBItem(i, dbtype, j);
        ((OracleTypeADT)oracletype).getTOID();
        if(!oracletype.isInHierarchyOf(dbtype.otype))
        {
            flag = true;
            dbtype.otype = oracletype;
        }
        dbtype.max_length = 0;
        dbitem.setNull();
        _setBindDBType(i, dbtype);
        _setBindDBItem(i, dbitem);
        return flag;
    }

    public void setNullBindItem(int i, int j, int k)
        throws SQLException
    {
        DBType dbtype = _createOrGetBindDBType(i, k);
        DBItem dbitem = _createOrGetDBItem(i, dbtype, j);
        dbitem.setNull();
        _setBindDBType(i, dbtype);
        _setBindDBItem(i, dbitem);
    }

    public void setADTBindType(int i, int j, int k, OracleType oracletype)
        throws SQLException
    {
        DBType dbtype = _createOrGetBindDBType(i, k);
        DBItem dbitem = _createOrGetDBItem(i, dbtype, j);
        ((OracleTypeADT)oracletype).getTOID();
        dbtype.max_length = 0;
        dbtype.otype = oracletype;
        _setBindDBType(i, dbtype);
        _setBindDBItem(i, null);
    }

    public boolean setADTBindItem(int i, int j, int k, byte abyte0[], OracleType oracletype)
        throws SQLException
    {
        boolean flag = false;
        DBType dbtype = _createOrGetBindDBType(i, k);
        DBItem dbitem = _createOrGetDBItem(i, dbtype, j);
        ((OracleTypeADT)oracletype).getTOID();
        dbtype.max_length = abyte0.length;
        if(!oracletype.isInHierarchyOf(dbtype.otype))
        {
            flag = true;
            dbtype.otype = oracletype;
        }
        dbitem.setArrayData(false, abyte0);
        _setBindDBType(i, dbtype);
        _setBindDBItem(i, dbitem);
        return flag;
    }

    public int checkBindTypes(DBDataSet dbdataset, int i, int j)
        throws SQLException
    {
        if(i < 0)
            DBError.throwSqlException(3);
        if(m_first_row)
            return 0;
        if(types != null && types.length > i)
        {
            DBType dbtype = _getDBType(i);
            if(dbtype != null && (dbtype.type != j || dbtype.max_length == 0 && !m_statement.isColumnSetNull(i + 1)))
                return -1;
        }
        DBDataSetImpl dbdatasetimpl = (DBDataSetImpl)dbdataset;
        if(dbdatasetimpl != null && dbdatasetimpl.types != null && dbdatasetimpl.types.length > i)
        {
            DBType dbtype1 = dbdatasetimpl._getDBType(i);
            if(dbtype1 != null && dbtype1.type != j && (dbtype1.type != 96 || j != 1) && (dbtype1.type != 1 || j != 96))
                DBError.throwSqlException(12);
        }
        return 0;
    }

    public int checkBindObjectTypes(DBDataSet dbdataset, int i, int j, StructDescriptor structdescriptor)
        throws SQLException
    {
        if(i < 0)
            DBError.throwSqlException(3);
        if(m_first_row)
            return 0;
        if(types != null && types.length > i)
        {
            DBType dbtype = _getDBType(i);
            if(dbtype != null && (dbtype.type != j || dbtype.max_length == 0 && !m_statement.isColumnSetNull(i + 1) || !dbtype.otype.isInHierarchyOf(structdescriptor)))
                return -1;
        }
        DBDataSetImpl dbdatasetimpl = (DBDataSetImpl)dbdataset;
        if(dbdatasetimpl != null && dbdatasetimpl.types != null && dbdatasetimpl.types.length > i)
        {
            DBType dbtype1 = dbdatasetimpl._getDBType(i);
            if(dbtype1 != null && dbtype1.type != j && (dbtype1.type != 96 || j != 1) && (dbtype1.type != 1 || j != 96))
                DBError.throwSqlException(12);
        }
        return 0;
    }

    public int checkBindsInAndOut(DBDataSet dbdataset, int i)
        throws SQLException
    {
        DBDataSetImpl dbdatasetimpl = (DBDataSetImpl)dbdataset;
        int j = 0;
        if(types != null)
            j = types.length;
        if(dbdatasetimpl != null && dbdatasetimpl.types != null && dbdatasetimpl.types.length > j)
            j = dbdatasetimpl.types.length;
        for(int k = 0; k < j; k++)
            if((data == null || k >= data.length || data[k] == null || data[k].getItem(i) == null) && (dbdatasetimpl == null || dbdatasetimpl.data == null || k >= dbdatasetimpl.data.length || dbdatasetimpl.data[k] == null || dbdatasetimpl.data[k].getItem(i) == null))
                return k;

        return -1;
    }

    public void removeFirstRow()
        throws SQLException
    {
        if(data != null)
        {
            for(int i = 0; i < data.length; i++)
                data[i].removeFirstItem();

        }
    }

    public void prependRowidColumn()
        throws SQLException
    {
        m_noOfArgs++;
        DBType adbtype[] = new DBType[m_noOfArgs];
        adbtype[0] = m_connection.db_access.createDBType(104, false);
        System.arraycopy(types, 0, adbtype, 1, types.length);
        types = adbtype;
    }

    public void removeRowidColumn()
        throws SQLException
    {
        m_noOfArgs--;
        DBType adbtype[] = new DBType[m_noOfArgs];
        System.arraycopy(types, 1, adbtype, 0, types.length - 1);
        types = adbtype;
    }

    public void enterCache()
        throws SQLException
    {
        if(m_dataSetType != 0)
        {
            cleanData();
            setFirstRow(true);
        } else
        if(m_statement.columns_defined_by_user)
            cleanTypes();
    }

    public void reactivate()
        throws SQLException
    {
    }

    public DBType[] getDBTypes()
    {
        return types;
    }

    public DBData[] getDBData()
    {
        return data;
    }

    public final String getInfoString()
        throws SQLException
    {
        StringBuffer stringbuffer = new StringBuffer("");
        stringbuffer.append(this + "\n" + "  DBDataSetImpl.m_dynamic=" + m_dynamic + "\n" + "  DBDataSetImpl.m_arrayDepth=" + m_arrayDepth + " (valid only when m_dynamic=false)\n");
        stringbuffer.append("  DBDataSetImpl.m_dataSetType=" + m_dataSetType + "\n");
        stringbuffer.append("  DBDataSetImpl.m_noOfArgs=" + m_noOfArgs + "\n");
        if(types == null)
        {
            stringbuffer.append("  DBDataSetImpl.types is null");
        } else
        {
            stringbuffer.append("  DBDataSetImpl.types.length=" + types.length);
            for(int i = 0; i < types.length; i++)
                if(types[i] == null)
                    stringbuffer.append("\n    types[" + i + "]=null");
                else
                    stringbuffer.append("\n    types[" + i + "].type=" + DBType.getStringType(types[i].type) + " (max_length=" + types[i].max_length + ")");

        }
        stringbuffer.append("\n");
        if(data == null)
        {
            stringbuffer.append("  DBDataSetImpl.data is null");
        } else
        {
            stringbuffer.append("  DBDataSetImpl.data.length=" + data.length);
            for(int j = 0; j < data.length; j++)
                if(data[j] == null)
                {
                    stringbuffer.append("\n    data[" + j + "]=null");
                } else
                {
                    for(int k = 0; k < data[j].getNItems(); k++)
                    {
                        DBItem dbitem = data[j].getItem(k);
                        if(dbitem == null)
                        {
                            stringbuffer.append("\n    data[" + j + "].items[" + k + "]=null");
                        } else
                        {
                            stringbuffer.append("\n    data[" + j + "].items[" + k + "] has " + dbitem.data_size + " bytes:\n");
                            if(dbitem.byte_value != null)
                            {
                                stringbuffer.append("\n    data[" + j + "].items[" + k + "] has " + dbitem.byte_value.length + " bytes allocated\n");
                                stringbuffer.append(OracleLog.bytesToFormattedStr(dbitem.byte_value, dbitem.data_size, "    "));
                            }
                        }
                    }

                }

        }
        if(m_last_bind_values == null)
            stringbuffer.append("  DBDataSetImpl.m_last_bind_values is null\n");
        else
            stringbuffer.append("  DBDataSetImpl.m_last_bind_values has size of " + m_last_bind_values.length + "\n");
        if(m_tmp_first_row_items == null)
            stringbuffer.append("  DBDataSetImpl.m_tmp_first_row_items is null\n");
        else
            stringbuffer.append("  DBDataSetImpl.m_tmp_first_row_items has size of " + m_tmp_first_row_items.length + "\n");
        if(m_tmp_first_row_types == null)
            stringbuffer.append("  DBDataSetImpl.m_tmp_first_row_types is null\n");
        else
            stringbuffer.append("  DBDataSetImpl.m_tmp_first_row_types has size of " + m_tmp_first_row_types.length + "\n");
        return stringbuffer.toString();
    }

    public short getFormOfUse(int i)
    {
        if(form_of_use == null)
            return 1;
        if(form_of_use.length <= i)
            return 1;
        if(form_of_use[i] == 0)
            return 1;
        else
            return form_of_use[i];
    }

    public void setFormOfUse(int i, short word0)
    {
        int j = i - 1;
        if(form_of_use == null)
        {
            int k = Math.max(j + 1, _MIN_ARG_COUNT);
            form_of_use = new short[k];
        } else
        if(j >= form_of_use.length)
        {
            int l = form_of_use.length;
            l = Math.max(j + 1, l);
            short aword0[] = new short[2 * l];
            System.arraycopy(form_of_use, 0, aword0, 0, form_of_use.length);
            form_of_use = aword0;
            aword0 = null;
        }
        form_of_use[j] = word0;
        if(m_dataSetType == 2)
        {
            DBType dbtype = _getBindDBType(j);
            if(dbtype != null)
                _setBindDBType(j, dbtype);
        }
    }

    public void setFirstRow(boolean flag)
    {
        m_first_row = flag;
    }

    public void clearItem(int i, boolean flag)
    {
        if(!flag && m_first_row && m_tmp_first_row_items != null)
        {
            for(int j = 0; j < m_noOfArgs; j++)
                m_tmp_first_row_items[j] = null;

        } else
        {
            if(data == null)
                return;
            if(!flag)
            {
                for(int k = 0; k < m_last_bind_values.length; k++)
                    m_last_bind_values[k] = null;

            }
            for(int l = 0; l < data.length && data[l] != null; l++)
                data[l].clearItem(i);

            m_cleanedData = true;
        }
    }

    private static int _MIN_ARG_COUNT = 1;
    private static final boolean DEBUG = false;
    protected OracleConnection m_connection;
    protected OracleStatement m_statement;
    private boolean m_dynamic;
    private int m_arrayDepth;
    private boolean m_cleanedData;
    private byte m_sql_kind;
    private boolean m_sql_kind_cached;
    private int m_noOfArgs;
    protected int m_dataSetType;
    protected DBData data[];
    protected DBType types[];
    private DBItem m_last_bind_values[];
    private boolean newDBType;
    private DBItem m_tmp_first_row_items[];
    private DBType m_tmp_first_row_types[];
    protected boolean m_first_row;
    private short form_of_use[];

}
