// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleClobInputStream.java

package oracle.jdbc.driver;

import java.io.IOException;
import java.sql.SQLException;
import oracle.jdbc.dbaccess.DBAccess;
import oracle.jdbc.dbaccess.DBError;
import oracle.sql.CLOB;

// Referenced classes of package oracle.jdbc.driver:
//            OracleBufferedStream, OracleConnection

public class OracleClobInputStream extends OracleBufferedStream
{

    public OracleClobInputStream(CLOB clob)
        throws SQLException
    {
        this(clob, clob.getConnection().db_access.getDefaultStreamChunkSize(), 1L);
    }

    public OracleClobInputStream(CLOB clob, int i)
        throws SQLException
    {
        this(clob, i, 1L);
    }

    public OracleClobInputStream(CLOB clob, int i, long l)
        throws SQLException
    {
        super(i);
        if(clob == null || i <= 0 || l < 1L)
        {
            throw new IllegalArgumentException("Illegal Arguments");
        } else
        {
            m_lobOffset = l;
            m_clob = clob;
            m_markedByte = -1L;
            m_endOfStream = false;
            m_charBuf = new char[i];
            return;
        }
    }

    public boolean needBytes()
        throws IOException
    {
        ensureOpen();
        if(pos >= count)
        {
            if(!m_endOfStream)
                try
                {
                    count = m_clob.getChars(m_lobOffset, chunkSize, m_charBuf);
                    for(int i = 0; i < count; i++)
                        buf[i] = (byte)m_charBuf[i];

                    if(count < chunkSize)
                        m_endOfStream = true;
                    if(count > 0)
                    {
                        pos = 0;
                        m_lobOffset += count;
                        return true;
                    }
                }
                catch(SQLException sqlexception)
                {
                    DBError.SQLToIOException(sqlexception);
                }
            return false;
        } else
        {
            return true;
        }
    }

    protected void ensureOpen()
        throws IOException
    {
        try
        {
            if(closed)
                DBError.check_error(57, null);
        }
        catch(SQLException sqlexception)
        {
            DBError.SQLToIOException(sqlexception);
        }
    }

    public boolean markSupported()
    {
        return true;
    }

    public synchronized void mark(int i)
    {
        if(i < 0)
        {
            throw new IllegalArgumentException("Read-ahead limit < 0");
        } else
        {
            m_markedByte = (m_lobOffset - (long)count) + (long)pos;
            return;
        }
    }

    public synchronized void reset()
        throws IOException
    {
        ensureOpen();
        if(m_markedByte < 0L)
        {
            throw new IOException("Mark invalid or stream not marked.");
        } else
        {
            m_lobOffset = m_markedByte;
            pos = count;
            m_endOfStream = false;
            return;
        }
    }

    public long skip(long l)
        throws IOException
    {
        ensureOpen();
        long l1 = 0L;
        if((long)(count - pos) >= l)
        {
            pos += l;
            l1 += l;
        } else
        {
            l1 += count - pos;
            pos = count;
            try
            {
                long l2 = 0L;
                l2 = (m_clob.length() - m_lobOffset) + 1L;
                if(l2 >= l - l1)
                {
                    m_lobOffset += l - l1;
                    l1 += l - l1;
                } else
                {
                    m_lobOffset += l2;
                    l1 += l2;
                }
            }
            catch(SQLException sqlexception)
            {
                DBError.SQLToIOException(sqlexception);
            }
        }
        return l1;
    }

    protected long m_lobOffset;
    protected CLOB m_clob;
    protected long m_markedByte;
    protected boolean m_endOfStream;
    protected char m_charBuf[];
}
