// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleClobReader.java

package oracle.jdbc.driver;

import java.io.IOException;
import java.io.Reader;
import java.sql.SQLException;
import oracle.jdbc.dbaccess.*;
import oracle.sql.CLOB;

// Referenced classes of package oracle.jdbc.driver:
//            OracleConnection

public class OracleClobReader extends Reader
{

    public OracleClobReader(CLOB clob1)
        throws SQLException
    {
        this(clob1, clob1.getConnection().db_access.getDefaultStreamChunkSize() / 3);
    }

    public OracleClobReader(CLOB clob1, int i)
        throws SQLException
    {
        this(clob1, i, 1L);
    }

    public OracleClobReader(CLOB clob1, int i, long l)
        throws SQLException
    {
        if(clob1 == null || i <= 0 || clob1.getConnection() == null || l < 1L)
        {
            throw new IllegalArgumentException("Illegal Arguments");
        } else
        {
            db_access = clob1.getConnection().db_access;
            db_conversion = clob1.getConnection().conversion;
            clob = clob1;
            lob_offset = l;
            markedChar = -1L;
            buf = new char[i];
            pos = count = 0;
            chunkSize = i;
            isClosed = false;
            return;
        }
    }

    public int read(char ac[], int i, int j)
        throws IOException
    {
        ensureOpen();
        if(!needChars())
            return -1;
        int k = i;
        int l = k + Math.min(j, ac.length - i);
        for(k += writeChars(ac, k, l - k); k < l && needChars(); k += writeChars(ac, k, l - k));
        return k - i;
    }

    protected boolean needChars()
        throws IOException
    {
        ensureOpen();
        if(pos >= count)
        {
            if(!endOfStream)
                try
                {
                    count = clob.getChars(lob_offset, chunkSize, buf);
                    if(count < chunkSize)
                        endOfStream = true;
                    if(count > 0)
                    {
                        pos = 0;
                        lob_offset += count;
                        return true;
                    }
                }
                catch(SQLException sqlexception)
                {
                    DBError.SQLToIOException(sqlexception);
                }
            return false;
        } else
        {
            return true;
        }
    }

    protected int writeChars(char ac[], int i, int j)
    {
        int k = Math.min(j, count - pos);
        System.arraycopy(buf, pos, ac, i, k);
        pos += k;
        return k;
    }

    public boolean ready()
        throws IOException
    {
        ensureOpen();
        return pos < count;
    }

    public void close()
        throws IOException
    {
        isClosed = true;
    }

    void ensureOpen()
        throws IOException
    {
        try
        {
            if(isClosed)
                DBError.check_error(57, null);
        }
        catch(SQLException sqlexception)
        {
            DBError.SQLToIOException(sqlexception);
        }
    }

    public boolean markSupported()
    {
        return true;
    }

    public void mark(int i)
        throws IOException
    {
        if(i < 0)
        {
            throw new IllegalArgumentException("Read-ahead limit < 0");
        } else
        {
            markedChar = (lob_offset - (long)count) + (long)pos;
            return;
        }
    }

    public void reset()
        throws IOException
    {
        ensureOpen();
        if(markedChar < 0L)
        {
            throw new IOException("Mark invalid or stream not marked.");
        } else
        {
            lob_offset = markedChar;
            pos = count;
            endOfStream = false;
            return;
        }
    }

    public long skip(long l)
        throws IOException
    {
        ensureOpen();
        long l1 = 0L;
        if((long)(count - pos) >= l)
        {
            pos += l;
            l1 += l;
        } else
        {
            l1 += count - pos;
            pos = count;
            try
            {
                long l2 = (clob.length() - lob_offset) + 1L;
                if(l2 >= l - l1)
                {
                    lob_offset += l - l1;
                    l1 += l - l1;
                } else
                {
                    lob_offset += l2;
                    l1 += l2;
                }
            }
            catch(SQLException sqlexception)
            {
                DBError.SQLToIOException(sqlexception);
            }
        }
        return l1;
    }

    CLOB clob;
    DBAccess db_access;
    DBConversion db_conversion;
    long lob_offset;
    long markedChar;
    char buf[];
    int pos;
    int count;
    int chunkSize;
    boolean isClosed;
    boolean endOfStream;
}
