// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleClobWriter.java

package oracle.jdbc.driver;

import java.io.IOException;
import java.io.Writer;
import java.sql.SQLException;
import oracle.jdbc.dbaccess.*;
import oracle.sql.CLOB;

// Referenced classes of package oracle.jdbc.driver:
//            OracleConnection

public class OracleClobWriter extends Writer
{

    public OracleClobWriter(CLOB clob1)
        throws SQLException
    {
        this(clob1, clob1.getConnection().db_access.getDefaultStreamChunkSize() / 3, 1L);
    }

    public OracleClobWriter(CLOB clob1, int i)
        throws SQLException
    {
        this(clob1, i, 1L);
    }

    public OracleClobWriter(CLOB clob1, int i, long l)
        throws SQLException
    {
        if(clob1 == null || i <= 0 || clob1.getConnection() == null || l < 1L)
        {
            throw new IllegalArgumentException("Illegal Arguments");
        } else
        {
            db_access = clob1.getConnection().db_access;
            db_conversion = clob1.getConnection().conversion;
            clob = clob1;
            lob_offset = l;
            charBuf = new char[i];
            nativeBuf = new byte[i * 3];
            pos = count = 0;
            chunkSize = i;
            isClosed = false;
            return;
        }
    }

    public void write(char ac[], int i, int j)
        throws IOException
    {
        synchronized(lock)
        {
            ensureOpen();
            int k = i;
            for(int l = k + Math.min(j, ac.length - i); k < l;)
            {
                int i1 = Math.min(chunkSize - count, l - k);
                System.arraycopy(ac, k, charBuf, count, i1);
                k += i1;
                count += i1;
                if(count >= chunkSize)
                    flushBuffer();
            }

        }
    }

    public void flush()
        throws IOException
    {
        synchronized(lock)
        {
            ensureOpen();
            flushBuffer();
        }
    }

    public void close()
        throws IOException
    {
        synchronized(lock)
        {
            flushBuffer();
            isClosed = true;
        }
    }

    private void flushBuffer()
        throws IOException
    {
        synchronized(lock)
        {
            try
            {
                if(count > 0)
                {
                    clob.putString((int)lob_offset, new String(charBuf, 0, count));
                    lob_offset += count;
                    count = 0;
                }
            }
            catch(SQLException sqlexception)
            {
                DBError.SQLToIOException(sqlexception);
            }
        }
    }

    void ensureOpen()
        throws IOException
    {
        try
        {
            if(isClosed)
                DBError.check_error(57, null);
        }
        catch(SQLException sqlexception)
        {
            DBError.SQLToIOException(sqlexception);
        }
    }

    DBAccess db_access;
    DBConversion db_conversion;
    CLOB clob;
    long lob_offset;
    char charBuf[];
    byte nativeBuf[];
    int pos;
    int count;
    int chunkSize;
    boolean isClosed;
}
