// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleConversionInputStream.java

package oracle.jdbc.driver;

import java.io.*;
import java.sql.SQLException;
import oracle.jdbc.dbaccess.DBConversion;
import oracle.jdbc.dbaccess.DBError;

// Referenced classes of package oracle.jdbc.driver:
//            OracleBufferedStream

public class OracleConversionInputStream extends OracleBufferedStream
{

    public OracleConversionInputStream(DBConversion dbconversion, InputStream inputstream, int i)
    {
        super(4096);
        istream = inputstream;
        conversion = i;
        converter = dbconversion;
        max_size = 0;
        total_size = 0;
        numUnconvertedBytes = 0;
        endOfStream = false;
        switch(i)
        {
        case 0: // '\0'
            java_chars = new char[4096];
            convbuf = new byte[4096];
            break;

        case 1: // '\001'
            convbuf = new byte[2048];
            java_chars = new char[2048];
            break;

        case 2: // '\002'
            convbuf = new byte[2048];
            java_chars = new char[4096];
            break;

        case 3: // '\003'
            convbuf = new byte[1024];
            java_chars = new char[2048];
            break;

        case 4: // '\004'
            int j = 4096 / converter.getMaxCharbyteSize();
            convbuf = new byte[j * 2];
            java_chars = new char[j];
            break;

        case 5: // '\005'
            if(converter.isUcs2CharSet())
            {
                convbuf = new byte[2048];
                java_chars = new char[2048];
            } else
            {
                convbuf = new byte[4096];
                java_chars = new char[4096];
            }
            break;

        case 7: // '\007'
            int k = 4096 / converter.getMaxCharbyteSize();
            java_chars = new char[k];
            break;

        case 6: // '\006'
        default:
            convbuf = new byte[4096];
            java_chars = new char[4096];
            break;
        }
    }

    public OracleConversionInputStream(DBConversion dbconversion, InputStream inputstream, int i, int j)
    {
        this(dbconversion, inputstream, i);
        max_size = j;
        total_size = 0;
    }

    public OracleConversionInputStream(DBConversion dbconversion, Reader reader1, int i, int j)
    {
        this(dbconversion, (InputStream)null, i);
        reader = reader1;
        max_size = j;
        total_size = 0;
    }

    public void setFormOfUse(short word0)
    {
        csform = word0;
    }

    public boolean needBytes()
        throws IOException
    {
        if(closed)
            return false;
        if(pos < count)
            return true;
        if(istream != null)
            return needBytesFromStream();
        if(reader != null)
            return needBytesFromReader();
        else
            return false;
    }

    public boolean needBytesFromReader()
        throws IOException
    {
        try
        {
            int i = 0;
            if(max_size == 0)
                i = java_chars.length;
            else
                i = Math.min(max_size - total_size, java_chars.length);
            if(i <= 0)
            {
                reader.close();
                close();
                return false;
            }
            int j = reader.read(java_chars, 0, i);
            if(j == -1)
            {
                reader.close();
                close();
                return false;
            }
            total_size += j;
            switch(conversion)
            {
            case 7: // '\007'
                if(csform == 2)
                    count = converter.javaCharsToNCHARBytes(java_chars, j, buf);
                else
                    count = converter.javaCharsToCHARBytes(java_chars, j, buf);
                break;

            default:
                System.arraycopy(convbuf, 0, buf, 0, j);
                count = j;
                break;
            }
        }
        catch(SQLException sqlexception)
        {
            DBError.SQLToIOException(sqlexception);
        }
        pos = 0;
        return true;
    }

    public boolean needBytesFromStream()
        throws IOException
    {
        if(!endOfStream)
        {
            try
            {
                int i = 0;
                if(max_size == 0)
                    i = convbuf.length;
                else
                    i = Math.min(max_size - total_size, convbuf.length);
                int j = 0;
                if(i <= 0)
                {
                    endOfStream = true;
                    istream.close();
                    if(numUnconvertedBytes != 0)
                        DBError.throwSqlException(55);
                } else
                {
                    j = istream.read(convbuf, numUnconvertedBytes, i - numUnconvertedBytes);
                }
                if(j == -1)
                {
                    endOfStream = true;
                    istream.close();
                    if(numUnconvertedBytes != 0)
                        DBError.throwSqlException(55);
                } else
                {
                    j += numUnconvertedBytes;
                    total_size += j;
                }
                if(j <= 0)
                    return false;
                switch(conversion)
                {
                case 0: // '\0'
                    int ai[] = {
                        j
                    };
                    int j1 = converter.CHARBytesToJavaChars(convbuf, ai, java_chars);
                    numUnconvertedBytes = ai[0];
                    for(int l1 = 0; l1 < numUnconvertedBytes; l1++)
                        convbuf[l1] = convbuf[j - numUnconvertedBytes];

                    count = javaCharsToAsciiBytes(java_chars, j1, buf);
                    break;

                case 1: // '\001'
                    int ai1[] = {
                        j
                    };
                    int k1 = converter.CHARBytesToJavaChars(convbuf, ai1, java_chars);
                    numUnconvertedBytes = ai1[0];
                    for(int i2 = 0; i2 < numUnconvertedBytes; i2++)
                        convbuf[i2] = convbuf[j - numUnconvertedBytes];

                    count = javaCharsToUcs2Bytes(java_chars, k1, buf);
                    break;

                case 2: // '\002'
                    OracleConversionInputStream _tmp = this;
                    int k = DBConversion.RAWBytesToHexChars(convbuf, j, java_chars);
                    count = javaCharsToAsciiBytes(java_chars, k, buf);
                    break;

                case 3: // '\003'
                    OracleConversionInputStream _tmp1 = this;
                    int l = DBConversion.RAWBytesToHexChars(convbuf, j, java_chars);
                    count = javaCharsToUcs2Bytes(java_chars, l, buf);
                    break;

                case 4: // '\004'
                    OracleConversionInputStream _tmp2 = this;
                    int i1 = DBConversion.ucs2BytesToJavaChars(convbuf, j, java_chars);
                    count = converter.javaCharsToCHARBytes(java_chars, i1, buf);
                    break;

                case 5: // '\005'
                    OracleConversionInputStream _tmp3 = this;
                    DBConversion.asciiBytesToJavaChars(convbuf, j, java_chars);
                    count = converter.javaCharsToCHARBytes(java_chars, j, buf);
                    break;

                default:
                    System.arraycopy(convbuf, 0, buf, 0, j);
                    count = j;
                    break;
                }
            }
            catch(SQLException sqlexception)
            {
                DBError.SQLToIOException(sqlexception);
            }
            pos = 0;
            return true;
        } else
        {
            return false;
        }
    }

    static final int CHUNK_SIZE = 4096;
    DBConversion converter;
    int conversion;
    InputStream istream;
    Reader reader;
    byte convbuf[];
    char java_chars[];
    int max_size;
    int total_size;
    int numUnconvertedBytes;
    boolean endOfStream;
    private short csform;
}
