// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OraclePreparedStatement.java

package oracle.jdbc.driver;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.Reader;
import java.math.BigDecimal;
import java.net.URL;
import java.sql.Array;
import java.sql.Blob;
import java.sql.Clob;
import java.sql.Date;
import java.sql.ParameterMetaData;
import java.sql.Ref;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLData;
import java.sql.SQLException;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.Calendar;
import oracle.jdbc.OracleParameterMetaData;
import oracle.jdbc.dbaccess.DBAccess;
import oracle.jdbc.dbaccess.DBConversion;
import oracle.jdbc.dbaccess.DBDataSet;
import oracle.jdbc.dbaccess.DBError;
import oracle.jdbc.dbaccess.DBStatement;
import oracle.jdbc.internal.ObjectData;
import oracle.jdbc.oracore.OracleTypeCHAR;
import oracle.jdbc.oracore.OracleTypeNUMBER;
import oracle.jdbc.oracore.OracleTypeOPAQUE;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.sql.BFILE;
import oracle.sql.BLOB;
import oracle.sql.CHAR;
import oracle.sql.CLOB;
import oracle.sql.CharacterSet;
import oracle.sql.CustomDatum;
import oracle.sql.DATE;
import oracle.sql.Datum;
import oracle.sql.INTERVALYM;
import oracle.sql.NUMBER;
import oracle.sql.OPAQUE;
import oracle.sql.ORAData;
import oracle.sql.OpaqueDescriptor;
import oracle.sql.RAW;
import oracle.sql.REF;
import oracle.sql.ROWID;
import oracle.sql.STRUCT;
import oracle.sql.StructDescriptor;
import oracle.sql.TIMESTAMP;
import oracle.sql.TIMESTAMPLTZ;
import oracle.sql.TIMESTAMPTZ;

// Referenced classes of package oracle.jdbc.driver:
//            OracleStatement, OracleResultSetImpl, ScrollRsetStatement, OracleConnection, 
//            ResultSetUtil

public class OraclePreparedStatement extends OracleStatement
    implements oracle.jdbc.internal.OraclePreparedStatement, ScrollRsetStatement
{

    public OraclePreparedStatement(OracleConnection oracleconnection, String s, int i, int j)
        throws SQLException
    {
        this(oracleconnection, s, i, j, 1003, 1007);
    }

    public OraclePreparedStatement(OracleConnection oracleconnection, String s, int i, int j, int k, int l)
        throws SQLException
    {
        super(oracleconnection, i, j, k, l);
        check_bind_types = true;
        has_ref_cursors = false;
        m_batchStyle = 0;
        statementType = 1;
        need_to_parse = true;
        has_ref_cursors = false;
        prepare_for_new_result(true);
        sql_query = s;
        m_originalSql = s;
        clear_params = true;
        m_binds = null;
        m_scrollRsetTypeSolved = false;
        premature_batch_count = 0;
        binds_in = connection.db_access.createDBDataSet(oracleconnection, this, i, 1);
        parseSqlKind();
        if(oracleconnection.db_access.getVersionNumber() >= 8000)
        {
            min_binary_stream_size = 2000;
            min_ascii_stream_size = 4000;
        } else
        {
            min_binary_stream_size = 255;
            min_ascii_stream_size = 2000;
        }
    }

    protected void enterImplicitCache()
        throws SQLException
    {
        cacheState = OracleStatement.CACHED;
        m_creationState = 1;
        initializeState(batch, row_prefetch, m_autoRefetch, serverCursor);
        if(connection.m_stmtClearMetaData)
            initializeMetaData();
        dbstmt.enterCache();
        if(binds_in != null)
            binds_in.enterCache();
        if(binds_out != null)
            binds_out.enterCache();
        if(columns_defined_by_user && defines != null)
            defines.enterCache();
    }

    protected void enterExplicitCache()
        throws SQLException
    {
        cacheState = OracleStatement.CACHED;
        m_creationState = 2;
    }

    protected void exitImplicitCacheToActive()
        throws SQLException
    {
        cacheState = OracleStatement.ACTIVE;
        dbstmt.reactivate();
        if(binds_in != null)
            binds_in.reactivate();
        if(binds_out != null)
            binds_out.reactivate();
        if(defines != null)
            defines.reactivate();
        if(row_prefetch != connection.getDefaultRowPrefetch())
        {
            row_prefetch = connection.getDefaultRowPrefetch();
            default_row_prefetch = connection.getDefaultRowPrefetch();
            need_to_parse = true;
        }
        if(batch != connection.getDefaultExecuteBatch())
        {
            batch = connection.getDefaultExecuteBatch();
            need_to_parse = true;
        }
        if(m_autoRefetch != connection.getDefaultAutoRefetch())
        {
            m_autoRefetch = connection.getDefaultAutoRefetch();
            need_to_parse = true;
        }
    }

    protected void exitExplicitCacheToActive()
        throws SQLException
    {
        cacheState = OracleStatement.ACTIVE;
    }

    protected void exitImplicitCacheToClose()
        throws SQLException
    {
        cacheState = OracleStatement.CLOSED;
        super.close();
    }

    protected void exitExplicitCacheToClose()
        throws SQLException
    {
        cacheState = OracleStatement.CLOSED;
        super.close();
    }

    public void close()
        throws SQLException
    {
        synchronized(connection)
        {
            synchronized(this)
            {
                privateClose(null);
            }
        }
    }

    public void closeWithKey(String s)
        throws SQLException
    {
        synchronized(connection)
        {
            synchronized(this)
            {
                privateClose(s);
            }
        }
    }

    private void privateClose(String s)
        throws SQLException
    {
        if(closed)
            return;
        if(doesJdbcBatchExist())
            clearBatch();
        else
            sendBatch();
        if(connection.isStatementCacheInitialized() && cacheState != OracleStatement.CLOSED && cacheState != OracleStatement.NON_CACHED)
        {
            if(s == null)
            {
                if(connection.getImplicitCachingEnabled())
                {
                    connection.cacheImplicitStatement(this, sql_query, statementType, m_userRsetType);
                } else
                {
                    cacheState = OracleStatement.CLOSED;
                    super.close();
                }
            } else
            if(connection.getExplicitCachingEnabled())
            {
                connection.cacheExplicitStatement(this, s);
            } else
            {
                cacheState = OracleStatement.CLOSED;
                super.close();
            }
        } else
        {
            super.close();
        }
        if(s == null)
            cleanup();
    }

    public ResultSet executeQuery()
        throws SQLException
    {
label0:
        {
            OracleResultSetImpl oracleresultsetimpl;
            synchronized(connection)
            {
                synchronized(this)
                {
                    executeUpdate();
                    if(!isRegularResultSet())
                        break label0;
                    current_result_set = new OracleResultSetImpl(connection, this);
                    oracleresultsetimpl = current_result_set;
                }
            }
            return oracleresultsetimpl;
        }
        OracleResultSet oracleresultset;
        if(m_scrollRset == null)
        {
            current_result_set = new OracleResultSetImpl(connection, this);
            m_scrollRset = current_result_set;
        }
        oracleresultset = m_scrollRset;
        oraclepreparedstatement;
        JVM INSTR monitorexit ;
        oracleconnection;
        JVM INSTR monitorexit ;
        return oracleresultset;
        exception;
        throw exception;
        exception1;
        throw exception1;
    }

    public int executeUpdate()
        throws SQLException
    {
label0:
        {
            int i;
            synchronized(connection)
            {
                synchronized(this)
                {
                    noMoreUpdateCounts = false;
                    checkIfJdbcBatchExists();
                    ensureOpen();
                    if(has_ref_cursors)
                        need_to_parse = true;
                    if(!isRegularResultSet())
                        break label0;
                    prepare_for_new_result(true);
                    get_data_for_columns(batch);
                    doExecuteWithTimeout();
                    if(valid_rows > 0)
                    {
                        valid_rows += premature_batch_count;
                        premature_batch_count = 0;
                    }
                    i = valid_rows;
                }
            }
            return i;
        }
        int j;
        if(!m_scrollRsetTypeSolved)
            break MISSING_BLOCK_LABEL_198;
        prepare_for_new_result(true);
        get_data_for_columns(batch);
        doExecuteWithTimeout();
        current_result_set = new OracleResultSetImpl(connection, this);
        m_scrollRset = ResultSetUtil.createScrollResultSet(this, current_result_set, m_realRsetType);
        if(connection.m_accumulateBatchResult && valid_rows > 0)
        {
            valid_rows += premature_batch_count;
            premature_batch_count = 0;
        }
        j = valid_rows;
        oraclepreparedstatement;
        JVM INSTR monitorexit ;
        oracleconnection;
        JVM INSTR monitorexit ;
        return j;
        int l;
        int k = doScrollPstmtExecuteUpdate() + premature_batch_count;
        l = k;
        oraclepreparedstatement;
        JVM INSTR monitorexit ;
        oracleconnection;
        JVM INSTR monitorexit ;
        return l;
        exception;
        throw exception;
        exception1;
        throw exception1;
    }

    public boolean execute()
        throws SQLException
    {
        boolean flag;
        synchronized(connection)
        {
            synchronized(this)
            {
                checkIfJdbcBatchExists();
                executeUpdate();
                OracleConnection _tmp = connection;
                flag = sql_kind == 0;
            }
        }
        return flag;
    }

    public int sendBatch()
        throws SQLException
    {
label0:
        {
            int i;
            synchronized(connection)
            {
                synchronized(this)
                {
                    if(!isJdbcBatchStyle())
                        break label0;
                    i = 0;
                }
            }
            return i;
        }
        int j;
        ensureOpen();
        if(m_currentRank > 0)
            break MISSING_BLOCK_LABEL_62;
        j = connection.m_accumulateBatchResult ? 0 : valid_rows;
        oraclepreparedstatement;
        JVM INSTR monitorexit ;
        oracleconnection;
        JVM INSTR monitorexit ;
        return j;
        int l;
        int k = batch;
        try
        {
            m_currentRank--;
            if(batch != m_currentRank)
            {
                batch = m_currentRank;
                need_to_parse = true;
            }
            doExecuteWithTimeout();
        }
        finally
        {
            if(batch != k)
            {
                batch = k;
                need_to_parse = true;
            }
        }
        if(connection.m_accumulateBatchResult)
        {
            valid_rows += premature_batch_count;
            premature_batch_count = 0;
        }
        l = valid_rows;
        oraclepreparedstatement;
        JVM INSTR monitorexit ;
        oracleconnection;
        JVM INSTR monitorexit ;
        return l;
        exception1;
        throw exception1;
        exception2;
        throw exception2;
    }

    public synchronized void setExecuteBatch(int i)
        throws SQLException
    {
        setOracleBatchStyle();
        set_execute_batch(i);
    }

    private synchronized void set_execute_batch(int i)
        throws SQLException
    {
        if(i <= 0)
            DBError.throwSqlException(42);
        if(i == batch)
            return;
        batch = i;
        if(m_currentRank > 0)
            sendBatch();
        binds_in.setBatchSize(i);
        need_to_parse = true;
    }

    public final int getExecuteBatch()
    {
        return batch;
    }

    public synchronized void defineParameterTypeBytes(int i, int j, int k)
        throws SQLException
    {
        if(k < 0)
            DBError.throwSqlException(53);
        if(i < 1)
            DBError.throwSqlException(3);
        switch(j)
        {
        case -7: 
        case -6: 
        case -5: 
        case 2: // '\002'
        case 3: // '\003'
        case 4: // '\004'
        case 5: // '\005'
        case 6: // '\006'
        case 7: // '\007'
        case 8: // '\b'
            j = 6;
            break;

        case 999: 
            j = 999;
            break;

        case 1: // '\001'
            j = 96;
            break;

        case 12: // '\f'
            j = 1;
            break;

        case 91: // '['
        case 92: // '\\'
            j = 12;
            break;

        case -103: 
            j = 182;
            break;

        case -104: 
            j = 183;
            break;

        case -100: 
        case 93: // ']'
            j = 180;
            break;

        case -101: 
            j = 181;
            break;

        case -102: 
            j = 231;
            break;

        case -3: 
        case -2: 
            j = 23;
            break;

        case -8: 
            j = 104;
            break;

        case 2004: 
            j = 113;
            break;

        case 2005: 
            j = 112;
            break;

        case -13: 
            j = 114;
            break;

        case -10: 
            j = 102;
            break;

        default:
            DBError.throwSqlException(23);
            break;
        }
        binds_in.setType(i - 1, j, k, (short)1);
    }

    public synchronized void defineParameterTypeChars(int i, int j, int k)
        throws SQLException
    {
        int l = connection.db_access.getNlsRatio();
        if(j == 1 || j == 12)
            defineParameterTypeBytes(i, j, k * l);
        else
            defineParameterTypeBytes(i, j, k);
    }

    public synchronized void defineParameterType(int i, int j, int k)
        throws SQLException
    {
        defineParameterTypeBytes(i, j, k * connection.dataSizeScale);
    }

    public ResultSetMetaData getMetaData()
        throws SQLException
    {
        ResultSet resultset = getResultSet();
        if(resultset != null)
            return resultset.getMetaData();
        else
            return null;
    }

    protected void setItem(int i, int j, byte abyte0[])
        throws SQLException
    {
        checkBindTypes(true, i, j);
        if(binds_in.setBytesBindItem(i, m_currentRank, j, abyte0))
            need_to_parse = true;
    }

    protected void setItem(int i, int j, String s)
        throws SQLException
    {
        checkBindTypes(true, i, j);
        if(binds_in.setBytesBindItem(i, m_currentRank, j, s))
            need_to_parse = true;
    }

    protected void setStreamItem(int i, int j, InputStream inputstream, int k)
        throws SQLException
    {
        if(k < 0)
            DBError.throwSqlException(43);
        checkBindTypes(true, i, j);
        binds_in.setStreamBindItem(i, m_currentRank, j, inputstream, k);
    }

    public synchronized void setNull(int i, int j, String s)
        throws SQLException
    {
        if(j == 2002 || j == 2008 || j == 2003 || j == 2007 || j == 2006)
        {
            int k = get_internal_type(j);
            Object obj = null;
            int l = i - 1;
            columnSetNull = true;
            checkBindTypes(true, l, k);
            switch(j)
            {
            case 2002: 
            case 2006: 
            case 2008: 
                StructDescriptor structdescriptor = StructDescriptor.createDescriptor(s, connection);
                obj = structdescriptor.getOracleTypeADT();
                break;

            case 2003: 
                ArrayDescriptor arraydescriptor = ArrayDescriptor.createDescriptor(s, connection);
                obj = arraydescriptor.getOracleTypeCOLLECTION();
                break;

            case 2007: 
                OpaqueDescriptor opaquedescriptor = OpaqueDescriptor.createDescriptor(s, connection);
                obj = opaquedescriptor.getPickler();
                break;

            case 2004: 
            case 2005: 
            default:
                DBError.throwSqlException(1);
                break;
            }
            if(binds_in.setNullADTBindItem(l, m_currentRank, k, ((oracle.jdbc.oracore.OracleType) (obj))))
                need_to_parse = true;
        } else
        {
            setNull(i, j);
        }
        columnSetNull = false;
    }

    public synchronized void setNull(int i, int j)
        throws SQLException
    {
        if(j == 2002 || j == 2008 || j == 2003 || j == 2007 || j == 2006)
            DBError.throwSqlException(4, "sqlType=" + j);
        int k = i - 1;
        int l = get_internal_type(j);
        columnSetNull = true;
        checkBindTypes(true, k, l);
        switch(l)
        {
        case 8: // '\b'
            l = 1;
            break;

        case 24: // '\030'
            l = 23;
            break;
        }
        binds_in.setNullBindItem(k, m_currentRank, l);
        columnSetNull = false;
    }

    public synchronized void setBoolean(int i, boolean flag)
        throws SQLException
    {
        int j = i - 1;
        OracleConnection _tmp = connection;
        byte abyte0[] = DBConversion.BooleanToNumberBytes(flag);
        setItem(j, 6, abyte0);
    }

    public synchronized void setByte(int i, byte byte0)
        throws SQLException
    {
        int j = i - 1;
        OracleConnection _tmp = connection;
        byte abyte0[] = DBConversion.ByteToNumberBytes(byte0);
        setItem(j, 6, abyte0);
    }

    public synchronized void setShort(int i, short word0)
        throws SQLException
    {
        int j = i - 1;
        OracleConnection _tmp = connection;
        byte abyte0[] = DBConversion.ShortToNumberBytes(word0);
        setItem(j, 6, abyte0);
    }

    public synchronized void setInt(int i, int j)
        throws SQLException
    {
        int k = i - 1;
        OracleConnection _tmp = connection;
        byte abyte0[] = DBConversion.IntToNumberBytes(j);
        setItem(k, 6, abyte0);
    }

    public synchronized void setLong(int i, long l)
        throws SQLException
    {
        int j = i - 1;
        OracleConnection _tmp = connection;
        byte abyte0[] = DBConversion.LongToNumberBytes(l);
        setItem(j, 6, abyte0);
    }

    public synchronized void setFloat(int i, float f)
        throws SQLException
    {
        int j = i - 1;
        OracleConnection _tmp = connection;
        byte abyte0[] = DBConversion.FloatToNumberBytes(f);
        setItem(j, 6, abyte0);
    }

    public synchronized void setDouble(int i, double d)
        throws SQLException
    {
        int j = i - 1;
        OracleConnection _tmp = connection;
        byte abyte0[] = DBConversion.DoubleToNumberBytes(d);
        setItem(j, 6, abyte0);
    }

    public synchronized void setBigDecimal(int i, BigDecimal bigdecimal)
        throws SQLException
    {
        int j = i - 1;
        OracleConnection _tmp = connection;
        byte abyte0[] = DBConversion.BigDecimalToNumberBytes(bigdecimal);
        setItem(j, 6, abyte0);
    }

    public synchronized void setString(int i, String s)
        throws SQLException
    {
        int j = i - 1;
        boolean flag = connection.getProtocolType().equals("thin");
        boolean flag1 = false;
        if(binds_in != null)
            flag1 = binds_in.getFormOfUse(i - 1) == 2;
        if(flag)
        {
            setItem(j, 1, s);
        } else
        {
            byte abyte0[] = null;
            if(flag1)
                abyte0 = connection.conversion.StringToNCharBytes(s);
            else
                abyte0 = connection.conversion.StringToCharBytes(s);
            setItem(j, 1, abyte0);
        }
    }

    public synchronized void setFixedCHAR(int i, String s)
        throws SQLException
    {
        int j = i - 1;
        byte abyte0[] = connection.conversion.StringToCharBytes(s);
        setItem(j, 999, abyte0);
    }

    /**
     * @deprecated Method setCursor is deprecated
     */

    public synchronized void setCursor(int i, ResultSet resultset)
        throws SQLException
    {
        throw DBError.newSqlException(23);
    }

    public synchronized void setROWID(int i, ROWID rowid)
        throws SQLException
    {
        setDatum(i - 1, 104, rowid);
    }

    public synchronized void setArray(int i, Array array)
        throws SQLException
    {
        setARRAY(i, (ARRAY)array);
    }

    public synchronized void setARRAY(int i, ARRAY array)
        throws SQLException
    {
        if(array == null)
            DBError.throwSqlException(68);
        if(array.getDescriptor() == null)
            DBError.throwSqlException(61);
        int j = i - 1;
        checkBindTypes(true, j, 109);
        byte abyte0[] = array.toBytes();
        if(binds_in.setADTBindItem(j, m_currentRank, 109, abyte0, array.getDescriptor().getOracleTypeCOLLECTION()))
            need_to_parse = true;
    }

    public synchronized void setOPAQUE(int i, OPAQUE opaque)
        throws SQLException
    {
        int j = i - 1;
        if(opaque == null)
            DBError.throwSqlException(68);
        if(opaque.getDescriptor() == null)
            DBError.throwSqlException(61);
        checkBindTypes(true, j, 109);
        byte abyte0[] = opaque.toBytes();
        if(binds_in.setADTBindItem(j, m_currentRank, 109, abyte0, (OracleTypeOPAQUE)opaque.getDescriptor().getPickler()))
            need_to_parse = true;
    }

    public synchronized void setStructDescriptor(int i, StructDescriptor structdescriptor)
        throws SQLException
    {
        int j = i - 1;
        if(structdescriptor == null)
            DBError.throwSqlException(68);
        checkBindTypes(true, j, 109);
        binds_in.setADTBindType(j, m_currentRank, 109, structdescriptor.getOracleTypeADT());
    }

    public synchronized void setPreBindsCompelete()
        throws SQLException
    {
        binds_in.setFirstRow(false);
    }

    public synchronized void setSTRUCT(int i, STRUCT struct)
        throws SQLException
    {
        int j = i - 1;
        if(struct == null)
            DBError.throwSqlException(68);
        StructDescriptor structdescriptor = struct.getDescriptor();
        if(structdescriptor == null)
            DBError.throwSqlException(61);
        checkBindObjectTypes(true, j, 109, structdescriptor);
        byte abyte0[] = struct.toBytes();
        if(binds_in.setADTBindItem(j, m_currentRank, 109, abyte0, structdescriptor.getOracleTypeADT()))
            need_to_parse = true;
    }

    public synchronized void setRAW(int i, RAW raw)
        throws SQLException
    {
        setDatum(i - 1, 23, raw);
    }

    public synchronized void setCHAR(int i, CHAR char1)
        throws SQLException
    {
        int j = 1;
        CHAR char2 = char1;
        if(char2 != null)
        {
            short word0 = (short)char2.getCharacterSet().getOracleId();
            CharacterSet characterset;
            if(binds_in != null && binds_in.getFormOfUse(i - 1) == 2)
                characterset = connection.conversion.getAccessNCharSetObj();
            else
                characterset = connection.conversion.getAccessCharSetObj();
            if(characterset != null && word0 != characterset.getOracleId())
            {
                byte abyte0[] = char2.getBytes();
                char2 = new CHAR(characterset.convert(char1.getCharacterSet(), abyte0, 0, abyte0.length), characterset);
            }
        }
        setDatum(i - 1, j, char2);
    }

    public synchronized void setDATE(int i, DATE date)
        throws SQLException
    {
        setDatum(i - 1, 12, date);
    }

    public synchronized void setNUMBER(int i, NUMBER number)
        throws SQLException
    {
        setDatum(i - 1, 6, number);
    }

    private void setDatum(int i, int j, Datum datum)
        throws SQLException
    {
        if(datum == null)
            setItem(i, j, (byte[])null);
        else
            setItem(i, j, datum.getBytes());
    }

    public synchronized void setBLOB(int i, BLOB blob)
        throws SQLException
    {
        setDatum(i - 1, 113, blob);
    }

    public synchronized void setBlob(int i, Blob blob)
        throws SQLException
    {
        setBLOB(i, (BLOB)blob);
    }

    public synchronized void setCLOB(int i, CLOB clob)
        throws SQLException
    {
        setDatum(i - 1, 112, clob);
    }

    public synchronized void setClob(int i, Clob clob)
        throws SQLException
    {
        setCLOB(i, (CLOB)clob);
    }

    public synchronized void setBFILE(int i, BFILE bfile)
        throws SQLException
    {
        setDatum(i - 1, 114, bfile);
    }

    public synchronized void setBfile(int i, BFILE bfile)
        throws SQLException
    {
        setBFILE(i, bfile);
    }

    public synchronized void setBytes(int i, byte abyte0[])
        throws SQLException
    {
        int j = i - 1;
        if(abyte0 != null)
        {
            byte abyte1[] = new byte[abyte0.length];
            System.arraycopy(abyte0, 0, abyte1, 0, abyte0.length);
            setItem(j, 23, abyte1);
        } else
        {
            setItem(j, 23, (byte[])null);
        }
    }

    public synchronized void setInternalBytes(int i, byte abyte0[], int j)
        throws SQLException
    {
        int k = i - 1;
        setItem(k, j, abyte0);
    }

    public synchronized void setDate(int i, Date date)
        throws SQLException
    {
        int j = i - 1;
        byte abyte0[] = connection.conversion.DateToDateBytes(date);
        setItem(j, 12, abyte0);
    }

    public synchronized void setTime(int i, Time time)
        throws SQLException
    {
        int j = i - 1;
        byte abyte0[] = connection.conversion.TimeToDateBytes(time);
        setItem(j, 12, abyte0);
    }

    public synchronized void setTimestamp(int i, Timestamp timestamp)
        throws SQLException
    {
        int j = i - 1;
        byte abyte0[] = TIMESTAMP.toBytes(timestamp);
        setItem(j, 180, abyte0);
    }

    public synchronized void setINTERVALYM(int i, INTERVALYM intervalym)
        throws SQLException
    {
        setDatum(i - 1, 182, intervalym);
    }

    public synchronized void setTIMESTAMP(int i, TIMESTAMP timestamp)
        throws SQLException
    {
        setDatum(i - 1, 180, timestamp);
    }

    public synchronized void setTIMESTAMPTZ(int i, TIMESTAMPTZ timestamptz)
        throws SQLException
    {
        setDatum(i - 1, 181, timestamptz);
    }

    public synchronized void setTIMESTAMPLTZ(int i, TIMESTAMPLTZ timestampltz)
        throws SQLException
    {
        if(connection.getSessionTimeZone() == null)
            DBError.throwSqlException(105);
        setDatum(i - 1, 231, timestampltz);
    }

    public synchronized void setAsciiStream(int i, InputStream inputstream, int j)
        throws SQLException
    {
        set_execute_batch(1);
        if(inputstream != null)
        {
            int k = i - 1;
            int l = connection.db_access.getMinAsciiStreamSize(connection, min_ascii_stream_size);
            OracleConnection _tmp = connection;
            if(sql_kind == 1 || j <= l || !isRegularResultSet())
            {
                try
                {
                    byte abyte0[] = new byte[j];
                    inputstream.read(abyte0, 0, j);
                    byte abyte1[] = connection.conversion.asciiBytesToCHARBytes(abyte0);
                    setItem(k, 1, abyte1);
                }
                catch(IOException ioexception)
                {
                    DBError.throwSqlException(ioexception);
                }
            } else
            {
                InputStream inputstream1 = connection.conversion.ConvertStream(inputstream, 5, j);
                setStreamItem(k, 8, inputstream1, j);
            }
        } else
        {
            setString(i, null);
        }
    }

    public synchronized void setBinaryStream(int i, InputStream inputstream, int j)
        throws SQLException
    {
        set_execute_batch(1);
        if(inputstream != null)
        {
            int k = i - 1;
            OracleConnection _tmp = connection;
            if(sql_kind == 1 || j <= min_binary_stream_size || !isRegularResultSet())
                try
                {
                    byte abyte0[] = new byte[j];
                    inputstream.read(abyte0, 0, j);
                    setItem(k, 23, abyte0);
                }
                catch(IOException ioexception)
                {
                    DBError.throwSqlException(ioexception);
                }
            else
                setStreamItem(k, 24, inputstream, j);
        } else
        {
            setBytes(i, null);
        }
    }

    /**
     * @deprecated Method setUnicodeStream is deprecated
     */

    public synchronized void setUnicodeStream(int i, InputStream inputstream, int j)
        throws SQLException
    {
        set_execute_batch(1);
        if(inputstream != null)
        {
            int k = i - 1;
            InputStream inputstream1 = connection.conversion.ConvertStream(inputstream, 4, j);
            int l = (2 * (min_ascii_stream_size / connection.db_access.getC2SNlsRatio())) / connection.conversion.getMaxCharbyteSize();
            OracleConnection _tmp = connection;
            if(sql_kind == 1 || j <= l || !isRegularResultSet())
                try
                {
                    ByteArrayOutputStream bytearrayoutputstream = new ByteArrayOutputStream(1024);
                    byte abyte0[] = new byte[1024];
                    int i1;
                    while((i1 = inputstream1.read(abyte0)) != -1) 
                        bytearrayoutputstream.write(abyte0, 0, i1);
                    setItem(k, 1, bytearrayoutputstream.toByteArray());
                    bytearrayoutputstream.close();
                }
                catch(IOException ioexception)
                {
                    DBError.throwSqlException(ioexception);
                }
            else
                setStreamItem(k, 8, inputstream1, j * connection.conversion.getMaxCharbyteSize());
        } else
        {
            setString(i, null);
        }
    }

    /**
     * @deprecated Method setCustomDatum is deprecated
     */

    public synchronized void setCustomDatum(int i, CustomDatum customdatum)
        throws SQLException
    {
        Datum datum = customdatum.toDatum(connection);
        setOracleObject(i, datum);
    }

    public synchronized void setORAData(int i, ORAData oradata)
        throws SQLException
    {
        Datum datum = oradata.toDatum(connection);
        setOracleObject(i, datum);
    }

    public synchronized void setObject(int i, Object obj, int j, int k)
        throws SQLException
    {
        if(obj == null && j != 2002 && j != 2008 && j != 2003 && j != 2007 && j != 2006)
            setNull(i, j);
        else
            switch(j)
            {
            case 1: // '\001'
                if(obj instanceof CHAR)
                    setCHAR(i, (CHAR)obj);
                else
                    setString(i, (String)obj);
                break;

            case 12: // '\f'
                setString(i, (String)obj);
                break;

            case 999: 
                setFixedCHAR(i, (String)obj);
                break;

            case -1: 
                setString(i, (String)obj);
                break;

            case 2: // '\002'
                if(obj instanceof NUMBER)
                {
                    setNUMBER(i, (NUMBER)obj);
                    break;
                }
                if(obj instanceof Byte)
                {
                    setByte(i, ((Byte)obj).byteValue());
                    break;
                }
                if(obj instanceof Short)
                {
                    setShort(i, ((Short)obj).shortValue());
                    break;
                }
                if(obj instanceof Integer)
                {
                    setInt(i, ((Integer)obj).intValue());
                    break;
                }
                if(obj instanceof Long)
                {
                    setLong(i, ((Long)obj).longValue());
                    break;
                }
                if(obj instanceof Float)
                {
                    setFloat(i, ((Float)obj).floatValue());
                    break;
                }
                if(obj instanceof Double)
                    setDouble(i, ((Double)obj).doubleValue());
                else
                    setBigDecimal(i, (BigDecimal)obj);
                break;

            case 3: // '\003'
                setBigDecimal(i, (BigDecimal)obj);
                break;

            case -7: 
                setBoolean(i, ((Boolean)obj).booleanValue());
                break;

            case -6: 
                setByte(i, ((Number)obj).byteValue());
                break;

            case 5: // '\005'
                setShort(i, ((Number)obj).shortValue());
                break;

            case 4: // '\004'
                setInt(i, ((Number)obj).intValue());
                break;

            case -5: 
                setLong(i, ((Number)obj).longValue());
                break;

            case 6: // '\006'
            case 7: // '\007'
                setFloat(i, ((Number)obj).floatValue());
                break;

            case 8: // '\b'
                setDouble(i, ((Number)obj).doubleValue());
                break;

            case -2: 
                if(obj instanceof RAW)
                    setRAW(i, (RAW)obj);
                else
                    setBytes(i, (byte[])obj);
                break;

            case -3: 
                setBytes(i, (byte[])obj);
                break;

            case -4: 
                setBytes(i, (byte[])obj);
                break;

            case 91: // '['
                if(obj instanceof DATE)
                    setDATE(i, (DATE)obj);
                else
                    setDate(i, (Date)obj);
                break;

            case 92: // '\\'
                setTime(i, (Time)obj);
                break;

            case 93: // ']'
                if(obj instanceof TIMESTAMP)
                    setTIMESTAMP(i, (TIMESTAMP)obj);
                else
                    setTimestamp(i, (Timestamp)obj);
                break;

            case -100: 
                setTIMESTAMP(i, (TIMESTAMP)obj);
                break;

            case -101: 
                setTIMESTAMPTZ(i, (TIMESTAMPTZ)obj);
                break;

            case -102: 
                setTIMESTAMPLTZ(i, (TIMESTAMPLTZ)obj);
                break;

            case -103: 
                setINTERVALYM(i, (INTERVALYM)obj);
                break;

            case -8: 
                setROWID(i, (ROWID)obj);
                break;

            case 2004: 
                setBLOB(i, (BLOB)obj);
                break;

            case 2005: 
                setCLOB(i, (CLOB)obj);
                break;

            case -13: 
                setBFILE(i, (BFILE)obj);
                break;

            case 2002: 
            case 2008: 
                setSTRUCT(i, STRUCT.toSTRUCT(obj, connection));
                break;

            case 2003: 
                setARRAY(i, (ARRAY)obj);
                break;

            case 2007: 
                setOPAQUE(i, (OPAQUE)obj);
                break;

            case 2006: 
                setREF(i, (REF)obj);
                break;

            default:
                DBError.throwSqlException(4);
                break;
            }
    }

    public void setObject(int i, Object obj, int j)
        throws SQLException
    {
        setObject(i, obj, j, 0);
    }

    public void setRefType(int i, REF ref)
        throws SQLException
    {
        setREF(i, ref);
    }

    public synchronized void setRef(int i, Ref ref)
        throws SQLException
    {
        setREF(i, (REF)ref);
    }

    public synchronized void setREF(int i, REF ref)
        throws SQLException
    {
        if(ref == null)
            DBError.throwSqlException(68);
        if(ref.getDescriptor() == null)
            DBError.throwSqlException(52);
        int j = i - 1;
        checkBindTypes(true, j, 111);
        byte abyte0[] = ref.getBytes();
        if(binds_in.setADTBindItem(j, m_currentRank, 111, abyte0, ref.getDescriptor().getOracleTypeADT()))
            need_to_parse = true;
    }

    public synchronized void setObject(int i, Object obj)
        throws SQLException
    {
        if(obj instanceof ORAData)
            setORAData(i, (ORAData)obj);
        else
        if(obj instanceof CustomDatum)
        {
            setCustomDatum(i, (CustomDatum)obj);
        } else
        {
            int j = sqlTypeForObject(obj);
            setObject(i, obj, j, 0);
        }
    }

    public synchronized void setOracleObject(int i, Datum datum)
        throws SQLException
    {
        setObject(i, datum);
    }

    public synchronized void setPlsqlIndexTable(int i, Object obj, int j, int k, int l, int i1)
        throws SQLException
    {
        if(j < 0 || k < 0 || j < k)
            DBError.throwSqlException(68, "maxLen < 0, curLen < 0 or maxLen < curLen ");
        int j1 = get_internal_type(l);
        checkPlsqlIndexTableBindTypes(true, i - 1, j, j1, i1);
        Datum adatum[] = null;
        switch(j1)
        {
        case 1: // '\001'
        case 96: // '`'
            OracleTypeCHAR oracletypechar = new OracleTypeCHAR(connection);
            adatum = oracletypechar.toDatumArray(obj, connection, 1L, k);
            break;

        case 2: // '\002'
        case 6: // '\006'
            adatum = OracleTypeNUMBER.toNUMBERArray(obj, connection, 1L, k);
            break;

        default:
            DBError.throwSqlException(97);
            return;
        }
        if(binds_in.setPlsqlIndexTableItem(i - 1, m_currentRank, adatum, j, k, j1, i1))
            need_to_parse = true;
    }

    void checkPlsqlIndexTableBindTypes(boolean flag, int i, int j, int k, int l)
        throws SQLException
    {
        int i1 = 0;
        switch(k)
        {
        default:
            DBError.throwSqlException(97);
            break;

        case 1: // '\001'
        case 2: // '\002'
        case 6: // '\006'
        case 96: // '`'
            break;
        }
        if(!check_bind_types)
            return;
        if(flag)
            i1 = binds_in.checkPlsqlIndexTableBindTypes(binds_out, i, j, l, k);
        else
            i1 = binds_out.checkPlsqlIndexTableBindTypes(binds_in, i, j, l, k);
        if(i1 == -1)
        {
            sendBatch();
            need_to_parse = true;
            clearDefines();
        }
    }

    void end_of_result_set()
        throws SQLException
    {
        prepare_for_new_result(false);
    }

    private void get_data_for_columns(int i)
        throws SQLException
    {
        binds_in.rowCompleted(m_currentRank);
        if(binds_out != null)
            binds_out.rowCompleted(m_currentRank);
    }

    protected void checkBindTypes(boolean flag, int i, int j)
        throws SQLException
    {
        if(!check_bind_types)
            return;
        int k;
        if(flag)
            k = binds_in.checkBindTypes(binds_out, i, j);
        else
            k = binds_out.checkBindTypes(binds_in, i, j);
        if(k == -1)
        {
            int l = m_currentRank;
            premature_batch_count = sendBatch();
            need_to_parse = true;
            binds_in.clearItem(l, true);
        }
    }

    protected void checkBindObjectTypes(boolean flag, int i, int j, StructDescriptor structdescriptor)
        throws SQLException
    {
        if(!check_bind_types)
            return;
        int k;
        if(flag)
            k = binds_in.checkBindObjectTypes(binds_out, i, j, structdescriptor);
        else
            k = binds_out.checkBindObjectTypes(binds_in, i, j, structdescriptor);
        if(k == -1)
        {
            premature_batch_count = sendBatch();
            need_to_parse = true;
        }
    }

    int sqlTypeForObject(Object obj)
    {
        if(obj == null)
            return 0;
        if(!(obj instanceof Datum))
        {
            if(obj instanceof String)
                return fixedString ? 999 : 12;
            if(obj instanceof BigDecimal)
                return 2;
            if(obj instanceof Boolean)
                return -7;
            if(obj instanceof Integer)
                return 4;
            if(obj instanceof Long)
                return -5;
            if(obj instanceof Float)
                return 6;
            if(obj instanceof Double)
                return 8;
            if(obj instanceof byte[])
                return -3;
            if(obj instanceof Short)
                return 5;
            if(obj instanceof Byte)
                return -6;
            if(obj instanceof Date)
                return 91;
            if(obj instanceof Time)
                return 92;
            if(obj instanceof Timestamp)
                return 93;
            if(obj instanceof SQLData)
                return 2002;
            if(obj instanceof ObjectData)
                return 2002;
        } else
        {
            if(obj instanceof BLOB)
                return 2004;
            if(obj instanceof CLOB)
                return 2005;
            if(obj instanceof BFILE)
                return -13;
            if(obj instanceof ROWID)
                return -8;
            if(obj instanceof NUMBER)
                return 2;
            if(obj instanceof DATE)
                return 91;
            if(obj instanceof TIMESTAMP)
                return 93;
            if(obj instanceof TIMESTAMPTZ)
                return -101;
            if(obj instanceof TIMESTAMPLTZ)
                return -102;
            if(obj instanceof REF)
                return 2006;
            if(obj instanceof CHAR)
                return 1;
            if(obj instanceof RAW)
                return -2;
            if(obj instanceof ARRAY)
                return 2003;
            if(obj instanceof STRUCT)
                return 2002;
            if(obj instanceof OPAQUE)
                return 2007;
            if(obj instanceof INTERVALYM)
                return -103;
        }
        return 1111;
    }

    public synchronized void clearParameters()
        throws SQLException
    {
        clear_params = true;
        if(binds_in != null)
            binds_in.clearItem(m_currentRank, false);
    }

    private void printByteArray(byte abyte0[])
    {
        if(abyte0 != null)
        {
            int j = abyte0.length;
            for(int i = 0; i < j; i++)
            {
                int k = abyte0[i] & 0xff;
                if(k >= 16);
            }

        }
    }

    public void setCharacterStream(int i, Reader reader, int j)
        throws SQLException
    {
        set_execute_batch(1);
        if(reader != null)
        {
            int k = i - 1;
            short word0 = 2;
            if(binds_in != null)
                word0 = binds_in.getFormOfUse(k);
            InputStream inputstream = connection.conversion.ConvertStream(reader, 7, j, word0);
            int l = min_ascii_stream_size / connection.db_access.getC2SNlsRatio() / connection.conversion.getMaxCharbyteSize();
            OracleConnection _tmp = connection;
            if(sql_kind == 1 || j <= l || !isRegularResultSet())
                try
                {
                    ByteArrayOutputStream bytearrayoutputstream = new ByteArrayOutputStream(1024);
                    byte abyte0[] = new byte[1024];
                    int i1;
                    while((i1 = inputstream.read(abyte0)) != -1) 
                        bytearrayoutputstream.write(abyte0, 0, i1);
                    setItem(k, 1, bytearrayoutputstream.toByteArray());
                    bytearrayoutputstream.close();
                }
                catch(IOException ioexception)
                {
                    DBError.throwSqlException(ioexception);
                }
            else
                setStreamItem(k, 8, inputstream, j * connection.conversion.getMaxCharbyteSize());
        } else
        {
            setString(i, null);
        }
    }

    public void setDate(int i, Date date, Calendar calendar)
        throws SQLException
    {
        setDATE(i, date != null ? new DATE(date, calendar) : null);
    }

    public void setTime(int i, Time time, Calendar calendar)
        throws SQLException
    {
        setDATE(i, time != null ? new DATE(time, calendar) : null);
    }

    public void setTimestamp(int i, Timestamp timestamp, Calendar calendar)
        throws SQLException
    {
        setDATE(i, timestamp != null ? new DATE(timestamp, calendar) : null);
    }

    public void setCheckBindTypes(boolean flag)
    {
        check_bind_types = flag;
    }

    protected final void setOracleBatchStyle()
        throws SQLException
    {
        if(m_batchStyle == 2)
            DBError.throwSqlException(90, "operation cannot be mixed with JDBC-2.0-style batching");
        else
        if(m_batchStyle != 0);
        m_batchStyle = 1;
    }

    protected final void setJdbcBatchStyle()
        throws SQLException
    {
        if(m_batchStyle == 1)
            DBError.throwSqlException(90, "operation cannot be mixed with Oracle-style batching");
        m_batchStyle = 2;
    }

    protected final void checkIfJdbcBatchExists()
        throws SQLException
    {
        if(doesJdbcBatchExist())
            DBError.throwSqlException(81, "batch must be either executed or cleared");
    }

    private boolean doesJdbcBatchExist()
    {
        return m_currentRank > 0 && m_batchStyle == 2;
    }

    private boolean isJdbcBatchStyle()
    {
        return m_batchStyle == 2;
    }

    public synchronized void addBatch()
        throws SQLException
    {
        setJdbcBatchStyle();
        binds_in.rowCompleted(-1);
        if(binds_in.hasStreamType())
            DBError.throwSqlException(90, "streams type cannot be used in batching");
        checkBindsInAndOut();
        m_currentRank++;
    }

    public synchronized void addBatch(String s)
        throws SQLException
    {
        DBError.throwSqlException(23);
    }

    public synchronized void clearBatch()
        throws SQLException
    {
        if(binds_in != null && binds_in.getNoOfArgs() > 0)
            binds_in.clearItems();
        m_currentRank = 0;
        clear_params = true;
    }

    public int[] executeBatch()
        throws SQLException
    {
label0:
        {
            int ai[];
            synchronized(connection)
            {
                synchronized(this)
                {
                    boolean flag = false;
                    setJdbcBatchStyle();
                    if(m_currentRank != 0)
                        break label0;
                    ai = new int[0];
                }
            }
            return ai;
        }
        int ai2[];
        int ai1[] = new int[m_currentRank];
        ensureOpen();
        prepare_for_new_result(true);
        if(sql_string_changed)
            parseSqlKind();
        if(sql_kind == 0)
            DBError.throwBatchUpdateException(80, 0, null);
        try
        {
            need_to_parse = true;
            doExecuteOther(true);
        }
        catch(SQLException sqlexception)
        {
            for(int i = 0; i < ai1.length; i++)
                ai1[i] = -3;

            DBError.throwBatchUpdateException(sqlexception, ai1.length, ai1);
        }
        finally
        {
            cleanupForBatching();
        }
        if(valid_rows < 0)
        {
            for(int j = 0; j < ai1.length; j++)
                ai1[j] = -3;

            DBError.throwBatchUpdateException(81, 0, ai1);
        }
        for(int k = 0; k < ai1.length; k++)
            ai1[k] = -2;

        ai2 = ai1;
        oraclepreparedstatement;
        JVM INSTR monitorexit ;
        oracleconnection;
        JVM INSTR monitorexit ;
        return ai2;
        exception1;
        throw exception1;
        exception2;
        throw exception2;
    }

    public DBDataSet getBinds()
    {
        return m_binds;
    }

    void scrollStmt_cleanup(boolean flag)
        throws SQLException
    {
        m_binds = null;
        super.scrollStmt_cleanup(flag);
    }

    private int doScrollPstmtExecuteUpdate()
        throws SQLException
    {
        scrollStmt_cleanup(false);
        parseSqlKind();
        if(sql_kind != 0)
        {
            prepare_for_new_result(true);
            get_data_for_columns(batch);
            doExecuteWithTimeout();
            return valid_rows;
        }
        boolean flag = true;
        String s = null;
        if(!m_needToAddIdentifier)
        {
            prepare_for_new_result(true);
            get_data_for_columns(batch);
            doExecuteWithTimeout();
            current_result_set = new OracleResultSetImpl(connection, this);
            m_realRsetType = m_userRsetType;
        } else
        {
            try
            {
                m_revisedSql = ResultSetUtil.addIdentifierToSql(m_originalSql);
                need_to_parse = true;
                sql_string_changed = true;
                prepare_for_new_result(true);
                sql_query = m_revisedSql;
                if(columns_defined_by_user)
                    adjustUserDefines(1);
                prepare_for_new_result(true);
                get_data_for_columns(batch);
                doExecuteWithTimeout();
                m_binds = binds_in;
                current_result_set = new OracleResultSetImpl(connection, this);
            }
            catch(SQLException sqlexception)
            {
                flag = false;
                s = sqlexception.getMessage();
                m_binds = binds_in;
            }
            if(flag)
            {
                m_realRsetType = m_userRsetType;
            } else
            {
                if(m_userRsetType > 3)
                    m_realRsetType = 3;
                else
                    m_realRsetType = 1;
                need_to_parse = true;
                sql_string_changed = true;
                prepare_for_new_result(true);
                sql_query = m_originalSql;
                if(columns_defined_by_user)
                    adjustUserDefines(-1);
                prepare_for_new_result(true);
                doExecuteWithTimeout();
                m_binds = binds_in;
                current_result_set = new OracleResultSetImpl(connection, this);
                flag = true;
            }
        }
        if(current_result_set == null || !flag)
        {
            DBError.check_error(1, "Unable to create result set");
        } else
        {
            if(m_userRsetType != m_realRsetType)
                m_warning = DBError.addSqlWarning(m_warning, 91, s);
            m_scrollRset = ResultSetUtil.createScrollResultSet(this, current_result_set, m_realRsetType);
        }
        m_scrollRsetTypeSolved = true;
        return valid_rows;
    }

    private void cleanup()
    {
        if(connection.m_stmtClearMetaData && binds_in != null)
            binds_in.cleanup();
        clear_params = true;
    }

    public synchronized void setDisableStmtCaching(boolean flag)
    {
        if(flag)
            cacheState = OracleStatement.NON_CACHED;
    }

    public synchronized void setFormOfUse(int i, short word0)
    {
        binds_in.setFormOfUse(i, word0);
    }

    public void setURL(int i, URL url)
        throws SQLException
    {
        DBError.throwUnsupportedFeatureSqlException();
    }

    public ParameterMetaData getParameterMetaData()
        throws SQLException
    {
        DBError.throwUnsupportedFeatureSqlException();
        return null;
    }

    public OracleParameterMetaData OracleGetParameterMetaData()
        throws SQLException
    {
        DBError.throwUnsupportedFeatureSqlException();
        return null;
    }

    private int min_binary_stream_size;
    private int min_ascii_stream_size;
    private int premature_batch_count;
    boolean check_bind_types;
    DBDataSet m_binds;
    boolean m_scrollRsetTypeSolved;
    boolean has_ref_cursors;
    protected static final int BSTYLE_UNKNOWN = 0;
    protected static final int BSTYLE_ORACLE = 1;
    protected static final int BSTYLE_JDBC = 2;
    protected int m_batchStyle;
}
