// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleResultSetImpl.java

package oracle.jdbc.driver;

import java.io.*;
import java.math.BigDecimal;
import java.sql.*;
import java.util.Calendar;
import java.util.Map;
import oracle.jdbc.dbaccess.DBAccess;
import oracle.jdbc.dbaccess.DBError;
import oracle.sql.*;

// Referenced classes of package oracle.jdbc.driver:
//            BaseResultSet, OracleResultSetMetaData, OracleStatement, OracleConnection, 
//            OracleInputStream

public class OracleResultSetImpl extends BaseResultSet
{

    OracleResultSetImpl(OracleConnection oracleconnection, OracleStatement oraclestatement)
        throws SQLException
    {
        connection = oracleconnection;
        statement = oraclestatement;
        close_statement_on_close = false;
        closed = false;
        explicitly_closed = false;
        m_emptyRset = false;
    }

    public synchronized void close()
        throws SQLException
    {
        internal_close();
        if(close_statement_on_close)
            try
            {
                statement.close();
            }
            catch(SQLException sqlexception) { }
        explicitly_closed = true;
    }

    public synchronized boolean wasNull()
        throws SQLException
    {
        return statement.wasNullValue();
    }

    public synchronized ResultSetMetaData getMetaData()
        throws SQLException
    {
        if(explicitly_closed)
            DBError.check_error(10, "getMetaData");
        if(statement.closed)
            DBError.check_error(9, "getMetaData");
        return new OracleResultSetMetaData(connection, statement);
    }

    public synchronized Statement getStatement()
        throws SQLException
    {
        return statement;
    }

    public synchronized boolean next()
        throws SQLException
    {
        if(explicitly_closed)
            DBError.check_error(10, "next");
        if(statement.connection == null || statement.connection.closed)
            DBError.check_error(8, "next");
        if(statement.closed)
            DBError.check_error(9, "next");
        if(closed)
            return false;
        statement.current_row++;
        statement.total_rows_visited++;
        if(statement.max_rows != 0 && statement.total_rows_visited > statement.max_rows)
        {
            internal_close();
            return false;
        }
        if(statement.current_row >= statement.valid_rows)
            try
            {
                if(statement.got_last_batch)
                {
                    internal_close();
                    return false;
                }
                statement.check_row_prefetch_changed();
                prepare_for_new_row();
                statement.connection.needLine();
                statement.valid_rows = connection.db_access.fetch(statement.dbstmt, statement.defines, statement.row_prefetch);
                statement.fetchedFirstColumns();
                if(statement.valid_rows == 0)
                {
                    internal_close();
                    return false;
                } else
                {
                    statement.current_row = 0;
                    statement.checkValidRowsStatus();
                    return true;
                }
            }
            catch(IOException ioexception)
            {
                DBError.check_error(ioexception);
            }
        return true;
    }

    public boolean isBeforeFirst()
        throws SQLException
    {
        return !isEmptyResultSet() && statement.current_row == -1 && !closed;
    }

    public boolean isAfterLast()
        throws SQLException
    {
        return !isEmptyResultSet() && closed;
    }

    public boolean isFirst()
        throws SQLException
    {
        return getRow() == 1;
    }

    public boolean isLast()
        throws SQLException
    {
        DBError.throwSqlException(75, "isLast");
        return false;
    }

    public int getRow()
        throws SQLException
    {
        return statement.total_rows_visited;
    }

    public synchronized String getString(int i)
        throws SQLException
    {
        return statement.getStringValue(true, i);
    }

    public synchronized boolean getBoolean(int i)
        throws SQLException
    {
        return statement.getBooleanValue(true, i);
    }

    public synchronized byte getByte(int i)
        throws SQLException
    {
        return statement.getByteValue(true, i);
    }

    public synchronized short getShort(int i)
        throws SQLException
    {
        return statement.getShortValue(true, i);
    }

    public synchronized int getInt(int i)
        throws SQLException
    {
        return statement.getIntValue(true, i);
    }

    public synchronized long getLong(int i)
        throws SQLException
    {
        return statement.getLongValue(true, i);
    }

    public synchronized float getFloat(int i)
        throws SQLException
    {
        return statement.getFloatValue(true, i);
    }

    public synchronized double getDouble(int i)
        throws SQLException
    {
        return statement.getDoubleValue(true, i);
    }

    public synchronized BigDecimal getBigDecimal(int i, int j)
        throws SQLException
    {
        return statement.getBigDecimalValue(true, i, j);
    }

    public synchronized byte[] getBytes(int i)
        throws SQLException
    {
        return statement.getBytesValue(true, i);
    }

    public synchronized Date getDate(int i)
        throws SQLException
    {
        return statement.getDateValue(true, i);
    }

    public synchronized Time getTime(int i)
        throws SQLException
    {
        return statement.getTimeValue(true, i);
    }

    public synchronized Timestamp getTimestamp(int i)
        throws SQLException
    {
        return statement.getTimestampValue(true, i);
    }

    public synchronized InputStream getAsciiStream(int i)
        throws SQLException
    {
        return statement.getAsciiStreamValue(true, i);
    }

    public synchronized InputStream getUnicodeStream(int i)
        throws SQLException
    {
        return statement.getUnicodeStreamValue(true, i);
    }

    public synchronized InputStream getBinaryStream(int i)
        throws SQLException
    {
        return statement.getBinaryStreamValue(true, i);
    }

    public synchronized Object getObject(int i)
        throws SQLException
    {
        return statement.getObjectValue(true, i);
    }

    public synchronized ResultSet getCursor(int i)
        throws SQLException
    {
        return statement.getCursorValue(true, i);
    }

    public synchronized Datum getOracleObject(int i)
        throws SQLException
    {
        return statement.getOracleObjectValue(true, i);
    }

    public synchronized ROWID getROWID(int i)
        throws SQLException
    {
        return statement.getROWIDValue(true, i);
    }

    public synchronized NUMBER getNUMBER(int i)
        throws SQLException
    {
        return statement.getNUMBERValue(true, i);
    }

    public synchronized DATE getDATE(int i)
        throws SQLException
    {
        return statement.getDATEValue(true, i);
    }

    public synchronized ARRAY getARRAY(int i)
        throws SQLException
    {
        return statement.getARRAYValue(true, i);
    }

    public synchronized STRUCT getSTRUCT(int i)
        throws SQLException
    {
        return statement.getSTRUCTValue(true, i);
    }

    public synchronized OPAQUE getOPAQUE(int i)
        throws SQLException
    {
        return statement.getOPAQUEValue(true, i);
    }

    public synchronized REF getREF(int i)
        throws SQLException
    {
        return statement.getREFValue(true, i);
    }

    public synchronized CHAR getCHAR(int i)
        throws SQLException
    {
        return statement.getCHARValue(true, i);
    }

    public synchronized RAW getRAW(int i)
        throws SQLException
    {
        return statement.getRAWValue(true, i);
    }

    public synchronized BLOB getBLOB(int i)
        throws SQLException
    {
        return statement.getBLOBValue(true, i);
    }

    public synchronized CLOB getCLOB(int i)
        throws SQLException
    {
        return statement.getCLOBValue(true, i);
    }

    public synchronized BFILE getBFILE(int i)
        throws SQLException
    {
        return statement.getBFILEValue(true, i);
    }

    public synchronized BFILE getBfile(int i)
        throws SQLException
    {
        return getBFILE(i);
    }

    public synchronized CustomDatum getCustomDatum(int i, CustomDatumFactory customdatumfactory)
        throws SQLException
    {
        return statement.getCustomDatumValue(true, i, customdatumfactory);
    }

    public synchronized ORAData getORAData(int i, ORADataFactory oradatafactory)
        throws SQLException
    {
        return statement.getORADataValue(true, i, oradatafactory);
    }

    public synchronized Object getObject(int i, Map map)
        throws SQLException
    {
        return statement.getObjectValue(true, i, map);
    }

    public synchronized Ref getRef(int i)
        throws SQLException
    {
        return getREF(i);
    }

    public synchronized Blob getBlob(int i)
        throws SQLException
    {
        return getBLOB(i);
    }

    public synchronized Clob getClob(int i)
        throws SQLException
    {
        return getCLOB(i);
    }

    public synchronized Array getArray(int i)
        throws SQLException
    {
        return getARRAY(i);
    }

    public synchronized Reader getCharacterStream(int i)
        throws SQLException
    {
        return statement.getCharacterStreamValue(true, i);
    }

    public BigDecimal getBigDecimal(int i)
        throws SQLException
    {
        return statement.getBigDecimalValue(true, i, 0);
    }

    public Date getDate(int i, Calendar calendar)
        throws SQLException
    {
        return statement.getDateValue(true, i, calendar);
    }

    public Time getTime(int i, Calendar calendar)
        throws SQLException
    {
        return statement.getTimeValue(true, i, calendar);
    }

    public Timestamp getTimestamp(int i, Calendar calendar)
        throws SQLException
    {
        return statement.getTimestampValue(true, i, calendar);
    }

    public INTERVALYM getINTERVALYM(int i)
        throws SQLException
    {
        return statement.getINTERVALYMValue(true, i);
    }

    public TIMESTAMP getTIMESTAMP(int i)
        throws SQLException
    {
        return statement.getTIMESTAMPValue(true, i);
    }

    public TIMESTAMPTZ getTIMESTAMPTZ(int i)
        throws SQLException
    {
        return statement.getTIMESTAMPTZValue(true, i);
    }

    public TIMESTAMPLTZ getTIMESTAMPLTZ(int i)
        throws SQLException
    {
        return statement.getTIMESTAMPLTZValue(true, i);
    }

    public void setFetchSize(int i)
        throws SQLException
    {
        statement.setPrefetchInternal(i, false, false);
    }

    public int getFetchSize()
        throws SQLException
    {
        return statement.getPrefetchInternal(false);
    }

    void internal_close()
        throws SQLException
    {
        if(closed)
            return;
        closed = true;
        if(statement.got_last_batch && statement.valid_rows == 0)
            m_emptyRset = true;
        try
        {
            statement.connection.needLine();
            statement.connection.db_access.closeQuery(statement.dbstmt);
        }
        catch(IOException ioexception)
        {
            DBError.throwSqlException(ioexception);
        }
        catch(SQLException sqlexception) { }
        statement.end_of_result_set();
    }

    void prepare_for_new_row()
        throws SQLException
    {
        if(statement.streams != null)
            try
            {
                statement.streams.close();
            }
            catch(IOException ioexception)
            {
                DBError.check_error(ioexception);
            }
        clearWarnings();
    }

    public synchronized int findColumn(String s)
        throws SQLException
    {
        return statement.get_column_index(s);
    }

    boolean isEmptyResultSet()
    {
        return m_emptyRset || !m_emptyRset && statement.got_last_batch && statement.valid_rows == 0;
    }

    int getValidRows()
    {
        return statement.valid_rows;
    }

    OracleConnection connection;
    OracleStatement statement;
    boolean closed;
    boolean explicitly_closed;
    private boolean m_emptyRset;
}
