// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   SensitiveScrollableResultSet.java

package oracle.jdbc.driver;

import java.sql.SQLException;
import oracle.jdbc.dbaccess.DBError;

// Referenced classes of package oracle.jdbc.driver:
//            ScrollableResultSet, OracleResultSetImpl, ScrollRsetStatement

public class SensitiveScrollableResultSet extends ScrollableResultSet
{

    public SensitiveScrollableResultSet(ScrollRsetStatement scrollrsetstatement, OracleResultSetImpl oracleresultsetimpl, int i, int j)
        throws SQLException
    {
        super(scrollrsetstatement, oracleresultsetimpl, i, j);
        int k = oracleresultsetimpl.getValidRows();
        if(k > 0)
        {
            m_beginLastFetchedIdx = 1;
            m_endLastFetchedIdx = k;
        } else
        {
            m_beginLastFetchedIdx = 0;
            m_endLastFetchedIdx = 0;
        }
    }

    public synchronized boolean next()
        throws SQLException
    {
        if(super.next())
        {
            handle_refetch();
            return true;
        } else
        {
            return false;
        }
    }

    public synchronized boolean first()
        throws SQLException
    {
        if(super.first())
        {
            handle_refetch();
            return true;
        } else
        {
            return false;
        }
    }

    public synchronized boolean last()
        throws SQLException
    {
        if(super.last())
        {
            handle_refetch();
            return true;
        } else
        {
            return false;
        }
    }

    public synchronized boolean absolute(int i)
        throws SQLException
    {
        if(super.absolute(i))
        {
            handle_refetch();
            return true;
        } else
        {
            return false;
        }
    }

    public synchronized boolean relative(int i)
        throws SQLException
    {
        if(super.relative(i))
        {
            handle_refetch();
            return true;
        } else
        {
            return false;
        }
    }

    public synchronized boolean previous()
        throws SQLException
    {
        if(super.previous())
        {
            handle_refetch();
            return true;
        } else
        {
            return false;
        }
    }

    public synchronized void refreshRow()
        throws SQLException
    {
        if(!isValidRow(m_currentRow))
            DBError.throwSqlException(11);
        int i = getFetchDirection();
        int j = 0;
        try
        {
            j = refreshRowsInCache(m_currentRow, getFetchSize(), i);
        }
        catch(SQLException sqlexception)
        {
            DBError.throwSqlException(sqlexception, 90, "Unsupported syntax for refreshRow()");
        }
        if(j != 0)
        {
            m_beginLastFetchedIdx = m_currentRow;
            m_endLastFetchedIdx = (m_currentRow + j) - 1;
        }
    }

    synchronized int removeRowInCache(int i)
        throws SQLException
    {
        int j = super.removeRowInCache(i);
        if(j != 0)
            if(i >= m_beginLastFetchedIdx && i <= m_endLastFetchedIdx && m_beginLastFetchedIdx != m_endLastFetchedIdx)
                m_endLastFetchedIdx--;
            else
                m_beginLastFetchedIdx = m_endLastFetchedIdx = 0;
        return j;
    }

    private boolean handle_refetch()
        throws SQLException
    {
        if(m_currentRow >= m_beginLastFetchedIdx && m_currentRow <= m_endLastFetchedIdx || m_currentRow >= m_endLastFetchedIdx && m_currentRow <= m_beginLastFetchedIdx)
        {
            return false;
        } else
        {
            refreshRow();
            return true;
        }
    }

    public static boolean DEBUG = false;
    private int m_beginLastFetchedIdx;
    private int m_endLastFetchedIdx;

}
