// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleXAException.java

package oracle.jdbc.xa;

import javax.transaction.xa.XAException;

public class OracleXAException extends XAException
{

    public OracleXAException()
    {
        xa_error = 0;
        primary = 0;
        secondary = 0;
    }

    public OracleXAException(int i)
    {
        super(errorConvert(i));
        xa_error = 0;
        primary = 0;
        secondary = 0;
        xa_error = errorConvert(i);
        primary = i & 0xffff;
        secondary = i >> 16;
    }

    public static int errorConvert(int i)
    {
        switch(i & 0xffff)
        {
        case 24756: 
            return -4;

        case 25351: 
            return 4;

        case 24764: 
            return 7;

        case 24765: 
            return 6;

        case 24766: 
            return 5;

        case 24767: 
            return 3;

        case 3113: 
        case 3114: 
            return -7;

        case 24763: 
        case 24769: 
        case 24770: 
            return -6;
        }
        return -3;
    }

    public int getXAError()
    {
        return xa_error;
    }

    public int getOracleError()
    {
        return primary;
    }

    public int getOracleSQLError()
    {
        return secondary;
    }

    public static String getXAErrorMessage(int i)
    {
        switch(i)
        {
        case 7: // '\007'
            return "The transaction branch has been heuristically committed.";

        case 8: // '\b'
            return "The transaction branch may have been heuristically completed.";

        case 5: // '\005'
            return "The transaction branch has been heuristically committed and rolled back.";

        case 6: // '\006'
            return "The transaction branch has been heuristically rolled back.";

        case 9: // '\t'
            return "Resumption must occur where suspension occured.";

        case 100: // 'd'
            return "The inclusive lower bound oof the rollback codes.";

        case 101: // 'e'
            return "Rollback was caused by communication failure.";

        case 102: // 'f'
            return "A deadlock was detected.";

        case 107: // 'k'
            return "The inclusive upper bound of the rollback error code.";

        case 103: // 'g'
            return "A condition that violates the integrity of the resource was detected.";

        case 104: // 'h'
            return "The resource manager rolled back the transaction branch for a reason not on this list.";

        case 105: // 'i'
            return "A protocol error occured in the resource manager.";

        case 106: // 'j'
            return "A transaction branch took too long.";

        case 3: // '\003'
            return "The transaction branch has been read-only and has been committed.";

        case 4: // '\004'
            return "Routine returned with no effect and may be reissued.";

        case -2: 
            return "Asynchronous operation already outstanding.";

        case -8: 
            return "The XID already exists.";

        case -5: 
            return "Invalid arguments were given.";

        case -4: 
            return "The XID is not valid.";

        case -9: 
            return "The resource manager is doing work outside global transaction.";

        case -6: 
            return "Routine was invoked in an inproper context.";

        case -3: 
            return "A resource manager error has occured in the transaction branch.";

        case -7: 
            return "Resource manager is unavailable.";
        }
        return "Internal XA Error";
    }

    private int xa_error;
    private int primary;
    private int secondary;
}
