// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   TypeDescriptor.java

package oracle.sql;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.sql.Connection;
import java.sql.SQLException;
import oracle.jdbc.dbaccess.DBAccess;
import oracle.jdbc.dbaccess.DBError;
import oracle.jdbc.driver.OracleConnection;
import oracle.jdbc.oracore.OracleNamedType;
import oracle.jdbc.oracore.OracleTypeADT;
import oracle.jdbc.oracore.OracleTypeCOLLECTION;
import oracle.jdbc.oracore.OracleTypeOPAQUE;

// Referenced classes of package oracle.sql:
//            SQLName, StructDescriptor, ArrayDescriptor, OpaqueDescriptor

public abstract class TypeDescriptor
    implements Serializable
{

    protected TypeDescriptor()
    {
    }

    protected TypeDescriptor(String s, Connection connection)
        throws SQLException
    {
        if(s == null || connection == null)
            DBError.check_error(60, "Invalid arguments");
        setPhysicalConnectionOf(connection);
        m_sqlName = new SQLName(s, getInternalConnection());
    }

    protected TypeDescriptor(SQLName sqlname, Connection connection)
        throws SQLException
    {
        if(sqlname == null || connection == null)
            DBError.check_error(60, "Invalid arguments");
        m_sqlName = sqlname;
        setPhysicalConnectionOf(connection);
    }

    protected TypeDescriptor(SQLName sqlname, OracleTypeADT oracletypeadt, Connection connection)
        throws SQLException
    {
        if(sqlname == null || oracletypeadt == null || connection == null)
            DBError.check_error(60, "Invalid arguments");
        m_sqlName = sqlname;
        setPhysicalConnectionOf(connection);
        m_pickler = oracletypeadt;
        m_pickler.setDescriptor(this);
    }

    protected TypeDescriptor(OracleTypeADT oracletypeadt, Connection connection)
        throws SQLException
    {
        if(oracletypeadt == null || connection == null)
            DBError.check_error(60, "Invalid arguments");
        setPhysicalConnectionOf(connection);
        m_sqlName = null;
        m_pickler = oracletypeadt;
        m_pickler.setDescriptor(this);
    }

    public synchronized String getName()
        throws SQLException
    {
        if(m_sqlName == null)
            initSQLName();
        String s = m_sqlName.getName();
        return s;
    }

    public synchronized SQLName getSQLName()
        throws SQLException
    {
        if(m_sqlName == null)
            initSQLName();
        return m_sqlName;
    }

    void initSQLName()
        throws SQLException
    {
        if(m_pickler == null || getInternalConnection() == null)
            DBError.throwSqlException(1);
        m_sqlName = new SQLName(m_pickler.getFullName(), getInternalConnection());
    }

    public String getSchemaName()
        throws SQLException
    {
        String s = getSQLName().getSchema();
        return s;
    }

    public String getTypeName()
        throws SQLException
    {
        String s = getSQLName().getSimpleName();
        return s;
    }

    public OracleNamedType getPickler()
    {
        return m_pickler;
    }

    public oracle.jdbc.internal.OracleConnection getInternalConnection()
    {
        return m_conn;
    }

    public void setPhysicalConnectionOf(Connection connection)
    {
        m_conn = OracleConnection.physicalConnectionWithin(connection);
    }

    public abstract int getTypeCode()
        throws SQLException;

    public static TypeDescriptor getTypeDescriptor(String s, oracle.jdbc.OracleConnection oracleconnection)
        throws SQLException
    {
        Object obj = null;
        try
        {
            SQLName sqlname = new SQLName(s, oracleconnection);
            String s1 = sqlname.getName();
            obj = (TypeDescriptor)oracleconnection.getDescriptor(s1);
            if(obj == null)
            {
                OracleTypeADT oracletypeadt = new OracleTypeADT(s1, oracleconnection);
                ((OracleConnection)oracleconnection).db_access.getOracleTypeADT(oracletypeadt);
                oracletypeadt.init((OracleConnection)oracleconnection);
                OracleNamedType oraclenamedtype = oracletypeadt.cleanup();
                switch(oraclenamedtype.getTypeCode())
                {
                case 2002: 
                case 2008: 
                    obj = new StructDescriptor(sqlname, (OracleTypeADT)oraclenamedtype, oracleconnection);
                    break;

                case 2003: 
                    obj = new ArrayDescriptor(sqlname, (OracleTypeCOLLECTION)oraclenamedtype, oracleconnection);
                    break;

                case 2007: 
                    obj = new OpaqueDescriptor(sqlname, (OracleTypeOPAQUE)oraclenamedtype, oracleconnection);
                    break;

                case 2004: 
                case 2005: 
                case 2006: 
                default:
                    DBError.throwSqlException(1);
                    break;
                }
                oracleconnection.putDescriptor(s1, obj);
                oraclenamedtype.setDescriptor(((TypeDescriptor) (obj)));
            }
        }
        catch(Exception exception)
        {
            if(exception instanceof SQLException)
                DBError.throwSqlException((SQLException)exception, 60, "Unable to resolve type \"" + s + "\"");
            else
                DBError.throwSqlException(60, "Unable to resolve type \"" + s + "\"");
        }
        return ((TypeDescriptor) (obj));
    }

    public static TypeDescriptor getTypeDescriptor(String s, oracle.jdbc.OracleConnection oracleconnection, byte abyte0[], long l)
        throws SQLException
    {
        Object obj = null;
        byte abyte1[][] = new byte[1][];
        String s1 = getSubtypeName(oracleconnection, abyte0, l);
        if(s1 == null)
            s1 = s;
        obj = (TypeDescriptor)oracleconnection.getDescriptor(s1);
        if(obj == null)
        {
            SQLName sqlname = new SQLName(s1, oracleconnection);
            OracleTypeADT oracletypeadt = new OracleTypeADT(s1, oracleconnection);
            ((OracleConnection)oracleconnection).db_access.getOracleTypeADT(oracletypeadt);
            oracletypeadt.init((OracleConnection)oracleconnection);
            OracleNamedType oraclenamedtype = oracletypeadt.cleanup();
            switch(oraclenamedtype.getTypeCode())
            {
            case 2002: 
            case 2008: 
                obj = new StructDescriptor(sqlname, (OracleTypeADT)oraclenamedtype, oracleconnection);
                break;

            case 2003: 
                obj = new ArrayDescriptor(sqlname, (OracleTypeCOLLECTION)oraclenamedtype, oracleconnection);
                break;

            case 2007: 
                obj = new OpaqueDescriptor(sqlname, (OracleTypeOPAQUE)oraclenamedtype, oracleconnection);
                break;

            case 2004: 
            case 2005: 
            case 2006: 
            default:
                DBError.throwSqlException(1);
                break;
            }
            oracleconnection.putDescriptor(s1, obj);
        }
        return ((TypeDescriptor) (obj));
    }

    public boolean isInHierarchyOf(String s)
        throws SQLException
    {
        return false;
    }

    private void writeObject(ObjectOutputStream objectoutputstream)
        throws IOException
    {
        try
        {
            if(m_sqlName == null)
                initSQLName();
        }
        catch(SQLException sqlexception)
        {
            DBError.SQLToIOException(sqlexception);
        }
        objectoutputstream.writeObject(m_sqlName);
        objectoutputstream.writeObject(m_pickler);
    }

    private void readObject(ObjectInputStream objectinputstream)
        throws IOException, ClassNotFoundException
    {
        m_sqlName = (SQLName)objectinputstream.readObject();
        m_pickler = (OracleNamedType)objectinputstream.readObject();
    }

    public void setConnection(Connection connection)
        throws SQLException
    {
        setPhysicalConnectionOf(connection);
        m_pickler.setConnection(getInternalConnection());
    }

    public static String getSubtypeName(oracle.jdbc.OracleConnection oracleconnection, byte abyte0[], long l)
        throws SQLException
    {
        if(abyte0 == null || abyte0.length == 0 || oracleconnection == null)
            DBError.throwSqlException(68);
        String s = OracleTypeADT.getSubtypeName(oracleconnection, abyte0, l);
        return s;
    }

    public static boolean DEBUG_SERIALIZATION = false;
    static final long serialVersionUID = 0x1c11b6d24ed1cf6bL;
    SQLName m_sqlName;
    OracleNamedType m_pickler;
    transient oracle.jdbc.internal.OracleConnection m_conn;

}
